<?php
/*
   TM Offline Stats v0.62a
   Copyright (c) 2006 Alexander Domnin

   This program is licenced under the Creative Commons Attribution-NonCommercial-NoDerivs 2.5
   To view a copy of this licence, visit http://creativecommons.org/licenses/by-nc-nd/2.5/

   This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
   without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

function get_linkstr($text, $action, $stats, $sid, $pid, $tid, $query ="*", $sort = "", $dir = "", $page = 1) {
   $link = "<a href=\"{$_SERVER['PHP_SELF']}?";
   $link .= "action=$action";
   $link .= "&stats=$stats";
   if ($sid != -1)
      $link .= "&sid=$sid";
   if ($pid != -1)
      $link .= "&pid=$pid";
   if ($tid != -1)
      $link .= "&tid=$tid";
   if ($query != "*")
      $link .= "&query=$query";
   if ($sort != "" && $sort != "default")
      $link .= "&sort=$sort";
   if ($dir != "" && $dir != "default")
      $link .= "&dir=$dir";
   if ($page != 1)
      $link .= "&page=$page";
   $link .= "\">$text</a>";

   return $link;
}

function get_pagesstr($it_pages, $view) {
   $pages = "$it_pages";
   if ($view['totalpages'] <= 11) {
      for ($i = 1; $i <= $view['totalpages']; $i++) {
         if ($i == $view['page'])
            $pages .= " |<b>$i</b>|";
         else
            $pages .= get_linkstr(" $i", $view['action'], $view['stats'], $view['sid'], $view['pid'], $view['tid'], $view['query'], $view['sort'], $view['dir'], $i);
      }
   }
   else if ($view['page'] < 7) {
      for ($i = 1; $i <= 10; $i++) {
         if ($i == $view['page'])
            $pages .= " |<b>$i</b>|";
         else
            $pages .= get_linkstr(" $i", $view['action'], $view['stats'], $view['sid'], $view['pid'], $view['tid'], $view['query'], $view['sort'], $view['dir'], $i);
      }
      $pages .= " .. ".get_linkstr(" {$view['totalpages']}", $view['action'], $view['stats'], $view['sid'], $view['pid'], $view['tid'], $view['query'], $view['sort'], $view['dir'], $view['totalpages']);
   }
   else if ($view['page'] > $view['totalpages'] - 6) {
      $pages .= get_linkstr(" 1", $view['action'], $view['stats'], $view['sid'], $view['pid'], $view['tid'], $view['query'], $view['sort'], $view['dir'], 1)." ..";
      for ($i = $view['totalpages'] - 9; $i <= $view['totalpages']; $i++) {
         if ($i == $view['page'])
            $pages .= " |<b>$i</b>|";
         else
            $pages .= get_linkstr(" $i", $view['action'], $view['stats'], $view['sid'], $view['pid'], $view['tid'], $view['query'], $view['sort'], $view['dir'], $i);
      }
   }
   else {
      $pages .= get_linkstr(" 1", $view['action'], $view['stats'], $view['sid'], $view['pid'], $view['tid'], $view['query'], $view['sort'], $view['dir'], 1)." ..";
      for ($i = $view['page'] - 4; $i <= $view['page'] + 4; $i++) {
         if ($i == $view['page'])
            $pages .= " |<b>$i</b>|";
         else
            $pages .= get_linkstr(" $i", $view['action'], $view['stats'], $view['sid'], $view['pid'], $view['tid'], $view['query'], $view['sort'], $view['dir'], $i);
      }
      $pages .= " .. ".get_linkstr(" {$view['totalpages']}", $view['action'], $view['stats'], $view['sid'], $view['pid'], $view['tid'], $view['query'], $view['sort'], $view['dir'], $view['totalpages']);
   }

   return $pages;
}

function get_tabs_content($it, $view, $inf) {
   if (!$view['showtabs']) return "";

   $tab_curr = get_linkstr($it['tab_lastxdays'], $view['action'], "c", $view['sid'], $view['pid'], $view['tid'], $view['query'], $view['sort'], $view['dir'], 1);
   $tab_all = get_linkstr($it['tab_alltime'], $view['action'], "a", $view['sid'], $view['pid'], $view['tid'], $view['query'], $view['sort'], $view['dir'], 1);
   if ($view['stats'] == "a") {
      $tab_curr_style = "tab";
      $tab_all_style = "taba";
   }
   else {
      $tab_curr_style = "taba";
      $tab_all_style = "tab";
   }
$content = <<<EOD
<table cols="4" class="tabs">
   <td width="10" class="tabl">&nbsp;</td>
   <td width="150" class="$tab_curr_style">$tab_curr</td>
   <td width="150" class="$tab_all_style">$tab_all</td>
   <td class="tabr">{$inf['prev_date']}{$it['tab_dateseparator']}{$inf['curr_date']}</td>
</table>\r\n
EOD;
   return $content;
}

function get_servlist_content($cfg, $it, $view, $data) {
$content = <<<EOD
<table cols="5" class="data">
<tr><th class="infhdr" colspan="5">{$it['sl_header']}</th></tr>\r\n
EOD;
$c_tnstr = <<<EOD
<tr><td class="bl">-</td><td class="b">-</td><td class="b">-</td><td class="b">-</td><td class="br">-</td></tr>\r\n
EOD;
$c_tstr = <<<EOD
<tr\$cd_javascript><td class=\"l\">\$cd_server</td><td width=\"100\">\$cd_game</td><td width=\"200\">\$cd_track</td><td width=\"100\">\$cd_players</td><td class=\"r\" width=\"100\">\$cd_status</td></tr>\r\n
EOD;
$c_pages = <<<EOD
<tr><td class="blr" colspan="5">&nbsp;</td></tr>
EOD;
   if ($cfg['javascript'])
      $cd_javascript = ' onMouseOver="mi(this)" onMouseOut="mo(this)"';
   else
      $cd_javascript = "";

   if (count($data) == 0)
      $content .= $c_tnstr;
   else {
      foreach ($data as $serverid=>$info) {
         if ($info['status'] != 0) {
            $cd_server = get_linkstr(name_html($info['server']), "players", $view['stats'], $serverid, -1, -1);
            $cd_game = $info['game'];
            $cd_track = "-";
            $cd_players = "-";
            $cd_status = $it['sl_offline'];
         }
         else {
            $cd_server = get_linkstr(name_html($info['server']), "monitoring", $view['stats'], $serverid, -1, -1);
            $cd_game = $info['game'];
            $cd_track = name_html($info['track']['track']);
            $cd_players = $info['playerscurr']." / ".$info['playersmax'];
            $cd_status = $it['sl_online'];
         }
         eval("\$content .= \"$c_tstr\";");
      }
      $content .= $c_pages;
   }
$content .= <<<EOD
</table>\r\n
EOD;
   return $content;
}

function get_monitoring_content($cfg, $it, $view, $data) {
   // server
   $server_name = name_html($data['server']);
   // track
   $track_name = name_html($data['track']['track']);
   $track_author = name_html($data['track']['author']);
   $track_authortime = time_msectofull($data['track']['authortime']);
   if ($data['gamemode'] == "Rounds" &&  $data['track']['trackid'] != -1 && $data['track']['laps'])
      $track_nblaps = $data['track']['nblaps_t'];
   else if ($data['track']['laps'])
      $track_nblaps = $data['nblaps_s'];
   else
      $track_nblaps = '-';
   if ($data['track']['trackid'] != -1) {
      $track_name = get_linkstr($track_name, "track", $view['stats'], $view['sid'], -1, $data['track']['trackid']);
      if ($data['track']['nblaps_t'] > 1) $track_authortime = "$track_authortime / {$data['track']['nblaps_t']}";
   }
   if ($data['track']['trackid'] != -1 && $data['track']['bestplayerid'] != -1)
      $best_time = "{$data['track']['besttime']} (".get_linkstr(name_html($data['track']['bestplayer']), "player", $view['stats'], $view['sid'], $data['track']['bestplayerid'], -1).")";
   else
      $best_time = "-";
   if (file_exists("./gfx/tracks/{$data['track']['uid']}.jpg")) $track_screen = "./gfx/tracks/{$data['track']['uid']}.jpg";
   else {
      switch ($data['game']) {
      case "Original" : $track_screen = "gfx/track_original.jpg"; break;
      case "Sunrise" : $track_screen = "gfx/track_sunrise.jpg"; break;
      case "Nations" : $track_screen = "gfx/track_nations.jpg"; break;
      default : $track_screen = "gfx/track_united.jpg"; break;
      }
   }
$content = <<<EOD
<table cols="3" class="data">
   <tr><th colspan="3" class="infhdr">$server_name &raquo; {$it['mon_header']}</th></tr>
   <tr><td class="l" width="160">{$it['mon_game']}</td><td class="r" colspan="2">{$data['game']}</td></tr>
   <tr><td class="l">{$it['mon_gamemode']}</td><td class="r" colspan="2">{$data['gamemode']}</td></tr>
   <tr><td class="l">{$it['mon_players']}</td><td class="r" colspan="2">{$data['playerscurr']} / {$data['playersmax']}</td></tr>
   <tr><td class="l">{$it['mon_spectators']}</td><td class="r" colspan="2">{$data['spectatorscurr']} / {$data['spectatorsmax']}</td></tr>
   <tr><td class="l">{$it['mon_tracks']}</td><td class="r" colspan="2">{$data['challengetotal']}</td></tr>
   <tr><th class="lr" colspan="3">{$it['mon_trackheader']}</th></tr>
   <tr>
      <td class="l">{$it['mon_trackcurr']}</td><td>$track_name</td>
      <td width="160" rowspan="6" class="infpict2"><img class="infpict" src="$track_screen"></td>
   </tr>
   <tr><td class="l" width="200">{$it['mon_trackenvir']}</td><td>{$data['track']['envir']}</td></tr>
   <tr><td class="l">{$it['mon_trackauthor']}</td><td>$track_author</td></tr>
   <tr><td class="l">{$it['mon_tracklaps']}</td><td>$track_nblaps</td></tr>
   <tr><td class="l">{$it['mon_trackauthortime']}</td><td>$track_authortime</td></tr>
   <tr><td class="bl">{$it['mon_trackbesttime']}</td><td class="b">$best_time</td></tr>
</table>
<div class="splitter">&nbsp;</div>\r\n
EOD;

$c_thdr = <<<EOD
<table cols=\"\$total_columns\" class=\"data\">
<tr><th width=\"60\">\$ch_num</th><th>\$ch_player</th>\$ch_lapsfinished<th width=\"150\">\$ch_besttime</th></tr>\r\n
EOD;

$c_tnstr = <<<EOD
<tr><td class=\"bl\">-</td><td class=\"b\">-</td>\$cdn_lapsfinished<td class=\"br\">-</td></tr>\r\n
EOD;

$c_tstr = <<<EOD
<tr\$cd_javascript><td class=\"l\">\$cd_num</td><td>\$cd_player</td>\$cd_lapsfinished<td class=\"arr\">\$cd_besttime</td>\r\n
EOD;

$c_pages = <<<EOD
<tr><td colspan=\"\$total_columns\" class=\"blr\">&nbsp</td></tr>\r\n
EOD;

   $ch_num = $it['mon_playernum'];
   $ch_player = $it['mon_playername'];
   $ch_besttime = $it['mon_playerbesttime'];
   if ($data['gamemode'] == "Laps" && $data['track']['laps']) {
      $total_columns = 4;
      $ch_lapsfinished = "<th width=\"150\">{$it['mon_playerlapsfinished']}</th>";
      $cdn_lapsfinished = "<td class=\"b\">-</td>";
      $c_lapsfinished = '<td>{$data[\'players\'][$i][\'lapsfinished\']}</td>';
   }
   else {
      $total_columns = 3;
      $ch_lapsfinished = "";
      $cdn_lapsfinished = "";
      $c_lapsfinished = "";
   }

   eval("\$content .= \"$c_thdr\";");

   if ($cfg['javascript'])
      $cd_javascript = ' onMouseOver="mi(this)" onMouseOut="mo(this)"';
   else
      $cd_javascript = "";

   if ($data['players']['count'] == 0)
      eval("\$content .= \"$c_tnstr\";");
   else {
      for ($i = 0; $i < $data['players']['count']; $i++) {
         $cd_num = $i+1;
         $cd_player = name_html($data['players'][$i]['player']);
         if ($data['players'][$i]['playerid'] != -1)
            $cd_player = get_linkstr($cd_player, "player", $view['stats'], $view['sid'], $data['players'][$i]['playerid'], -1);
         if ($data['players'][$i]['besttime'] != 999999999)
            $cd_besttime = time_msectocut($data['players'][$i]['besttime']);
         else
            $cd_besttime = "-";
         eval("\$cd_lapsfinished = \"$c_lapsfinished\";");
         eval("\$content .= \"$c_tstr\";");
      }
      eval("\$content .= \"$c_pages\";");
   }
$content .= <<<EOD
</table>\r\n
EOD;
   return $content;
}

function get_players_content($cfg, $it, $view, $inf, $data) {

   $server_name = name_html($inf['servername']);
   $pages = get_pagesstr($it['mnu_pages'], $view);
   switch ($inf['servergame']) {
   case "Original" : $players_pict = "gfx/players_original.jpg"; break;
   case "Sunrise" : $players_pict = "gfx/players_sunrise.jpg"; break;
   case "Nations" : $players_pict = "gfx/players_nations.jpg"; break;
   default : $players_pict = "gfx/players_united.jpg"; break;
   }

$content = <<<EOD
<table cols="2" class="inf">
   <tr><th colspan="2" class="infhdr">$server_name &raquo; {$it['pl_header']}</th></tr>
   <tr><td class="infpict"><img src="$players_pict" class="infpict"></td><td class="infdata">
   <table cols="3" class="infdata">
      <tr><td width="150">{$it['pl_lastupdate']}</td><td>{$inf['lastupdate']}</td><td width="100" rowspan="6">
         <form action="{$_SERVER['PHP_SELF']}" method="get">
         <input type="hidden" name="action" value="{$view['action']}">
         <input type="hidden" name="stats" value="{$view['stats']}">
         <input type="hidden" name="sid" value="{$view['sid']}">
         <input type="hidden" name="sort" value="{$view['sort']}">
         <input type="hidden" name="dir" value="{$view['dir']}">
         <input type="hidden" name="page" value="1">
         {$it['pl_findplayer']}<p class="splitter">
         <input type="text" name="query" value="{$view['query']}" class="txt"><p class="splitter"><p>
         <input type="submit" value="{$it['pl_findplayer_btn']}" class="btn">
         </form>
      </td></tr>
      <tr><td>{$it['pl_totalplayers']}</td><td>{$inf['totalplayers']}</td></tr>
      <tr><td>{$it['pl_totalawards']}</td><td>{$inf['totalawards']}</td></tr>
      <tr><td>&nbsp</td><td>&nbsp</td></tr>
      <tr><td>&nbsp</td><td>&nbsp</td></tr>
      <tr><td>&nbsp</td><td>&nbsp</td></tr>
      </table>
   </td></tr>
</table>
<div class="splitter">&nbsp;</div>\r\n
EOD;

$c_thdr = <<<EOD
<table cols=\"4\" class=\"data\">
<tr><th width=\"50\">\$ch_num</th><th nowrap>\$ch_player</th><th width=\"100\" nowrap>\$ch_score</th><th width=\"100\" nowrap>\$ch_awards</th></tr>\r\n
EOD;

$c_tnstr = <<<EOD
<tr><td class=\"bl\">-</td><td class=\"b\">-</td><td class=\"b\">-</td><td class=\"br\">-</td></tr>\r\n
EOD;

$c_tstr = <<<EOD
<tr\$cd_javascript><td class=\"l\">\$cd_num</td><td>\$cd_player</td><td>\$cd_score</td><td class=\"r\">\$cd_awards</td></tr>\r\n
EOD;

$c_pages = <<<EOD
<tr><td class=\"pages\" colspan=\"4\">\$pages</td></tr>\r\n
EOD;

   $ch_num = $it['pl_num'];
   $sort_img = "<img src=\"gfx/sort".($view['sort'] == "playerc" ? "a" : "").".gif\" class=\"sort\">";
   $ch_player = "{$it['pl_player']}&nbsp;".get_linkstr($sort_img, "players", $view['stats'], $view['sid'], -1, -1, $view['query'], "playerc", "asc");
   $sort_img = "<img src=\"gfx/sort".($view['sort'] == "score" ? "a" : "").".gif\" class=\"sort\">";
   $ch_score = "{$it['pl_score']}&nbsp;".get_linkstr($sort_img, "players", $view['stats'], $view['sid'], -1, -1, $view['query'], "score", "desc");
   $sort_img = "<img src=\"gfx/sort".($view['sort'] == "awards" ? "a" : "").".gif\" class=\"sort\">";
   $ch_awards = "{$it['pl_awards']}&nbsp;".get_linkstr($sort_img, "players", $view['stats'], $view['sid'], -1, -1, $view['query'], "awards", "desc");
   eval("\$content .= \"$c_thdr\";");

   if ($cfg['javascript'])
      $cd_javascript = ' onMouseOver="mi(this)" onMouseOut="mo(this)"';
   else
      $cd_javascript = "";
   if (!$data || $data['count'] == 0)
      eval("\$content .= \"$c_tnstr\";");
   else {
      for ($i = 0; $i < $data['count']; $i++) {
         $cd_num = ($view['page']-1)*$cfg['recperpage'] + $i + 1;
         $cd_player = get_linkstr(name_html($data[$i]['player']), "player", $view['stats'], $view['sid'], $data[$i]['playerid'], -1);
         $cd_score = $data[$i]['score'];
         $cd_awards = $data[$i]['awards'];
         eval("\$content .= \"$c_tstr\";");
      }
      eval("\$content .= \"$c_pages\";");
   }

$content .= <<<EOD
</table>\r\n
EOD;

   return $content;
}

function get_player_content($cfg, $it, $view, $inf, $data) {

   $server_name = name_html($inf['servername']);
   $player_name = name_html($inf['player']);
   $pages = get_pagesstr($it['mnu_pages'], $view);
   if (file_exists("gfx/avatars/{$inf['account']}.jpg"))
      $player_avatar = "gfx/avatars/{$inf['account']}.jpg";
   else if (file_exists("gfx/avatars/{$inf['account']}.gif"))
      $player_avatar = "gfx/avatars/{$inf['account']}.gif";
   else if (file_exists("gfx/avatars/{$inf['account']}.png"))
      $player_avatar = "gfx/avatars/{$inf['account']}.png";
   else {
      switch ($inf['servergame']) {
      case "Original" : $player_avatar = "gfx/player_original.jpg"; break;
      case "Sunrise" : $player_avatar = "gfx/player_sunrise.jpg"; break;
      case "Nations" : $player_avatar = "gfx/player_nations.jpg"; break;
      default : $player_avatar = "gfx/player_united.jpg"; break;
      }
   }
   if ($view['showuserbars'])
      $player_userbar = get_linkstr("<img src=\"gfx/gub.gif\" class=\"ubbtn\">", "userbar", $view['stats'], $view['sid'], $view['pid'], -1);
   else
      $player_userbar = "&nbsp;";
   
   for ($aliases_count = 0; $aliases_count < 6; $aliases_count++) 
      $player_aliases[$aliases_count] = "&nbsp";
   $aliases = aliases_toarray($inf['aliases']);
   $aliases_count = 0;
   foreach ($aliases as $num=>$alias) {
     $player_aliases[$aliases_count] = name_html($alias);
     $aliases_count++;
   }
   
$content = <<<EOD
<table cols="2" class="inf">
   <tr><th colspan="2" style="padding:0">
   <table cols="2" class="infhdr">
      <tr><th class="infhdr">$server_name &raquo; {$it['pi_header']} &raquo; $player_name</th><th width="50" class="infhdr">$player_userbar</th></tr>
   </table>
   </th></tr>
   <tr><td class="infpict"><img src="$player_avatar" class="infpict"></td><td class="infdata">\r\n
EOD;

   if ($aliases_count > 1) {
$content .= <<<EOD
   <table cols="3" class="infdata">
      <tr><td width="150">{$it['pi_rank']}</td><td>{$inf['rank']} ({$inf['score']})</td><td width="140">{$it['pi_aliases']} ($aliases_count):</td></tr>
      <tr><td>{$it['pi_authormedals']}</td><td>{$inf['am']}</td><td>{$player_aliases[0]}</td></tr>
      <tr><td>{$it['pi_goldmedals']}</td><td>{$inf['gm']}</td><td>{$player_aliases[1]}</td></tr>
      <tr><td>{$it['pi_silvermedals']}</td><td>{$inf['sm']}</td><td>{$player_aliases[2]}</td></tr>
      <tr><td>{$it['pi_bronzemedals']}</td><td>{$inf['bm']}</td><td>{$player_aliases[3]}</td></tr>
      <tr><td>{$it['pi_lastonline']}</td><td>{$inf['lastonline']}</td><td>{$player_aliases[4]}</td></tr>
   </table>\r\n
EOD;
   }
   else {
$content .= <<<EOD
   <table cols="2" class="infdata">
      <tr><td width="150">{$it['pi_rank']}</td><td>{$inf['rank']} ({$inf['score']})</td></tr>
      <tr><td>{$it['pi_authormedals']}</td><td>{$inf['am']}</td></tr>
      <tr><td>{$it['pi_goldmedals']}</td><td>{$inf['gm']}</td></tr>
      <tr><td>{$it['pi_silvermedals']}</td><td>{$inf['sm']}</td></tr>
      <tr><td>{$it['pi_bronzemedals']}</td><td>{$inf['bm']}</td></tr>
      <tr><td>{$it['pi_lastonline']}</td><td>{$inf['lastonline']}</td></tr>
   </table>\r\n
EOD;
   }

$content .= <<<EOD
   </td></tr>
</table>
<div class="splitter">&nbsp;</div>
<table cols="6" class="data">\r\n
EOD;


$c_thdr = <<<EOD
<tr><th width=\"60\">\$ch_number</th><th nowrap>\$ch_track</th><th width=\"120\" nowrap>\$ch_besttime</th><th width=\"130\" nowrap>\$ch_place</th><th width=\"80\" nowrap>\$ch_award</th><th width=\"150\" nowrap>\$ch_ts</th></tr>\r\n
EOD;

$c_tnstr = <<<EOD
<tr><td class="bl">-</td><td class="b">-</td><td class="b">-</td><td class="b">-</td><td class="b">-</td><td class="br">-</td></tr>\r\n
EOD;

$c_tstr = <<<EOD
<tr\$cd_javascript><td class=\"l\">\$cd_num</td><td>\$cd_track</td><td class=\"ar\">\$cd_besttime</td><td class=\"ar\">\$cd_place</td><td><img src=\"\$cd_award\" class=\"m\"></td><td class=\"r\">\$cd_ts</td></tr>\r\n
EOD;

$c_pages = <<<EOD
<tr><td class=\"pages\" colspan=\"6\">\$pages</td></tr>\r\n
EOD;
    
   $ch_number = $it['pi_num'];
   $sort_img = "<img src=\"gfx/sort".($view['sort'] == "trackc" ? "a" : "").".gif\" class=\"sort\">";
   $ch_track = "{$it['pi_track']}&nbsp;".get_linkstr($sort_img, "player", $view['stats'], $view['sid'], $view['pid'], -1, $view['query'], "trackc", "asc");
   $ch_besttime = $it['pi_besttime'];
   $sort_img = "<img src=\"gfx/sort".($view['sort'] == "rank" ? "a" : "").".gif\" class=\"sort\">";
   $ch_place = "{$it['pi_place']}&nbsp;".get_linkstr($sort_img, "player", $view['stats'], $view['sid'], $view['pid'], -1, $view['query'], "rank", "asc");
   $sort_img = "<img src=\"gfx/sort".($view['sort'] == "award" ? "a" : "").".gif\" class=\"sort\">";
   $ch_award = "{$it['pi_award']}&nbsp;".get_linkstr($sort_img, "player", $view['stats'], $view['sid'], $view['pid'], -1, $view['query'], "award", "asc");
   $sort_img = "<img src=\"gfx/sort".($view['sort'] == "ts" ? "a" : "").".gif\" class=\"sort\">";
   $ch_ts = "{$it['pi_ts']}&nbsp;".get_linkstr($sort_img, "player", $view['stats'], $view['sid'], $view['pid'], -1, $view['query'], "ts", "asc");

   eval("\$content .= \"$c_thdr\";");

   if ($cfg['javascript'])
      $cd_javascript = ' onMouseOver="mi(this)" onMouseOut="mo(this)"';
   else
      $cd_javascript = "";

   if ($data['count'] == 0)
      $content .= $c_tnstr;
   else {
      for ($i = 0; $i < $data['count']; $i++) {
         $cd_num = ($view['page']-1)*$cfg['recperpage'] + $i + 1;
         $cd_track = get_linkstr(name_html($data[$i]['track']), "track", $view['stats'], $view['sid'], -1, $data[$i]['trackid']);
         switch ($data[$i]['award']) {
         case "a": $cd_award = "gfx/ma.gif"; break;
         case "b": $cd_award = "gfx/mg.gif"; break;
         case "c": $cd_award = "gfx/ms.gif"; break;
         case "d": $cd_award = "gfx/mb.gif"; break;
         default:  $cd_award = "gfx/mf.gif"; break;
         }
         $cd_besttime = time_cut($data[$i]['bestresult']);
         $cd_place = $data[$i]['rank']." / ".$data[$i]['totalresults'];
         $cd_ts = $data[$i]['ts'];
         eval("\$content .= \"$c_tstr\";");
      }
      eval("\$content .= \"$c_pages\";");
   }

$content .= <<<EOD
</table>\r\n
EOD;

   return $content;
}

function get_tracks_content($cfg, $it, $view, $inf, $data) {

   $server_name = name_html($inf['servername']);
   $pages = get_pagesstr($it['mnu_pages'], $view);
   switch ($inf['servergame']) {
   case "Original" : $tracks_pict = "gfx/tracks_original.jpg"; break;
   case "Sunrise" : $tracks_pict = "gfx/tracks_sunrise.jpg"; break;
   case "Nations" : $tracks_pict = "gfx/tracks_nations.jpg"; break;
   default : $tracks_pict = "gfx/tracks_united.jpg"; break;
   }

$content = <<<EOD
<table cols="2" class="inf">
   <tr><th colspan="2" class="infhdr">$server_name &raquo; {$it['tl_header']}</th></tr>
   <tr><td class="infpict"><img src="$tracks_pict" class="infpict"></td><td class="infdata">
   <table cols="3" class="infdata">
      <tr><td width="150">{$it['tl_totaltracks']}</td><td>{$inf['totaltracks']}</td><td width="100" rowspan="6">
         <form action="{$_SERVER['PHP_SELF']}" method="get">
         <input type="hidden" name="action" value="{$view['action']}">
         <input type="hidden" name="stats" value="{$view['stats']}">
         <input type="hidden" name="sid" value="{$view['sid']}">
         <input type="hidden" name="sort" value="{$view['sort']}">
         <input type="hidden" name="dir" value="{$view['dir']}">
         <input type="hidden" name="page" value="1">
         {$it['tl_findtrack']}<p class="splitter">
         <input type="text" name="query" value="{$view['query']}" class="txt"><p class="splitter"><p>
         <input type="submit" value="{$it['tl_findtrack_btn']}" class="btn">
         </form>
      </td></tr>
      <tr><td>{$it['tl_totalauthors']}</td><td>{$inf['totalauthors']}</td></tr>
      <tr><td>&nbsp</td><td>&nbsp</td></tr>
      <tr><td>&nbsp</td><td>&nbsp</td></tr>
      <tr><td>&nbsp</td><td>&nbsp</td></tr>
      <tr><td>&nbsp</td><td>&nbsp</td></tr>
      </table>
   </td></tr>
</table>
<div class="splitter">&nbsp;</div>
<table cols="5" class="data">\r\n
EOD;

$c_thdr = <<<EOD
<tr><th width=\"60\">\$ch_number</th><th nowrap>\$ch_track</th><th width=\"150\" nowrap>\$ch_author</th><th width=\"120\" nowrap>\$ch_bestresult</th><th width=\"20%\" nowrap>\$ch_player</th></tr>\r\n
EOD;

$c_tnstr = <<<EOD
<tr><td class="bl">-</td><td class="b">-</td><td class="b">-</td><td class="b">-</td><td class="br">-</td></tr>\r\n
EOD;

$c_tstr = <<<EOD
<tr\$cd_javascript><td class=\"l\">\$cd_num</td><td>\$cd_track</td><td>\$cd_author</td><td class=\"ar\">\$cd_bestresult</td><td class=\"r\">\$cd_player</td></tr>\r\n
EOD;

$c_pages = <<<EOD
<tr><td class=\"pages\" colspan=\"5\">\$pages</td></tr>\r\n
EOD;

   $ch_number = $it['tl_num'];
   $sort_img = "<img src=\"gfx/sort".($view['sort'] == "trackc" ? "a" : "").".gif\" class=\"sort\">";
   $ch_track = "{$it['tl_track']}&nbsp;".get_linkstr($sort_img, "tracks", $view['stats'], $view['sid'], -1, -1, $view['query'], "trackc", "asc");
   $sort_img = "<img src=\"gfx/sort".($view['sort'] == "author" ? "a" : "").".gif\" class=\"sort\">";
   $ch_author = "{$it['tl_author']}&nbsp;".get_linkstr($sort_img, "tracks", $view['stats'], $view['sid'], -1, -1, $view['query'], "author", "asc");
   $sort_img = "<img src=\"gfx/sort".($view['sort'] == "bestresult" ? "a" : "").".gif\" class=\"sort\">";
   $ch_bestresult = "{$it['tl_bestresult']}&nbsp;".get_linkstr($sort_img, "tracks", $view['stats'], $view['sid'], -1, -1, $view['query'], "bestresult", "asc");
   $sort_img = "<img src=\"gfx/sort".($view['sort'] == "playerc" ? "a" : "").".gif\" class=\"sort\">";
   $ch_player = "{$it['tl_player']}&nbsp;".get_linkstr($sort_img, "tracks", $view['stats'], $view['sid'], -1, -1, $view['query'], "playerc", "asc");

   eval("\$content .= \"$c_thdr\";");

   if ($cfg['javascript'])
      $cd_javascript = ' onMouseOver="mi(this)" onMouseOut="mo(this)"';
   else
      $cd_javascript = "";
   if ($data['count'] == 0)
      $content .= $c_tnstr;
   else {
      for ($i = 0; $i < $data['count']; $i++) {
         $cd_num = ($view['page']-1)*$cfg['recperpage'] + $i + 1;
         $cd_track = get_linkstr(name_html($data[$i]['track']), "track", $view['stats'], $view['sid'], -1, $data[$i]['trackid']);
         $cd_author = name_html($data[$i]['author']);
         $cd_bestresult = time_cut($data[$i]['bestresult']);
         $cd_player = get_linkstr(name_html($data[$i]['player']), "player", $view['stats'], $view['sid'], $data[$i]['playerid'], -1);
         eval("\$content .= \"$c_tstr\";");
      }
      eval("\$content .= \"$c_pages\";");
   }

$content .= <<<EOD
</table>\r\n
EOD;
   return $content;
}


function get_track_content($cfg, $it, $view, $inf, $data) {

   $server_name = name_html($inf['servername']);
   $pages = get_pagesstr($it['mnu_pages'], $view);
   $track_name = name_html($inf['track']);
   if (file_exists("gfx/tracks/{$inf['uid']}.jpg"))
      $track_screen = "gfx/tracks/{$inf['uid']}.jpg";
   else {
      switch ($inf['servergame']) {
      case "Original" : $track_screen = "gfx/track_original.jpg"; break;
      case "Sunrise" : $track_screen = "gfx/track_sunrise.jpg"; break;
      case "Nations" : $track_screen = "gfx/track_nations.jpg"; break;
      default : $track_screen = "gfx/track_united.jpg"; break;
      }
   }
   $author_name = name_html($inf['author']);

   if ($inf['nblaps'] > 1) {
      $author_time = $inf['authortime']." / ".$inf['nblaps']." = ".time_lapfull($inf['authortime'], $inf['nblaps']);
      $gold_time = $inf['gold']." / ".$inf['nblaps']." = ".time_lapfull($inf['gold'], $inf['nblaps']);
      $silver_time = $inf['silver']." / ".$inf['nblaps']." = ".time_lapfull($inf['silver'], $inf['nblaps']);
      $bronze_time = $inf['bronze']." / ".$inf['nblaps']." = ".time_lapfull($inf['bronze'], $inf['nblaps']);
   }
   else {
      $author_time = $inf['authortime'];
      $gold_time = $inf['gold'];
      $silver_time = $inf['silver'];
      $bronze_time = $inf['bronze'];
   }

$content = <<<EOD
<table cols="2" class="inf">
   <tr><th colspan="2" class="infhdr">$server_name &raquo; {$it['ti_header']} &raquo; $track_name</th></tr>
   <tr><td class="infpict"><img src="$track_screen" class="infpict"></td><td class="infdata">
   <table cols="2" class="infdata">
      <tr><td width="150">{$it['ti_author']}</td><td>$author_name</td></tr>
      <tr><td>{$it['ti_timeauthor']}</td><td>$author_time</td></tr>
      <tr><td>{$it['ti_timegold']}</td><td>$gold_time</td></tr>
      <tr><td>{$it['ti_timesilver']}</td><td>$silver_time</td></tr>
      <tr><td>{$it['ti_timebronze']}</td><td>$bronze_time</td></tr>
      <tr><td>{$it['ti_envir']}</td><td>{$inf['envir']}</td></tr>
   </table>
   </td></tr>
</table>
<div class="splitter">&nbsp;</div>
<table cols="5" class="data">\r\n
EOD;


$c_thdr = <<<EOD
<tr><th width=\"60\">\$ch_number</th><th nowrap>\$ch_player</th><th width=\"120\" nowrap>\$ch_besttime</th><th width=\"70\" nowrap>\$ch_award</th><th width=\"150\" nowrap>\$ch_ts</th></tr>\r\n
EOD;

$c_tnstr = <<<EOD
<tr><td class="bl">-</td><td class="b">-</td><td class="b">-</td><td class="b">-</td><td class="br">-</td></tr>\r\n
EOD;

$c_tstr = <<<EOD
<tr\$cd_javascript><td class=\"l\">\$cd_num</td><td>\$cd_player</td><td class=\"ar\">\$cd_besttime</td><td><img src=\"\$cd_award\" class=\"m\"></td><td class=\"r\">\$cd_ts</td></tr>\r\n
EOD;

$c_pages = <<<EOD
<tr><td class=\"pages\" colspan=\"5\">\$pages</td></tr>\r\n
EOD;

   $ch_number = $it['ti_num'];
   $sort_img = "<img src=\"gfx/sort".($view['sort'] == "playerc" ? "a" : "").".gif\" class=\"sort\">";
   $ch_player = "{$it['ti_player']}&nbsp;".get_linkstr($sort_img, "track", $view['stats'], $view['sid'], -1, $view['tid'], $view['query'], "playerc", "asc");
   $sort_img = "<img src=\"gfx/sort".($view['sort'] == "bestresult" ? "a" : "").".gif\" class=\"sort\">";
   $ch_besttime = "{$it['ti_bestresult']}&nbsp;".get_linkstr($sort_img, "track", $view['stats'], $view['sid'], -1, $view['tid'], $view['query'], "besttime", "asc");
   $sort_img = "<img src=\"gfx/sort".($view['sort'] == "award" ? "a" : "").".gif\" class=\"sort\">";
   $ch_award = $it['ti_award'];
   $sort_img = "<img src=\"gfx/sort".($view['sort'] == "ts" ? "a" : "").".gif\" class=\"sort\">";
   $ch_ts = "{$it['ti_ts']}&nbsp;".get_linkstr($sort_img, "track", $view['stats'], $view['sid'], -1, $view['tid'], $view['query'], "ts", "asc");

   eval("\$content .= \"$c_thdr\";");

   if ($cfg['javascript'])
      $cd_javascript = ' onMouseOver="mi(this)" onMouseOut="mo(this)"';
   else
      $cd_javascript = "";

   if ($data['count'] == 0)
      $content .= $c_tnstr;
   else {
      for ($i = 0; $i < $data['count']; $i++) {
         $cd_num = ($view['page']-1)*$cfg['recperpage'] + $i + 1;
         if ($data[$i]['score'] >= $cfg['minscore'])
            $cd_player = get_linkstr(name_html($data[$i]['player']), "player", $view['stats'], $view['sid'], $data[$i]['playerid'], -1);
         else
            $cd_player = name_html($data[$i]['player']);
         switch ($data[$i]['award']) {
         case "a": $cd_award = "gfx/ma.gif"; break;
         case "b": $cd_award = "gfx/mg.gif"; break;
         case "c": $cd_award = "gfx/ms.gif"; break;
         case "d": $cd_award = "gfx/mb.gif"; break;
         default:  $cd_award = "gfx/mf.gif"; break;
         }
         if ($data[$i]['bestresult'] == $inf['bestresult'])
            $cd_besttime = $data[$i]['bestresult'];
         else
            $cd_besttime = "+".time_deltacut($data[$i]['bestresult'], $inf['bestresult']);
         $cd_ts = $data[$i]['ts'];
         eval("\$content .= \"$c_tstr\";");
      }
      eval("\$content .= \"$c_pages\";");
   }

$content .= <<<EOD
</table>\r\n
EOD;

   return $content;
}


function get_clans_content($cfg, $it, $view, $inf, $data) {

   $server_name = name_html($inf['servername']);
   $pages = get_pagesstr($it['mnu_pages'], $view);
$content = <<<EOD
<table cols="3" class="data">
<tr><th colspan="3" class="infhdr">$server_name &raquo; {$it['cl_header']}</th></tr>\r\n
EOD;

$c_thdr = <<<EOD
<tr><th width=\"50\">\$ch_num</th><th nowrap>\$ch_clan</th><th width=\"100\" nowrap>\$ch_score</th></tr>\r\n
EOD;

$c_tnstr = <<<EOD
<tr><td class=\"bl\">-</td><td class=\"b\">-</td><td class=\"br\">-</td></tr>\r\n
EOD;

$c_tstr = <<<EOD
<tr\$cd_javascript><td class=\"l\">\$cd_num</td><td class=\"pl\">\$cd_clan</td><td class=\"r\">\$cd_score</td></tr>\r\n
EOD;

$c_tstrc = <<<EOD
<tr\$cd_javascript><td class=\"lc\">\$cd_num</td><td class=\"c\">\$cd_clan</td><td class=\"rc\">\$cd_score</td></tr>\r\n
EOD;

$c_pages = <<<EOD
<tr><td class=\"pages\" colspan=\"3\">\$pages</td></tr>\r\n
EOD;

   $ch_num = $it['cl_num'];
   $sort_img = "<img src=\"gfx/sort".($view['sort'] == "clan" ? "a" : "").".gif\" class=\"sort\">";
   $ch_clan = "{$it['cl_clan']}&nbsp;".get_linkstr($sort_img, "clans", $view['stats'], $view['sid'], -1, -1, "*", "clan", "asc");
   $sort_img = "<img src=\"gfx/sort".($view['sort'] == "score" ? "a" : "").".gif\" class=\"sort\">";
   $ch_score = "{$it['cl_score']}&nbsp;".get_linkstr($sort_img, "clans", $view['stats'], $view['sid'], -1, -1, "*", "score", "desc");
   eval("\$content .= \"$c_thdr\";");

   if ($cfg['javascript'])
      $cd_javascript = ' onMouseOver="mi(this)" onMouseOut="mo(this)"';
   else
      $cd_javascript = "";
 
  $is_clans = false;
   for ($i = 0; $i < $data['count']; $i++) {
      if ($data[$i]['score'] >= $cfg['minscore']) $is_clans = true;
   }
   if ($data['count'] == 0 || !$is_clans)
      eval("\$content .= \"$c_tnstr\";");
   else {
      for ($i = 0; $i < $data['count']; $i++) {
         $cd_num = ($view['page']-1)*$cfg['recperpage'] + $i + 1;
         $cd_clan = htmlspecialchars($data[$i]['clanc']).$data[$i]['description'];
         $cd_score = $data[$i]['score'];
         eval("\$content .= \"$c_tstrc\";");
         for ($j = 0; $j < $data[$i]['members']['count']; $j++) {
            $cd_num = "";
            if ($data[$i]['members'][$j]['score'] >= $cfg['minscore'])
               $cd_clan = get_linkstr(name_html($data[$i]['members'][$j]['player']), "player", $view['stats'], $view['sid'], $data[$i]['members'][$j]['playerid'], -1);
            else
               $cd_clan = name_html($data[$i]['members'][$j]['player']);
            $cd_score = $data[$i]['members'][$j]['score'];
            eval("\$content .= \"$c_tstr\";");
         }
      }
      eval("\$content .= \"$c_pages\";");
   }

$content .= <<<EOD
</table>\r\n
EOD;

   return $content;
}

function get_userbar_content($it, $view, $inf, $data) {
   switch ($inf['servergame']) {
   case "Original" : $userbar_game = "o"; break;
   case "Sunrise" : $userbar_game = "s"; break;
   case "Nations" : $userbar_game = "n"; break;
   default : $userbar_game = "u"; break;
   }

$content = <<<EOD
<table cols="1">
   <tr><th class="header">{$it['ub_header']}</th></tr>
   <tr><td class="blr">\r\n
EOD;
   for ($i = 0; $i < $data['count']; $i++) {
      if ($data[$i][1] == $userbar_game)
$content .= <<<EOD
   <p><br>
   <img src="{$inf['link']}tmos_{$data[$i][1]}_{$data[$i][2]}_{$data[$i][3]}_{$data[$i][4]}_{$view['sid']}_{$view['stats']}_{$view['pid']}.png"><p>
   {$it['ub_forum_and_html_links']}<br><textarea>[img]{$inf['link']}tmos_{$data[$i][1]}_{$data[$i][2]}_{$data[$i][3]}_{$data[$i][4]}_{$view['sid']}_{$view['stats']}_{$view['pid']}.png[/img]\r\n<img src="{$inf['link']}tmos_{$data[$i][1]}_{$data[$i][2]}_{$data[$i][3]}_{$data[$i][4]}_{$view['sid']}_{$view['stats']}_{$view['pid']}.png"></textarea><p>
EOD;
   }
$content .= <<<EOD
   </td></tr>
</table>\r\n
EOD;
   return $content;
}


function get_error_content($it, $errorid) {
   switch ($errorid) {
      case "error_dblib":
         $error_msg = $it['err_dblib'];
         break;
      case "error_dbconnection":
         $error_msg = $it['err_dbconnection'];
         break;
      case "error_servers":
         $error_msg = $it['err_serversnotfound'];
         break;
      case "error_monitoring":
         $error_msg = $it['err_monitoring'];
         break;
      case "error_gd":
         $error_msg = $it['err_gdnotsupported'];
         break;
      case "error_ub0":
         $error_msg = $it['err_userbarsnotfound'];
         break;
      default:
         $error_msg = $it['err_error'];
         break;

   }
$content = <<<EOD
$error_msg
EOD;
   return $content;
}

function get_header($cfg, $it, $view) {
$header = <<<EOD
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>TM Offline Stats 0.62</title>
<link rel="stylesheet" type="text/css" href="./gfx/{$cfg['cssfile']}">\r\n
EOD;
   if ($cfg['javascript'])
$header .= <<<EOD
<script language=javascript>
   function mi(tablestr) {
      tablestr.className='light';
   } 
   function mo(tablestr) {
      tablestr.className='';
   } 
</script>\r\n
EOD;
$header .= <<<EOD
</head>
<body>
<table class="headline">
   <tr><td class="logo"><img src="./gfx/logo.gif" class="logo" alt="TM Offline Stats"></td></tr>\r\n
EOD;

   $ms = "";
   $mm = "";
   $mp = "";
   $mt = "";
   $mc = "";
   $mo = "";
   switch ($view['action']) {
   case "servers": $ms = "a"; break;
   case "monitoring": $mm = "a"; break;
   case "players": $mp = "a"; break;
   case "tracks": $mt = "a"; break;
   case "clans": $mc = "a"; break;
   default: $mo = "a"; break;
   }

   if ($view['showmenuservers'])
      $servers_menu = "<td class=\"m$ms\" nowrap><a href={$_SERVER['PHP_SELF']}?action=servers>{$it['mnu_servers']}</a></td>";
   else
      $servers_menu = "";
   if ($view['showmenuclans'])
      $clans_menu = "<td class=\"m$mc\" nowrap><a href={$_SERVER['PHP_SELF']}?action=clans&sid={$view['sid']}&stats={$view['stats']}>{$it['mnu_clanlist']}</a></td>";
   else
      $clans_menu = "";

   if ($view['showmenu'])
$header .= <<<EOD
   <tr><td class="blr">
   <table class="menu"><tr>
      $servers_menu
      <td class="m$mm" nowrap><a href={$_SERVER['PHP_SELF']}?action=monitoring&sid={$view['sid']}&stats={$view['stats']}>{$it['mnu_monitoring']}</a></td>
      <td class="m$mp" nowrap><a href={$_SERVER['PHP_SELF']}?action=players&sid={$view['sid']}&stats={$view['stats']}>{$it['mnu_playerlist']}</a></td>
      <td class="m$mt" nowrap><a href={$_SERVER['PHP_SELF']}?action=tracks&sid={$view['sid']}&stats={$view['stats']}>{$it['mnu_tracklist']}</a></td>
      $clans_menu
      <td class="m$mo" nowrap>&raquo;</td>
      <td class="me" width="100%">&nbsp;</td>
   </tr></table>
   </td></tr>\r\n
EOD;
   else
$header .= <<<EOD
   <tr><td class="blr">
   <table class="menu">
      <tr><td class="n">&nbsp;</td></tr>
   </table>
   </td></tr>\r\n
EOD;

$header .= <<<EOD
</table>
<div class="splitter">&nbsp;</div>\r\n
EOD;

   return $header;
}

function get_footer() {
$footer = <<<EOD
<div class="splitter">&nbsp;</div>
<table class="links">
   <tr><td class="links">&copy; 2007 Alexander Domnin</td></tr>
   <tr><td class="links"><a href="http://tmos.pp.ru">www.tmos.pp.ru</a></td></tr>
</table>
</body>
</html>
EOD;
   return $footer;
}


?>