<?php
/*
   TM Offline Stats v0.62a
   Copyright (c) 2006 Alexander Domnin

   This program is licenced under the Creative Commons Attribution-NonCommercial-NoDerivs 2.5
   To view a copy of this licence, visit http://creativecommons.org/licenses/by-nc-nd/2.5/

   This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
   without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

define("PS_CFG_FILENAME", "./tmos_config.php");       //
define("PS_CFG_MP_FILENAME","./tmos_config_mp.php");
define("PS_CACHE_DIR", "./cache/");                   //
define("PS_MIN_TIME_BETWEEN_PARSING", 30);            // second
define("PS_ID_LENGTH", 11);                           // part of md5
define("PS_DB_INSERT_RECS_COUNT", 1000);              //
define("PS_UB_QUERY_DELIM", "/");                     //

function get_id($str) {
   return substr(md5($str), 0, PS_ID_LENGTH);
}

function config_load() {
   $cfg = array();

   require(PS_CFG_FILENAME);

   if (!isset($cfg['dbhost']) || !is_string($cfg['dbhost'])) $cfg['dbhost'] = "localhost";
   if (!isset($cfg['dbtype']) || !is_string($cfg['dbtype'])) $cfg['dbtype'] = "mysql"; $cfg['dbtype'] = "mysql";
   if (!isset($cfg['dbname']) || !is_string($cfg['dbname'])) $cfg['dbname'] = "tmostats";
   if (!isset($cfg['dblogin']) || !is_string($cfg['dblogin'])) $cfg['dblogin'] = "root";
   if (!isset($cfg['dbpassword']) || !is_string($cfg['dbpassword'])) $cfg['dbpassword'] = "";
   if (!isset($cfg['interfacelanguage']) || !is_string($cfg['interfacelanguage'])) $cfg['interfacelanguage'] = "xxx";
   if (!isset($cfg['recperpage']) || !is_numeric($cfg['recperpage']) || $cfg['recperpage'] < 10) $cfg['recperpage'] = 100;
   if (!isset($cfg['javascript']) || !is_bool($cfg['javascript'])) $cfg['javascript'] = true;
   if (!isset($cfg['servertimeout']) || !is_numeric($cfg['servertimeout']) || $cfg['servertimeout'] < 1) $cfg['servertimeout'] = 2;
   if (!isset($cfg['defaultstats']) || ($cfg['defaultstats'] != "a" && $cfg['defaultstats'] != "c")) $cfg['defaultstats'] = "a";
   if (!isset($cfg['showoneserver']) || !is_bool($cfg['showoneserver'])) $cfg['showoneserver'] = false;
   if (!isset($cfg['showclans']) || !is_bool($cfg['showclans'])) $cfg['showclans'] = false;
   if (!isset($cfg['showuserbars']) || !is_bool($cfg['showuserbars'])) $cfg['showuserbars'] = true;
   if (!isset($cfg['minscore']) || !is_numeric($cfg['minscore']) || $cfg['minscore'] < 0) $cfg['minscore'] = 1;
   if (!isset($cfg['htmlcache']) || !is_string($cfg['htmlcache'])) $cfg['htmlcache'] = "main";
   if (!isset($cfg['gzipcompress']) || !is_bool($cfg['gzipcompress'])) $cfg['gzipcompress'] = false;
   if (!isset($cfg['cssfile']) || !is_string($cfg['cssfile'])) $cfg['cssfile'] = "tmos_default.css";
   if (!isset($cfg['adminpass']) || !is_string($cfg['adminpass'])) $cfg['adminpass'] = "1";
   if (!isset($cfg['timeperiod']) || !is_numeric($cfg['timeperiod']) || $cfg['timeperiod'] < 1) $cfg['timeperiod'] = 7;
   if (!isset($cfg['minclansize']) || !is_numeric($cfg['minclansize']) || $cfg['minclansize'] < 2) $cfg['minclansize'] = 2;
   if (!isset($cfg['amscore']) || !is_numeric($cfg['amscore']) || $cfg['amscore'] < 0) $cfg['amscore'] = 1;
   if (!isset($cfg['gmscore']) || !is_numeric($cfg['gmscore']) || $cfg['gmscore'] < 0) $cfg['gmscore'] = 0;
   if (!isset($cfg['smscore']) || !is_numeric($cfg['smscore']) || $cfg['smscore'] < 0) $cfg['smscore'] = 0;
   if (!isset($cfg['bmscore']) || !is_numeric($cfg['bmscore']) || $cfg['bmscore'] < 0) $cfg['bmscore'] = 0;
   if (!isset($cfg['finishscore']) || !is_numeric($cfg['finishscore']) || $cfg['finishscore'] < 0) $cfg['finishscore'] = 0;
   if (!isset($cfg['ubfont']) || !is_string($cfg['ubfont'])) $cfg['ubfont'] = "arialuni.ttf";
   if (!isset($cfg['ubfontsizen']) || !is_numeric($cfg['ubfontsizen']) || $cfg['ubfontsizen'] < 1) $cfg['ubfontsizen'] = 7;
   if (!isset($cfg['ubfontsizeb']) || !is_numeric($cfg['ubfontsizeb']) || $cfg['ubfontsizeb'] < 1) $cfg['ubfontsizeb'] = 9;

   return $cfg;
}

function config_save($cfg) {
   if (($fp = @fopen(PS_CFG_FILENAME, "wb")) !== false) {
      // preformat
      $cfg['javascript'] ? $cfg['javascript'] = "true" : $cfg['javascript'] = "false";
      $cfg['showoneserver'] ? $cfg['showoneserver'] = "true" : $cfg['showoneserver'] = "false";
      $cfg['showclans'] ? $cfg['showclans'] = "true" : $cfg['showclans'] = "false";
      $cfg['showuserbars'] ? $cfg['showuserbars'] = "true" : $cfg['showuserbars'] = "false";
      $cfg['gzipcompress'] ? $cfg['gzipcompress'] = "true" : $cfg['gzipcompress'] = "false";

$tmos_config = <<<EOD
<?php
// TM Offline Stats v0.62a

// db settings
\$cfg['dbhost'] = "{$cfg['dbhost']}";
\$cfg['dbtype'] = "{$cfg['dbtype']}";
\$cfg['dbname'] = "{$cfg['dbname']}";
\$cfg['dblogin'] = "{$cfg['dblogin']}";
\$cfg['dbpassword'] = "{$cfg['dbpassword']}";

// interface settings
\$cfg['interfacelanguage'] = "{$cfg['interfacelanguage']}";
\$cfg['recperpage'] = {$cfg['recperpage']};
\$cfg['javascript'] = {$cfg['javascript']};
\$cfg['servertimeout'] = {$cfg['servertimeout']};
\$cfg['defaultstats'] = "{$cfg['defaultstats']}";
\$cfg['showoneserver'] = {$cfg['showoneserver']};
\$cfg['showclans'] = {$cfg['showclans']};
\$cfg['showuserbars'] = {$cfg['showuserbars']};
\$cfg['minscore'] = {$cfg['minscore']};
\$cfg['htmlcache'] = "{$cfg['htmlcache']}";
\$cfg['gzipcompress'] = {$cfg['gzipcompress']};
\$cfg['cssfile'] = "{$cfg['cssfile']}";

// parse settings
\$cfg['timeperiod'] = {$cfg['timeperiod']};
\$cfg['minclansize'] = {$cfg['minclansize']};
\$cfg['amscore'] = {$cfg['amscore']};
\$cfg['gmscore'] = {$cfg['gmscore']};
\$cfg['smscore'] = {$cfg['smscore']};
\$cfg['bmscore'] = {$cfg['bmscore']};
\$cfg['finishscore'] = {$cfg['finishscore']};

// userbars settings
\$cfg['ubfont'] = "{$cfg['ubfont']}";
\$cfg['ubfontsizen'] = {$cfg['ubfontsizen']};
\$cfg['ubfontsizeb'] = {$cfg['ubfontsizeb']};

// admin password
\$cfg['adminpass'] = "{$cfg['adminpass']}";
?>
EOD;
      // save
      if (@fwrite($fp, $tmos_config) !== false) $result = true;
      else $result = false;
      fclose ($fp);
   }
   else
      $result = false;
   return $result;
}

function userbars_load() {
   $ub['count'] = 0;
   if (($curr_dir = @opendir("./gfx")) !== false) {
      while(($curr_rec = readdir($curr_dir)) !== false) {
         if (preg_match("/^tmosub_(.)_(.)_([0-9a-f]{6})_(.{1,3})\.png$/i", $curr_rec, $curr_ub)) {
            $ub[$ub['count']] = $curr_ub;
            $ub['count']++;
         }
      }
      closedir($curr_dir);
   }
   return $ub;
}

function languages_load() {
   if (($curr_dir = @opendir("./include")) !== false) {
      while(($curr_rec = readdir($curr_dir)) !== false) {
         if (preg_match("/^tmos_lang_([0-9a-z]{1,10})\.inc\.php$/i", $curr_rec, $curr_lang)) {
            $langs[] = $curr_lang[1];
         }
      }
      closedir($curr_dir);
   }
   if (!isset($langs)) $langs[0] = 'rus';
   return $langs;
}

function css_load() {
   if (($curr_dir = @opendir("./gfx")) !== false) {
      while(($curr_rec = readdir($curr_dir)) !== false) {
         if (preg_match("/.+\.css$/i", $curr_rec, $curr_css)) {
            $cssfiles[] = $curr_css[0];
         }
      }
      closedir($curr_dir);
   }
   return $cssfiles;
}

function cache_dir_clear() {
   if (($curr_dir = @opendir(PS_CACHE_DIR)) !== false) {
      while(($curr_rec = readdir($curr_dir)) !== false) {
         if ($curr_rec != '.' && $curr_rec != '..' && is_file(PS_CACHE_DIR.$curr_rec)) {
            unlink(PS_CACHE_DIR.$curr_rec);
         }
      }
      closedir($curr_dir);
   }
}

function cache_file_write($filename, &$content) {
   if (!file_exists(PS_CACHE_DIR.$filename)) {
      $fp = @fopen(PS_CACHE_DIR.$filename, "wb+");
      if (!$fp) {
      }
      else {
         @fwrite($fp, $content, strlen($content));
         @fclose($fp);
      }
   }
}

function cache_file_read($filename) {
   if (file_exists(PS_CACHE_DIR.$filename))
      $content = file_get_contents(PS_CACHE_DIR.$filename);
   else
      $content = "";
}

function gzip_out(&$content) {
     if (extension_loaded('zlib') && isset($_SERVER['HTTP_ACCEPT_ENCODING']) && strlen($content) > 1024) {
        $encoding = "";
        if (strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'x-gzip') !== false) $encoding = "x-gzip";
        if (strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip') !== false) $encoding = "gzip";

        if ($encoding != "") {
           header("Content-Encoding: $encoding");
           header("Vary: Accept-Encoding");
           echo "\x1f\x8b\x08\x00\x00\x00\x00\x00".
                  substr(gzcompress($content, 6), 0, -4).
                  pack("VV", crc32($content), strlen($content));
        }
        else {
           echo $content;
        }
     }
     else {
        echo $content;
     }
}

function split_tracks($tracks) {
   $tmp = preg_split('/;/u', $tracks, -1, PREG_SPLIT_NO_EMPTY);
   $result['count'] = sizeof($tmp);
   for ($i = 0; $i < sizeof($tmp); $i++)
      $result[$i] = $tmp[$i];
   return $result;
}

function split_logs($logs, $setnull) {
   $tmp = preg_split('/;/u', $logs, -1, PREG_SPLIT_NO_EMPTY);
   $result['count'] = sizeof($tmp);
   for ($i = 0; $i < sizeof($tmp); $i++) {
      $tmp2 = explode("*", $tmp[$i]);
      $result[$i]['logfile'] = $tmp2[0];
      if ($setnull) {
         $result[$i]['parse_position'] = 0;
         $result[$i]['parse_str'] = "x";
         $result[$i]['parse_track'] = "x";
      }
      else {
         $result[$i]['parse_position'] = $tmp2[1];
         $result[$i]['parse_str'] = $tmp2[2];
         $result[$i]['parse_track'] = $tmp2[3];
      }
   }
   return $result;
}

function merge_logs($logs, $setnull) {
   $result = "";
   for ($i = 0; $i < $logs['count']; $i++) {
      if ($setnull)
         $result .= $logs[$i]['logfile'].";";
      else
         $result .= $logs[$i]['logfile']."*".
                    $logs[$i]['parse_position']."*".
                    $logs[$i]['parse_str']."*".
                    $logs[$i]['parse_track'].";";
   }
   return $result;
}

function name_clan_auto_left($name) {
   $matches = array();
   if (preg_match("/^([\p{P}\p{S}]{0,2}[\{\(\<\[\|]{1,1}.{1,10}[\}\)\>\]\|]{1,1}[\p{P}\p{S}]{0,2})/u", $name, $matches)) {}
   else if (preg_match("/^([\p{P}\p{S}]{1,3}[\p{L}\p{N}]{1,10}[\p{P}\p{S}]{1,3})/u", $name, $matches)) {}
   else if (preg_match("/^([\p{L}\p{N}]{1,10}[\p{P}\p{S}]{1,3})/u", $name, $matches)) {}
   if (sizeof($matches) && $matches[1] != $name) {
      return trim($matches[1]);
   }
   return '';
}

function name_clan_auto_right($name) {
   $matches = array();
   if (preg_match("/([\p{P}\p{S}]{0,2}[\{\(\<\[\|]{1,1}.{1,10}[\}\)\>\]\|]{1,1}[\p{P}\p{S}]{0,2})$/u", $name, $matches)) {}
   else if (preg_match("/([\p{P}\p{S}]{1,3}[\p{L}\p{N}]{1,10}[\p{P}\p{S}]{1,3})$/u", $name, $matches)) {}
   else if (preg_match("/([\p{P}\p{S}]{1,3}[\p{L}\p{N}]{1,10})$/u", $name, $matches)) {}
   if (sizeof($matches) && $matches[1] != $name) {
      return trim($matches[1]);
   }
   return '';
}

function name_clan_manual($name, $mask) {
   if ($name == "" || $mask == "")
      $result = false;
   else {
      $mp = strpos(strtolower($name), strtolower($mask));
      if ($mp === 0 || $mp === strlen($name) - strlen($mask))
         $result = true;
      else
         $result = false;
   }
   return $result;
}

function name_clear($name) {
   $name = preg_replace('/(\$\$)/u', "\x01", $name);
   $patterns = array ('/(\$o)/iu', '/(\$s)/iu', '/(\$i)/iu', '/(\$n)/iu', '/(\$w)/iu', '/(\$g)/iu', '/(\$z)/iu', '/(\$m)/iu', '/(\$...)/iu', '/(^\s+)/u', '/(\s+$)/u');
   $replace = array ('', '', '', '', '', '', '', '', '', '', '');
   $name = preg_replace($patterns, $replace, $name);
   return preg_replace("/\x01/u", '$', $name);
}

function name_html($name) {
   $buf = preg_replace(array('/(\$\$)/u', '/(\$s)/iu', '/(\$o)/iu'), array("\x01", "", ""), $name);
   $buf = preg_split('/(\$i)|(\$n)|(\$w)|(\$g)|(\$z)|(\$m)|(\$...)/iu', $buf, -1, PREG_SPLIT_DELIM_CAPTURE | PREG_SPLIT_NO_EMPTY);
   $res = '';
   $st_color = '';
   $st_italic = '';
   $st_spacing = '';
   foreach($buf as $tnum=>$tok) {
      if (strcasecmp($buf[$tnum], '$z') == 0) {
         $st_color = '';
         $st_italic = '';
         $st_spacing = '';
      }
      else if (strcasecmp($buf[$tnum], '$g') == 0)
         $st_color = '';
      else if (strcasecmp($buf[$tnum], '$m') == 0)
         $st_spacing = '';
      else if (strcasecmp($buf[$tnum], '$i') == 0) {
         if ($st_italic !== '') $st_italic = '';
         else $st_italic = "font-style:italic;";
      }
      else if (strcasecmp($buf[$tnum], '$w') == 0)
         $st_spacing = "letter-spacing:2;";
      else if (strcasecmp($buf[$tnum], '$n') == 0)
         $st_spacing = "letter-spacing:-2;";
      else if($buf[$tnum][0] == "$") {
         $patterns = array ('/(\$)/', '/([0-9a-f])/iu', '/([^0-9a-f])/iu');
         $replace = array ("", "\${1}0", "00");
         $st_color = "color:#".preg_replace($patterns, $replace, $buf[$tnum]).";";
      }
      else if ("$st_color$st_italic$st_spacing" != "") {
         $res .= "<span style=\"$st_color$st_italic$st_spacing\">";
         $res .= htmlspecialchars($buf[$tnum]);
         $res .= "</span>";
      }
      else {
         $res .= htmlspecialchars($buf[$tnum]);
      }
   }
   return preg_replace("/\x01/u", "$", $res);
}

function config_mp_load() {
   require(PS_CFG_MP_FILENAME);
   // protect from dummies ?
   if (!isset($cfg_autofindclans) ||
       !isset($cfg_players) ||
       !isset($cfg_players_ignorelist) ||
       !isset($cfg_autofindclans) ||
       !isset($cfg_clans) ||
       !isset($cfg_clans_ignorelist) ||
       !isset($cfg_tracks_ignorelist))
      die ("File \"tmos_config_mp.php\" is corrupted, replace him with entire version");

   $cfg['afc'] = $cfg_autofindclans;
   $cfg['cil'] = array(); // clans, ignorelist
   $cfg['ctl'] = array(); // clans, tags
   $cfg['pil'] = array(); // players, ignoreslist
   $cfg['pal'] = array(); // players, unite
   $cfg['til'] = array(); // tracks, ignorelist

   foreach ($cfg_clans_ignorelist as $value) {
      $cfg['cil'][get_id(strtolower(name_clear($value)))] = true;
   }
   foreach ($cfg_clans as $key=>$value) {
      $clan_id = get_id(strtolower(name_clear($key)));
      $cfg['ctl'][$clan_id]['tag'] = $key;
      if (isset($value['description']))
         $cfg['ctl'][$clan_id]['descr'] = $value['description'];
      else
         $cfg['ctl'][$clan_id]['descr'] = "";
      if (isset($value['autofindmembers']))
          $cfg['ctl'][$clan_id]['afm'] = $value['autofindmembers'];
      else
          $cfg['ctl'][$clan_id]['afm'] = true;
      $cfg['ctl'][$clan_id]['members'] = array();
      if (isset($value['members'])) {
         $tmp = preg_split('/;/u', $value['members'], -1, PREG_SPLIT_NO_EMPTY);
         for ($i = 0; $i < sizeof($tmp); $i++)
            $cfg['ctl'][$clan_id]['members'][name_clear($tmp[$i])] = true;
      }
   }
   foreach ($cfg_players as $key=>$value) {
      $cfg['pal'][get_id(name_clear($key))] = get_id(name_clear($value));
   }
   foreach ($cfg_players_ignorelist as $value) {
      $cfg['pil'][get_id(name_clear($value))] = true;
   }
   foreach ($cfg_tracks_ignorelist as $value) {
      $cfg['til'][get_id(trim($value))] = true;
   }

   return $cfg;
}

// date time
function time_stamp($date, $time) {
   return $date.' '.$time;
}

// curr date time - $delta days
function time_stamp_delta($delta) {
   return date("Y/m/d H:i:s", strtotime("-$delta days"));
}

// xx:xx:xx.xx (1:2.3 -> 00:01:02.30)
function time_full($timestr) {
   $patterns = array ("/(^\d+:\d+\.\d+)/", "/(^\d:)/", "/:(\d):/", "/:(\d)\./", "/\.(\d$)/");
   $replace = array ("00:\\1", "0\\1", ":0\\1:", ":0\\1.", ".\${1}0");
   return preg_replace($patterns, $replace, $timestr);
}

// xx:xx:xx.xx (00:01:02.30 -> 1:02.30)
function time_cut($timestr) {
   $patterns = array ("/(00:)/", "/^0(\d)(:|\.)/");
   $replace = array ("", "\${1}\${2}");
   return preg_replace($patterns, $replace, $timestr);
}

// msec (00:01:02.30 -> 62300)
function time_fulltomsec($timestr) {
   list($hours, $minutes, $seconds, $msec)= sscanf($timestr, "%2s:%2s:%2s.%2s");
   return ((int)$hours)*3600000 + ((int)$minutes)*60000 + ((int)$seconds)*1000 + ((int)($msec))*10;
}

// xx:xx:xx.xx (62300 -> 00:01:02.30)
function time_msectofull($timemsec) {
   $msec = substr($timemsec, -3, -1);
   $timemsec = substr($timemsec, 0, -3);
   $hours = floor($timemsec/3600);
   $timemsec -= $hours*3600;
   $minutes = floor($timemsec/60);
   $seconds = $timemsec - $minutes*60;
   return sprintf("%02d:%02d:%02d.%02d", $hours, $minutes, $seconds, $msec);
}

// xx:xx:xx.xx (62300 -> 1:02.30)
function time_msectocut($timemsec) {
   return time_cut(time_msectofull($timemsec));
}

// $time1 - $time2 (00:01:02.30 - 00:00:32.00 = 30.30)
function time_deltacut($time1, $time2) {
   $delta = time_fulltomsec($time1) - time_fulltomsec($time2);
   return time_msectocut($delta);
}

// $timestr/$nblaps
function time_lapfull($timestr, $nblaps) {
   if ($nblaps <= 1)
      return $timestr;
   else {
      $lap = floor(time_fulltomsec($timestr)/$nblaps);
      return time_msectofull($lap);
   }
}

// alias in str
function aliases_exist($str, $alias, $delim = ",") {
   $result = false;
   $curr_alias = strtok($str, $delim);
   while ($curr_alias) {
      if ($alias == $curr_alias) {
         $result = true;
         break;
      }
      $curr_alias = strtok($delim);
   }
   return $result;
}

// aliases to array
function aliases_toarray($str, $delim = ",") {
   return explode($delim, $str);
}

// aliases str + str_new
function aliases_sum($str, $str_new, $delim = ",") {
   $aliases_old = explode($delim, $str);
   $aliases_new = explode($delim, $str_new);

   foreach ($aliases_new as $num_new=>$alias_new) {
      if ($alias_new == "") continue;
      $alias_exist = false;
      foreach ($aliases_old as $num_old=>$alias_old) {
         if ($alias_new == $alias_old) {
            $alias_exist = true;
            break;
         }
      }
      if (!$alias_exist) $aliases_old[] = $alias_new;
   }
   $result = "";
   foreach ($aliases_old as $num=>$alias) {
      if ($result != "") $result .= $delim;
      $result .= $alias;
   }
   return $result;
}

// *****************************************************************************
// Ttmos_TracksInfo
// *****************************************************************************
class Ttmos_TracksInfo {
   var $xmlparser;
   var $slash;
   var $dirs;
   var $currdir;
   var $files;     // finded files
   var $infs;      // xml headers out
   var $xmlheader; // current

   function Ttmos_TracksInfo($adirs) {
      $this->dirs = $adirs;
      for ($i = 0; $i < $this->dirs['count']; $i++)
         if(substr($this->dirs[$i], -1) == '\\' || substr($this->dirs[$i], -1) == '/') $this->dirs[$i] = substr($this->dirs[$i], 0, -1);
      $this->files = array();
      $this->infs = array();
      $this->currdir = '';
      $this->xmlheader = array();
      $this->slash = '/';
   }
   
   function clear() {
      unset($this->slash);
      unset($this->dirs);
      unset($this->currdir);
      unset($this->files);
      unset($this->infs);
      unset($this->xmlheader);
   }

   function get_track_files($curr_path) {
      if (($curr_dir = @opendir($curr_path)) !== false) {
         while(($curr_rec = readdir($curr_dir)) !== false) {
            if ($curr_rec != '.' && $curr_rec != '..') {
               $curr_rec = $curr_path.$this->slash.$curr_rec;
               if (strtolower(substr($curr_rec, -4)) == '.gbx') {
                  $buffer = $this->get_track_xmlheader($curr_rec);
                  if ($buffer !== -1) $this->files[str_replace($this->currdir.$this->slash, '', $curr_rec)] = $buffer;
               }
               else {
                  $this->get_track_files($curr_rec);
               }
            }
         }
         closedir($curr_dir);
      }
   }

   function get_track_xmlheader($track_filename) {
      if (($fp = @fopen($track_filename, 'rb')) !== false) {
         $buffer = fread($fp, 4096);
         fclose($fp);
         $beg_xml = strpos($buffer, '<hea');
         $end_xml = strpos($buffer, 'der>');
         if($beg_xml !== false && $end_xml !== false)
            $result = substr($buffer, $beg_xml, $end_xml-$beg_xml+4);
         else 
            $result = -1;
      }
      else $result = -1;
      return $result;
   }

   function set_track_xmlheader_tagopen($parser, $name, $attrs) {
      switch (strtolower($name)) {
         case 'header':
            if(strtolower($attrs['type']) == 'challenge') $this->xmlheader['challenge'] = true;
            else $this->xmlheader['challenge'] = false;
            $this->xmlheader['gameversion'] = $attrs['version'];
            break;
         case 'ident':
            if ($this->xmlheader['challenge']) {
               $this->xmlheader['b'] = $attrs['uid'];
               $this->xmlheader['c'] = urldecode($attrs['name']);
               $this->xmlheader['d'] = name_clear(urldecode($attrs['name']));
               if(isset($attrs['author'])) $this->xmlheader['e'] = urldecode($attrs['author']);
               else $this->xmlheader['e'] = 'unknown';
            }
            break;
         case 'desc':
            if ($this->xmlheader['challenge']) {
               if(isset($attrs['envir'])) $this->xmlheader['f'] = $attrs['envir'];
               else $this->xmlheader['f'] = 'unknown';
               if(isset($attrs['mood'])) $this->xmlheader['g'] = $attrs['mood'];
               else $this->xmlheader['g'] = 'unknown';
               // mood, what the fuck ?
               if (preg_match("/^\d\dx\d\d(\w{0,11})/i", $this->xmlheader['g'], $matches))
                  $this->xmlheader['g'] = $matches[1];
               if ($this->xmlheader['g'] == "") $this->xmlheader['g'] = 'unknown';
               if(isset($attrs['type'])) $this->xmlheader['h'] = $attrs['type'];
               else $this->xmlheader['h'] = 'unknown';
               if(isset($attrs['nblaps'])) $this->xmlheader['i'] = $attrs['nblaps'];
               else $this->xmlheader['i'] = 0;
               if(isset($attrs['price'])) $this->xmlheader['j'] = $attrs['price'];
               else $this->xmlheader['j'] = 0;
               if ($this->xmlheader['gameversion'] == "TMc.6") {
                  $this->xmlheader['q'] = 'U';
               }
               else if(isset($attrs['envir'])) {
                  if (strtolower($attrs['envir']) == 'stadium')
                     $this->xmlheader['q'] = 'N';
                  else if (strtolower($attrs['envir']) == 'alpine' ||
                           strtolower($attrs['envir']) == 'desert' ||
                           strtolower($attrs['envir']) == 'rally' ||
                           strtolower($attrs['envir']) == 'speed')
                     $this->xmlheader['q'] = 'O';
                  else if (strtolower($attrs['envir']) == 'island' ||
                           strtolower($attrs['envir']) == 'bay' ||
                           strtolower($attrs['envir']) == 'coast')
                     $this->xmlheader['q'] = 'S';
                  else
                     $this->xmlheader['q'] = 'U';
               }
               else $this->xmlheader['q'] = '?';
            }
            break;
         case 'times':
            if ($this->xmlheader['challenge']) {
               if(isset($attrs['bronze'])) $this->xmlheader['k'] = time_msectofull($attrs['bronze']);
               else $this->xmlheader['k'] = '00:00:00.00';
               if(isset($attrs['silver'])) $this->xmlheader['l'] = time_msectofull($attrs['silver']);
               else $this->xmlheader['l'] = '00:00:00.00';
               if(isset($attrs['gold'])) $this->xmlheader['m'] = time_msectofull($attrs['gold']);
               else $this->xmlheader['m'] = '00:00:00.00';
               if(isset($attrs['authortime'])) $this->xmlheader['n'] = time_msectofull($attrs['authortime']);
               else $this->xmlheader['n'] = '00:00:00.00';
               if(isset($attrs['authorscore'])) $this->xmlheader['o'] = $attrs['authorscore'];
               else $this->xmlheader['o'] = 0;
            }
            break;
      };
   }

   function set_track_xmlheader_tagclose($parser, $name) {
   }

   function set_track_xmlheader_cdata($parser, $data) {
   }

   function parse_track_xmlheaders() {
      foreach($this->files as $track_name=>$track_header) {
         $this->xml_parser = xml_parser_create();
         xml_parser_set_option($this->xml_parser, XML_OPTION_CASE_FOLDING, false);
         xml_set_object($this->xml_parser, $this);
         xml_set_element_handler($this->xml_parser, 'set_track_xmlheader_tagopen', 'set_track_xmlheader_tagclose');
         xml_set_character_data_handler($this->xml_parser, 'set_track_xmlheader_cdata');
         if (!xml_parse($this->xml_parser, $track_header, true)) {
            //echo 'XML : %s line %d', xml_error_string(xml_get_error_code($this->xml_parser)), xml_get_current_line_number($this->xml_parser);
         }
         else if($this->xmlheader['challenge']) {
            $id = get_id($this->xmlheader['b']);
            $this->infs[$id] = $this->xmlheader;
            $this->infs[$id]['p'] = $track_name;
            unset($this->infs[$id]['challenge']);
            unset($this->infs[$id]['gameversion']);
         }
         xml_parser_free($this->xml_parser);
      }
   }

   function cmp($a, $b) {
      return strcasecmp($a['d'], $b['d']);
   }

   function get_tracks_info($sort = false) {
      for ($i = 0; $i < $this->dirs['count']; $i++) {
         if (strpos($this->dirs[$i], "/") !== false)
            $this->slash = "/";
         else if (strpos($this->dirs[$i], "\\") !== false)
            $this->slash = "\\";
         else if (strstr(PHP_OS, 'WIN'))
            $this->slash = "\\";
         else
            $this->slash = "/";
         $this->currdir = $this->dirs[$i];
         $this->get_track_files($this->dirs[$i]);
      }
      $this->parse_track_xmlheaders();
      if ($sort) uasort($this->infs, array("Ttmos_TracksInfo", "cmp"));
      return $this->infs;
   }

} // class


// *****************************************************************************
// Ttmos_DB
// *****************************************************************************
class Ttmos_DB {
   var $db_type;
   var $db_host;
   var $db_name;
   var $db_login;
   var $db_password;
   var $mysql_link;
   var $error_str;

   function Ttmos_DB($config) {
      $this->db_type = $config['dbtype'];
      $this->db_type = "mysql";
      $this->db_host = $config['dbhost'];
      $this->db_name = $config['dbname'];
      $this->db_login = $config['dblogin'];
      $this->db_password = $config['dbpassword'];
      $this->mysql_link = NULL;
   }


// All -------------------------------------------------------------------------
   function check_lib() {
      switch ($this->db_type) {
      case "mysql":
         $result = function_exists('mysql_connect');
         break;
      case "mssql":
         break;
      }
      return $result;
   }
   function check_connection() {
      switch ($this->db_type) {
      case "mysql":
         $result = $this->check_connection_mysql();
         break;
      case "mssql":
         $result = $this->check_connection_mssql();
         break;
      }
      return $result;
   }

   function open() {
      switch ($this->db_type) {
      case "mysql":
         $result = $this->open_mysql();
         break;
      case "mssql":
         break;
      }
   }

   function close() {
      switch($this->db_type) {
      case "mysql":
         $result = $this->close_mysql();
         break;
      case "mssql":
         break;
      }
   }

   function get_db_version() {
      switch ($this->db_type) {
      case "mysql":
         $result = mysql_get_server_info($this->mysql_link);
         break;
      case "mssql":
         break;
      }
      return $result;
   }

   function query($sql) {
      switch($this->db_type) {
      case "mysql":
         $result = $this->query_mysql($sql);
         break;
      case "mssql":
         break;
      }
      return $result;
   }

   function query_assoc($sql, $field1=-1, $field2=-1, $field3=-1) {
      switch($this->db_type) {
      case "mysql":
         $result = $this->query_mysql_assoc($sql, $field1, $field2, $field3);
         break;
      case "mssql":
         break;
      }
      return $result;
   }

   function query_selectpage($sql, $pagenum, $rpp) {
      switch($this->db_type) {
      case "mysql":
         $result = $this->query_selectpage_mysql($sql, $pagenum, $rpp);
         break;
      case "mssql":
         break;
      }
      return $result;
   }

   function query_exec($sql, $safe = false) {
      switch($this->db_type) {
      case "mysql":
         $result = $this->query_exec_mysql($sql, $safe);
         break;
      case "mssql":
         break;
      }
      return $result;
   }

   function get_schema_curr() {
      switch($this->db_type) {
      case "mysql":
         $result = $this->get_schema_curr_mysql();
         break;
      case "mssql":
         break;
      }
      return $result;
   }

   function get_schema_ver() {
      switch($this->db_type) {
      case "mysql":
         $result = $this->get_schema_ver_mysql();
         break;
      case "mssql":
         break;
      }
      return $result;
   }

   function create_tables() {
      switch($this->db_type) {
      case "mysql":
         $result = $this->create_tables_mysql();
         break;
      case "mssql":
         break;
      }
      return $result;
   }

   function drop_tables() {
      switch($this->db_type) {
      case "mysql":
         $result = $this->drop_tables_mysql();
         break;
      case "mssql":
         break;
      }
      return $result;
   }

   function update_tables() {
      switch($this->db_type) {
      case "mysql":
         $result = $this->update_tables_mysql();
         break;
      case "mssql":
         break;
      }
      return $result;
   }

   function get_error() {
      switch($this->db_type) {
      case "mysql":
         $result = $this->get_error_mysql();
         break;
      case "mssql":
         break;
      }
      return $result;
   }


// MySQL -----------------------------------------------------------------------
   function check_connection_mysql() {
      $mysql_tmp = @mysql_connect($this->db_host, $this->db_login, $this->db_password);
      if (!$mysql_tmp || !@mysql_select_db($this->db_name, $mysql_tmp))
         $result = mysql_error();
      else
         $result = "ok";
      @mysql_close($mysql_tmp);
      return $result;
   }

   function open_mysql() {
      if ($this->mysql_link != NULL) die("Ttmos_DB: Already connected");
      $this->mysql_link = mysql_connect($this->db_host, $this->db_login, $this->db_password) or die("Ttmos_DB: ".mysql_error());
      mysql_select_db($this->db_name, $this->mysql_link) or die("Ttmos_DB: ".mysql_error());
      mysql_query("/*!40101 SET NAMES 'utf8' */", $this->mysql_link) or die("Ttmos_DB: ".mysql_error());
   }

   function close_mysql() {
      if ($this->mysql_link == NULL) die("Ttmos_DB: Not connected");
      $result = mysql_close($this->mysql_link) or die("Ttmos_DB: ".mysql_error());
      $this->mysql_link = null;
   }

   function query_mysql($sql) {
      /* slow?
      $query_result = mysql_unbuffered_query($sql, $this->mysql_link) or die("Ttmos_DB: ".mysql_error());
      $result['count'] = 0;
      while($curr_str = mysql_fetch_array($query_result, MYSQL_ASSOC)) {
         $result[$result['count']] = $curr_str;
         $result['count'] += 1;
      }
      */
      $query_result = mysql_query($sql, $this->mysql_link) or die("Ttmos_DB: ".mysql_error());
      $result = array();
      while($curr_str = mysql_fetch_array($query_result, MYSQL_ASSOC))
         $result[] = $curr_str;
      $result['count'] = mysql_num_rows($query_result);
      mysql_free_result($query_result);
      return $result;
   }

   function query_mysql_assoc($sql, $field1, $field2, $field3) {
      //$query_result = mysql_query($sql, $this->mysql_link);
      $query_result = mysql_unbuffered_query($sql, $this->mysql_link) or die("Ttmos_DB: ".mysql_error());
      $result = array();
      if ($field3 != -1) {
         while($curr_str = mysql_fetch_array($query_result, MYSQL_ASSOC)) {
            $result[$curr_str[$field1]][$curr_str[$field2]][$curr_str[$field3]] = $curr_str;
            unset($result[$curr_str[$field1]][$curr_str[$field2]][$curr_str[$field3]][$field3]);
            unset($result[$curr_str[$field1]][$curr_str[$field2]][$curr_str[$field3]][$field2]);
            unset($result[$curr_str[$field1]][$curr_str[$field2]][$curr_str[$field3]][$field1]);
         }
      }
      else if ($field2 != -1) {
         while($curr_str = mysql_fetch_array($query_result, MYSQL_ASSOC)) {
            $result[$curr_str[$field1]][$curr_str[$field2]] = $curr_str;
            unset($result[$curr_str[$field1]][$curr_str[$field2]][$field2]);
            unset($result[$curr_str[$field1]][$curr_str[$field2]][$field1]);
         }
      }
      else if ($field1 != -1) {
         while($curr_str = mysql_fetch_array($query_result, MYSQL_ASSOC)) {
            $result[$curr_str[$field1]] = $curr_str;
            unset($result[$curr_str[$field1]][$field1]);
         }
      }
      mysql_free_result($query_result);
      return $result;
   }

   function query_selectpage_mysql($sql, $pagenum, $rpp) {
      if ($pagenum < 1) die("Ttmos_DB: PageNum < 1");
      if ($rpp < 1) die("Ttmos_DB: RecPerPage < 1");
      $sql .= " LIMIT ".($pagenum-1)*$rpp.", $rpp";
      return $this->query_mysql($sql);
   }

   function query_exec_mysql($sql, $safe) {
      if ($safe)
         $result = @mysql_query($sql, $this->mysql_link);
      else
         $result = mysql_query($sql, $this->mysql_link) or die("Ttmos_DB: ".mysql_error());
      return $result;
   }

   function get_schema_ver_mysql() {
      $db_schema['v0.62'] = array(
            "tmos_servers"=>array("serverid"=>1, "server"=>1, "serverc"=>1, "ip"=>1, "game"=>1,
                                  "login"=>1, "password"=>1, "tracks"=>"1", "logfiles"=>"1", "last_update"=>"1"),
            "tmos_players"=>array("serverid"=>1, "playerid"=>1, "account"=>1, "player"=>1, "playerc"=>1,
                                  "aliases"=>1, "lastonline"=>1, "am"=>1, "gm"=>1, "sm"=>1, "bm"=>1, "score"=>1,
                                  "am_c"=>1, "gm_c"=>1, "sm_c"=>1, "bm_c"=>1, "score_c"=>1),
            "tmos_tracks" =>array("serverid"=>1, "trackid"=>1, "uid"=>1, "track"=>1, "trackc"=>1,
                                  "author"=>1, "envir"=>1, "mood"=>1, "type"=>1, "nblaps"=>1, "price"=>1,
                                  "bronze"=>1, "silver"=>1, "gold"=>1, "authortime"=>1, "authorscore"=>1,
                                  "relpath"=>1),
            "tmos_results"=>array("serverid"=>1, "resultid"=>1, "trackid"=>1, "playerid"=>1, "result"=>1, "ts"=>1),
            "tmos_clans"=>array("serverid"=>1, "clanid"=>1, "clanc"=>1, "description"=>1, "members"=>1, "score"=>1, "score_c"=>1, "tm"=>1),
            "tmos_view"=>array("serverid"=>1, "stats"=>1, "trackid"=>1, "playerid"=>1, "bestresult"=>1, "ts"=>1, "award"=>1, "rank"=>1, "totalresults"=>1)
      );
      $db_schema['v0.61'] = array(
            "tmos_servers"=>array("serverid"=>1, "server"=>1, "serverc"=>1, "ip"=>1, "game"=>1,
                                  "login"=>1, "password"=>1, "tracks"=>"1", "logfiles"=>"1", "last_update"=>"1"),
            "tmos_players"=>array("serverid"=>1, "playerid"=>1, "account"=>1, "player"=>1, "playerc"=>1,
                                  "aliases"=>1, "lastonline"=>1, "am"=>1, "gm"=>1, "sm"=>1, "bm"=>1, "score"=>1,
                                  "am_c"=>1, "gm_c"=>1, "sm_c"=>1, "bm_c"=>1, "score_c"=>1),
            "tmos_tracks" =>array("serverid"=>1, "trackid"=>1, "uid"=>1, "track"=>1, "trackc"=>1,
                                  "author"=>1, "envir"=>1, "mood"=>1, "type"=>1, "nblaps"=>1, "price"=>1,
                                  "bronze"=>1, "silver"=>1, "gold"=>1, "authortime"=>1, "authorscore"=>1,
                                  "relpath"=>1),
            "tmos_results"=>array("serverid"=>1, "resultid"=>1, "trackid"=>1, "playerid"=>1, "result"=>1, "ts"=>1),
            "tmos_clans"=>array("serverid"=>1, "clanid"=>1, "clanc"=>1, "members"=>1, "score"=>1, "score_c"=>1, "tm"=>1),
            "tmos_view"=>array("serverid"=>1, "stats"=>1, "trackid"=>1, "playerid"=>1, "bestresult"=>1, "ts"=>1, "award"=>1, "rank"=>1, "totalresults"=>1)
      );
      $db_schema['v0.60'] = array(
            "tmos_servers"=>array("serverid"=>1, "server"=>1, "serverc"=>1, "ip"=>1, "game"=>1,
                                  "login"=>1, "password"=>1, "tracks"=>"1", "logfiles"=>"1", "last_update"=>"1"),
            "tmos_players"=>array("serverid"=>1, "playerid"=>1, "account"=>1, "player"=>1, "playerc"=>1,
                                  "aliases"=>1, "lastonline"=>1, "am"=>1, "gm"=>1, "sm"=>1, "bm"=>1, "score"=>1,
                                  "am_c"=>1, "gm_c"=>1, "sm_c"=>1, "bm_c"=>1, "score_c"=>1),
            "tmos_tracks" =>array("serverid"=>1, "trackid"=>1, "uid"=>1, "track"=>1, "trackc"=>1,
                                  "author"=>1, "envir"=>1, "mood"=>1, "type"=>1, "nblaps"=>1, "price"=>1,
                                  "bronze"=>1, "silver"=>1, "gold"=>1, "authortime"=>1, "authorscore"=>1,
                                  "relpath"=>1),
            "tmos_results"=>array("serverid"=>1, "resultid"=>1, "trackid"=>1, "playerid"=>1, "result"=>1, "ts"=>1),
            "tmos_clans"=>array("serverid"=>1, "clanid"=>1, "clanc"=>1, "members"=>1, "score"=>1, "score_c"=>1, "tm"=>1),
            "tmos_view"=>array("serverid"=>1, "stats"=>1, "trackid"=>1, "playerid"=>1, "bestresult"=>1, "ts"=>1, "award"=>1, "rank"=>1)
      );
      $db_schema['v0.51'] = array(
            "tmos_servers"=>array("serverid"=>1, "server"=>1, "serverc"=>1, "ip"=>1, "game"=>1,
                                  "login"=>1, "password"=>1, "tracksdir"=>"1", "logfile"=>"1", "parse_position"=>"1",
                                  "parse_track"=>"1", "parse_str"=>"1", "parse_last"=>"1"),
            "tmos_players"=>array("serverid"=>1, "playerid"=>1, "account"=>1, "ip"=>1, "player"=>1, "playerc"=>1,
                                  "nation"=>"1", "aliases"=>1, "lastonline"=>1, "am"=>1, "gm"=>1, "sm"=>1, "bm"=>1,
                                  "score"=>1, "rank"=>1),
            "tmos_tracks" =>array("serverid"=>1, "trackid"=>1, "uid"=>1, "track"=>1, "trackc"=>1,
                                  "author"=>1, "envir"=>1, "mood"=>1, "type"=>1, "nblaps"=>1, "price"=>1,
                                  "bronze"=>1, "silver"=>1, "gold"=>1, "authortime"=>1, "authorscore"=>1,
                                  "filename"=>1),
            "tmos_results"=>array("serverid"=>1, "trackid"=>1, "playerid"=>1, "besttime"=>1, "ts"=>1, "award"=>1),
      );
      $db_schema['v0.50'] = array(
            "tmos_servers"=>array("serverid"=>1, "server"=>1, "serverc"=>1, "ip"=>1, "game"=>1,
                                  "login"=>1, "password"=>1, "tracksdir"=>"1", "logfile"=>"1", "parse_position"=>"1",
                                  "parse_track"=>"1", "parse_str"=>"1", "parse_last"=>"1"),
            "tmos_players"=>array("serverid"=>1, "playerid"=>1, "player"=>1, "playerc"=>1, "account"=>1, "ip"=>1,
                                  "nation"=>"1", "am"=>1, "gm"=>1, "sm"=>1, "bm"=>1,
                                  "score"=>1, "rank"=>1),
            "tmos_tracks" =>array("serverid"=>1, "trackid"=>1, "uid"=>1, "track"=>1, "trackc"=>1,
                                  "author"=>1, "envir"=>1, "mood"=>1, "type"=>1, "nblaps"=>1, "price"=>1,
                                  "bronze"=>1, "silver"=>1, "gold"=>1, "authortime"=>1, "authorscore"=>1,
                                  "filename"=>1),
            "tmos_results"=>array("serverid"=>1, "trackid"=>1, "playerid"=>1, "besttime"=>1, "ts"=>1, "award"=>1),
      );
      $db_schema['v0.30/v0.40/v0.41/v0.42/v0.43/v0.44'] = array(
            "tmos_players"=>array("id"=>1, "player"=>1, "ip"=>1, "am"=>1, "gm"=>1, "sm"=>1, "bm"=>1, "score"=>1),
            "tmos_tracks" =>array("id"=>1, "uid"=>1, "name"=>1, "author"=>1, "envir"=>1, "mood"=>1, "type"=>1,
                                  "nblaps"=>1, "price"=>1, "bronze"=>1, "silver"=>1, "gold"=>1, "authortime"=>1,
                                  "authorscore"=>1, "filename"=>1),
            "tmos_results"=>array("trackid"=>1, "playerid"=>1, "besttime"=>1, "ts"=>1, "prize"=>1),
      );


      $result['ver_curr'] = "unk";
      $result['ver_last'] = "v0.62";
      $result['update'] = false;
      $result['support'] = false;
      foreach ($db_schema as $db_version=>$tables) {
         $tmp = $this->get_schema_mysql($tables);
         $this_ver = true;
         foreach ($tmp as $curr_table=>$table_inf) {
            if ($table_inf['status'] != "1") {
               $this_ver = false;
               break;
            }
         }
         if ($this_ver) {
            $result['ver_curr'] = $db_version;
            if ($result['ver_curr'] != $result['ver_last']) $result['update'] = true;
            if ($result['ver_curr'] != 'v0.30/v0.40/v0.41/v0.42/v0.43/v0.44') $result['support'] = true;
            break;
         }
      }
      return $result;
   }

   function get_schema_mysql($db_schema) {
      $db_schema_exists = array();
      $tables = mysql_list_tables($this->db_name, $this->mysql_link);
      while ($curr_table = mysql_fetch_row($tables)) {
         $fields = mysql_list_fields($this->db_name, $curr_table[0], $this->mysql_link);
         $columns = mysql_num_fields($fields);
         for ($i = 0; $i < $columns; $i++) {
            $db_schema_exists[$curr_table[0]][mysql_field_name($fields, $i)] = "1";
         }
         mysql_free_result($fields);
      }
      mysql_free_result($tables);

      foreach ($db_schema as $curr_table=>$fields) {
         if (!isset($db_schema_exists[$curr_table])) {
            $result[$curr_table]["status"] = "0";
            $result[$curr_table]["record_count"] = "-";
         }
         else {
            $result[$curr_table]["status"] = "1";
            foreach ($fields as $curr_field=>$tmp)
               if (!isset($db_schema_exists[$curr_table][$curr_field])) {
                  $result[$curr_table]["status"] = "-1";
                  $result[$curr_table]["record_count"] = "-";
               }
            if ($result[$curr_table]["status"] == "1") {
                  $tmp = $this->query_mysql("select count(*) as record_count from $curr_table");
                  $result[$curr_table]["record_count"] = $tmp[0]['record_count'];
            }
         }
      }

      return $result;
   }

   function get_schema_curr_mysql() {
      $db_schema = array(
            "tmos_servers"=>array("serverid"=>1, "server"=>1, "serverc"=>1, "ip"=>1, "game"=>1,
                                  "login"=>1, "password"=>1, "tracks"=>"1", "logfiles"=>"1", "last_update"=>"1"),
            "tmos_players"=>array("serverid"=>1, "playerid"=>1, "account"=>1, "player"=>1, "playerc"=>1,
                                  "aliases"=>1, "lastonline"=>1, "am"=>1, "gm"=>1, "sm"=>1, "bm"=>1, "score"=>1,
                                  "am_c"=>1, "gm_c"=>1, "sm_c"=>1, "bm_c"=>1, "score_c"=>1),
            "tmos_tracks" =>array("serverid"=>1, "trackid"=>1, "uid"=>1, "track"=>1, "trackc"=>1,
                                  "author"=>1, "envir"=>1, "mood"=>1, "type"=>1, "nblaps"=>1, "price"=>1,
                                  "bronze"=>1, "silver"=>1, "gold"=>1, "authortime"=>1, "authorscore"=>1,
                                  "relpath"=>1),
            "tmos_results"=>array("serverid"=>1, "resultid"=>1, "trackid"=>1, "playerid"=>1, "result"=>1, "ts"=>1),
            "tmos_clans"=>array("serverid"=>1, "clanid"=>1, "clanc"=>1, "description"=>1, "members"=>1, "score"=>1, "score_c"=>1, "tm"=>1),
            "tmos_view"=>array("serverid"=>1, "stats"=>1, "trackid"=>1, "playerid"=>1, "bestresult"=>1, "ts"=>1, "award"=>1, "rank"=>1, "totalresults"=>1)
      );
      return $this->get_schema_mysql($db_schema);
   }

   function create_tables_mysql($prefix = "") {
      if (!$this->query_exec_mysql("
CREATE TABLE IF NOT EXISTS `{$prefix}tmos_clans` (
  `serverid` int(10) unsigned NOT NULL default '0',
  `clanid` int(10) unsigned NOT NULL auto_increment,
  `clanc` varchar(60) NOT NULL default '',
  `description` text NOT NULL,
  `members` text NOT NULL,
  `score` double NOT NULL default '0',
  `score_c` double NOT NULL default '0',
  `tm` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`serverid`,`clanid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8", true) ||
      !$this->query_exec_mysql("
CREATE TABLE IF NOT EXISTS `{$prefix}tmos_players` (
  `serverid` int(10) unsigned NOT NULL default '0',
  `playerid` varchar(".PS_ID_LENGTH.") NOT NULL default '',
  `account` varchar(60) NOT NULL default '',
  `player` varchar(60) NOT NULL default '',
  `playerc` varchar(60) NOT NULL default '',
  `aliases` text NOT NULL,
  `lastonline` varchar(19) NOT NULL default '',
  `am` int(10) unsigned NOT NULL default '0',
  `gm` int(10) unsigned NOT NULL default '0',
  `sm` int(10) unsigned NOT NULL default '0',
  `bm` int(10) unsigned NOT NULL default '0',
  `score` double NOT NULL default '0',
  `am_c` int(10) unsigned NOT NULL default '0',
  `gm_c` int(10) unsigned NOT NULL default '0',
  `sm_c` int(10) unsigned NOT NULL default '0',
  `bm_c` int(10) unsigned NOT NULL default '0',
  `score_c` double NOT NULL default '0',
  PRIMARY KEY  (`serverid`,`playerid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8", true) ||
      !$this->query_exec_mysql("
CREATE TABLE IF NOT EXISTS `{$prefix}tmos_results` (
  `serverid` int(10) unsigned NOT NULL default '0',
  `resultid` varchar(".PS_ID_LENGTH.") NOT NULL default '0',
  `trackid` varchar(".PS_ID_LENGTH.") NOT NULL default '0',
  `playerid` varchar(".PS_ID_LENGTH.") NOT NULL default '0',
  `result` varchar(11) NOT NULL default '',
  `ts` varchar(19) NOT NULL default '',
  PRIMARY KEY  (`serverid`,`resultid`),
  KEY `results_asc` TYPE BTREE (`serverid`,`trackid`,`result`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8", true) ||
      !$this->query_exec_mysql("
CREATE TABLE IF NOT EXISTS `{$prefix}tmos_servers` (
  `serverid` int(10) unsigned NOT NULL auto_increment,
  `server` varchar(60) NOT NULL default '',
  `serverc` varchar(60) NOT NULL default '',
  `ip` varchar(128) NOT NULL default '',
  `game` varchar(10) NOT NULL default '',
  `login` varchar(30) NOT NULL default '',
  `password` varchar(30) NOT NULL default '',
  `tracks` text NOT NULL,
  `logfiles` text NOT NULL,
  `last_update` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`serverid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8", true) ||
      !$this->query_exec_mysql("
CREATE TABLE IF NOT EXISTS `{$prefix}tmos_tracks` (
  `serverid` int(10) unsigned NOT NULL default '0',
  `trackid` varchar(".PS_ID_LENGTH.") NOT NULL default '',
  `uid` varchar(30) NOT NULL default '',
  `track` varchar(60) NOT NULL default '',
  `trackc` varchar(60) NOT NULL default '',
  `author` varchar(60) NOT NULL default '',
  `envir` varchar(10) NOT NULL default '',
  `mood` varchar(10) NOT NULL default '',
  `type` varchar(10) NOT NULL default '',
  `nblaps` int(10) unsigned NOT NULL default '0',
  `price` int(10) unsigned NOT NULL default '0',
  `bronze` varchar(11) NOT NULL default '',
  `silver` varchar(11) NOT NULL default '',
  `gold` varchar(11) NOT NULL default '',
  `authortime` varchar(11) NOT NULL default '',
  `authorscore` int(10) unsigned NOT NULL default '0',
  `relpath` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`serverid`,`trackid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8", true) ||
   !$this->query_exec_mysql("
CREATE TABLE IF NOT EXISTS `{$prefix}tmos_view` (
  `serverid` int(10) unsigned NOT NULL default '0',
  `stats` char(1) NOT NULL default '',
  `trackid` varchar(".PS_ID_LENGTH.") NOT NULL default '',
  `playerid` varchar(".PS_ID_LENGTH.") NOT NULL default '',
  `bestresult` varchar(11) NOT NULL default '',
  `ts` varchar(19) NOT NULL default '',
  `award` char(1) NOT NULL default '',
  `rank` int(10) NOT NULL default '0',
  `totalresults` varchar(60) NOT NULL default '',
  PRIMARY KEY  (`trackid`,`playerid`,`serverid`,`stats`),
  KEY `rank_asc` TYPE BTREE (`rank`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8", true))
         $result = false;
      else
         $result = true;
      return $result;
   }

   function drop_tables_mysql() {
      return $this->query_exec_mysql("drop table if exists tmos_servers, tmos_players, tmos_tracks, tmos_results, tmos_view, tmos_clans", true);
   }

   function update_tables_mysql() {
      $schema_ver = $this->get_schema_ver_mysql();
      switch ($schema_ver['ver_curr']) {

      case 'v0.61':
      // update from v0.61 to v0.62 ---------------------------------------------------------------------------------

      $this->query_exec_mysql("delete from tmos_clans", false);
      $this->query_exec_mysql("delete from tmos_view", false);
      $this->query_exec_mysql("alter table tmos_clans add column description text NOT NULL after clanc", false);
      $this->query_exec_mysql("alter table tmos_view modify column rank int(10) NOT NULL default '0'", false);
      $this->query_exec_mysql("alter table tmos_view modify column totalresults varchar(60) NOT NULL default ''", false);

      // update from v0.61 to v0.62 ---------------------------------------------------------------------------------
      break;

      case 'v0.60':
      // update from v0.60 to v0.62 ---------------------------------------------------------------------------------

      $this->query_exec_mysql("delete from tmos_clans", false);
      $this->query_exec_mysql("delete from tmos_view", false);
      $this->query_exec_mysql("alter table tmos_clans add column description text NOT NULL after clanc", false);
      $this->query_exec_mysql("alter table tmos_view modify column rank int(10) NOT NULL default '0'", false);
      $this->query_exec_mysql("alter table tmos_view add column totalresults varchar(60) NOT NULL default '' after rank", false);

      // update from v0.60 to v0.62 ---------------------------------------------------------------------------------
      break;

      case 'v0.51':
      // update from v0.51 to v0.62 ---------------------------------------------------------------------------------

      $this->create_tables_mysql("new_");
      // servers
      $tmp = $this->query_mysql("select * from tmos_servers");
      $sql = "insert into new_tmos_servers (serverid, server, serverc, ip, game, login, password, tracks, logfiles, last_update) values ";
      for ($i = 0; $i < $tmp['count']; $i++) {
         $sql .= "({$tmp[$i]['serverid']},'".addslashes($tmp[$i]['server'])."','".addslashes($tmp[$i]['serverc'])."','".addslashes($tmp[$i]['ip'])."','{$tmp[$i]['game']}','".addslashes($tmp[$i]['login'])."','".addslashes($tmp[$i]['password'])."','".addslashes($tmp[$i]['tracksdir'])."','".addslashes($tmp[$i]['logfile'])."*0*x*x;',0),";
      }
      if (strlen($sql) > 125) {
         $sql = substr($sql, 0, -1);
         $this->query_exec_mysql($sql, false);
      }
      // players by one
      $tmos_players = $this->query_mysql_assoc("select * from tmos_players", "playerid", -1, -1);
      foreach ($tmos_players as $pid=>$pinf) {
         if ($pinf['ip'] != "") {
            $tmos_players[$pid]['playerid'] = get_id(name_clear($pinf['account']));
            $tmos_players[$pid]['account']= name_clear($pinf['account']);
         }
         else {
            $tmos_players[$pid]['playerid'] = get_id($pinf['account']);
            $tmos_players[$pid]['account']= $pinf['account'];
         }
      }
      foreach ($tmos_players as $pid=>$pinf) {
         $sql = "insert ignore into new_tmos_players (serverid, playerid, account, player, playerc, aliases, lastonline, am, gm, sm, bm, score, am_c, gm_c, sm_c, bm_c, score_c) values ";
         $sql .= "({$pinf['serverid']},'{$pinf['playerid']}','".addslashes($pinf['account'])."','".addslashes($pinf['player'])."','".addslashes($pinf['playerc'])."','".addslashes($pinf['aliases'])."','{$pinf['lastonline']}',0,0,0,0,0,0,0,0,0,0)";
         $this->query_exec_mysql($sql, false);
      }
      // tracks
      $tmos_tracks = $this->query_mysql_assoc("select * from tmos_tracks", "trackid", -1, -1);
      foreach ($tmos_tracks as $tid=>$tinf) {
         if ($tinf['uid'] != '-') $tmos_tracks[$tid]['trackid'] = get_id($tinf['uid']);
         else $tmos_tracks[$tid]['trackid'] = "unknown";
      }
      $sql = "insert ignore into new_tmos_tracks (serverid, trackid, uid, track, trackc, author, envir, mood, type, nblaps, price, bronze, silver, gold, authortime, authorscore, relpath) values ";
      foreach ($tmos_tracks as $tid=>$tinf) {
         $sql .= "({$tinf['serverid']},'{$tinf['trackid']}','{$tinf['uid']}','".addslashes($tinf['track'])."','".addslashes($tinf['trackc'])."','".addslashes($tinf['author'])."','{$tinf['envir']}','{$tinf['mood']}','{$tinf['type']}',{$tinf['nblaps']},{$tinf['price']},'{$tinf['bronze']}','{$tinf['silver']}','{$tinf['gold']}','{$tinf['authortime']}',{$tinf['authorscore']},'-'),";
      }
      if (strlen($sql) > 185) {
         $sql = substr($sql, 0, -1);
         $this->query_exec_mysql($sql, false);
      }
      // results by pages
      $pages_count = $this->query_mysql("select count(*) as tr from tmos_results");
      $pages_count = floor($pages_count[0]['tr']/PS_DB_INSERT_RECS_COUNT)+1;
      for ($j = 0; $j < $pages_count; $j++) {
         $tmp = $this->query_mysql("select * from tmos_results limit ".($j*PS_DB_INSERT_RECS_COUNT).",".PS_DB_INSERT_RECS_COUNT);
         $sql = "insert into new_tmos_results (serverid, resultid, trackid, playerid, result, ts) values ";
         for ($i = 0; $i < $tmp['count']; $i++) {
            $sql .= "({$tmp[$i]['serverid']},'".get_id($tmos_players[$tmp[$i]['playerid']]['account'].$tmos_tracks[$tmp[$i]['trackid']]['uid'].str_replace(" ", "", $tmp[$i]['ts']))."','{$tmos_tracks[$tmp[$i]['trackid']]['trackid']}','{$tmos_players[$tmp[$i]['playerid']]['playerid']}','{$tmp[$i]['besttime']}','{$tmp[$i]['ts']}'),";
         }
         if (strlen($sql) > 90) {
            $sql = substr($sql, 0, -1);
            $this->query_exec_mysql($sql, false);
         }
      }
      // delete bad tracks
      $this->query_exec_mysql("delete from new_tmos_tracks where trackid='unknown'", false);
      // del bad results
      $this->query_exec_mysql("delete from new_tmos_results where trackid='unknown'", false);
      // rename tables
      $this->query_exec_mysql("drop table if exists tmos_servers, tmos_players, tmos_tracks, tmos_results, tmos_view, tmos_clans", true);
      $this->query_exec_mysql("alter table new_tmos_servers rename to tmos_servers", false);
      $this->query_exec_mysql("alter table new_tmos_players rename to tmos_players", false);
      $this->query_exec_mysql("alter table new_tmos_tracks rename to tmos_tracks", false);
      $this->query_exec_mysql("alter table new_tmos_results rename to tmos_results", false);
      $this->query_exec_mysql("alter table new_tmos_view rename to tmos_view", false);
      $this->query_exec_mysql("alter table new_tmos_clans rename to tmos_clans", false);

      // update from v0.51 to v0.62 ---------------------------------------------------------------------------------
      break;

      case 'v0.50':
      // update from v0.50 to v0.62 ---------------------------------------------------------------------------------

      $this->create_tables_mysql("new_");
      // servers
      $tmp = $this->query_mysql("select * from tmos_servers");
      $sql = "insert into new_tmos_servers (serverid, server, serverc, ip, game, login, password, tracks, logfiles, last_update) values ";
      for ($i = 0; $i < $tmp['count']; $i++) {
         $sql .= "({$tmp[$i]['serverid']},'".addslashes($tmp[$i]['server'])."','".addslashes($tmp[$i]['serverc'])."','".addslashes($tmp[$i]['ip'])."','{$tmp[$i]['game']}','".addslashes($tmp[$i]['login'])."','".addslashes($tmp[$i]['password'])."','".addslashes($tmp[$i]['tracksdir'])."','".addslashes($tmp[$i]['logfile'])."*0*x*x;',0),";
      }
      if (strlen($sql) > 125) {
         $sql = substr($sql, 0, -1);
         $this->query_exec_mysql($sql, false);
      }
      // players by one
      $tmos_players = $this->query_mysql_assoc("select * from tmos_players", "playerid", -1, -1);
      foreach ($tmos_players as $pid=>$pinf) {
         if ($pinf['ip'] != "") {
            if (preg_match("/(.+)\/\d+\.\d+\.\d+\.\d+:\d+/u", $pinf['account'], $matches)) $pinf['account'] = $matches[1];
            $tmos_players[$pid]['playerid'] = get_id(name_clear($pinf['account']));
            $tmos_players[$pid]['account']= name_clear($pinf['account']);
         }
         else {
            $tmos_players[$pid]['playerid'] = get_id($pinf['account']);
            $tmos_players[$pid]['account']= $pinf['account'];
         }
      }
      foreach ($tmos_players as $pid=>$pinf) {
         $sql = "insert ignore into new_tmos_players (serverid, playerid, account, player, playerc, aliases, lastonline, am, gm, sm, bm, score, am_c, gm_c, sm_c, bm_c, score_c) values ";
         $sql .= "({$pinf['serverid']},'{$pinf['playerid']}','".addslashes($pinf['account'])."','".addslashes($pinf['player'])."','".addslashes($pinf['playerc'])."','".addslashes($pinf['player'])."','-',0,0,0,0,0,0,0,0,0,0)";
         $this->query_exec_mysql($sql, false);
      }
      // tracks
      $tmos_tracks = $this->query_mysql_assoc("select * from tmos_tracks", "trackid", -1, -1);
      foreach ($tmos_tracks as $tid=>$tinf) {
         if ($tinf['uid'] != '-') $tmos_tracks[$tid]['trackid'] = get_id($tinf['uid']);
         else $tmos_tracks[$tid]['trackid'] = "unknown";
      }
      $sql = "insert ignore into new_tmos_tracks (serverid, trackid, uid, track, trackc, author, envir, mood, type, nblaps, price, bronze, silver, gold, authortime, authorscore, relpath) values ";
      foreach ($tmos_tracks as $tid=>$tinf) {
         $sql .= "({$tinf['serverid']},'{$tinf['trackid']}','{$tinf['uid']}','".addslashes($tinf['track'])."','".addslashes($tinf['trackc'])."','".addslashes($tinf['author'])."','{$tinf['envir']}','{$tinf['mood']}','{$tinf['type']}',{$tinf['nblaps']},{$tinf['price']},'{$tinf['bronze']}','{$tinf['silver']}','{$tinf['gold']}','{$tinf['authortime']}',{$tinf['authorscore']},'-'),";
      }
      if (strlen($sql) > 185) {
         $sql = substr($sql, 0, -1);
         $this->query_exec_mysql($sql, false);
      }
      // results by pages
      $pages_count = $this->query_mysql("select count(*) as tr from tmos_results");
      $pages_count = floor($pages_count[0]['tr']/PS_DB_INSERT_RECS_COUNT)+1;
      for ($j = 0; $j < $pages_count; $j++) {
         $tmp = $this->query_mysql("select * from tmos_results limit ".($j*PS_DB_INSERT_RECS_COUNT).",".PS_DB_INSERT_RECS_COUNT);
         $sql = "insert into new_tmos_results (serverid, resultid, trackid, playerid, result, ts) values ";
         for ($i = 0; $i < $tmp['count']; $i++) {
            $sql .= "({$tmp[$i]['serverid']},'".get_id($tmos_players[$tmp[$i]['playerid']]['account'].$tmos_tracks[$tmp[$i]['trackid']]['uid'].str_replace(" ", "", $tmp[$i]['ts']))."','{$tmos_tracks[$tmp[$i]['trackid']]['trackid']}','{$tmos_players[$tmp[$i]['playerid']]['playerid']}','{$tmp[$i]['besttime']}','{$tmp[$i]['ts']}'),";
         }
         if (strlen($sql) > 90) {
            $sql = substr($sql, 0, -1);
            $this->query_exec_mysql($sql, false);
         }
      }
      // delete bad tracks
      $this->query_exec_mysql("delete from new_tmos_tracks where trackid='unknown'", false);
      // del bad results
      $this->query_exec_mysql("delete from new_tmos_results where trackid='unknown'", false);
      // rename tables
      $this->query_exec_mysql("drop table if exists tmos_servers, tmos_players, tmos_tracks, tmos_results, tmos_view, tmos_clans", true);
      $this->query_exec_mysql("alter table new_tmos_servers rename to tmos_servers", false);
      $this->query_exec_mysql("alter table new_tmos_players rename to tmos_players", false);
      $this->query_exec_mysql("alter table new_tmos_tracks rename to tmos_tracks", false);
      $this->query_exec_mysql("alter table new_tmos_results rename to tmos_results", false);
      $this->query_exec_mysql("alter table new_tmos_view rename to tmos_view", false);
      $this->query_exec_mysql("alter table new_tmos_clans rename to tmos_clans", false);

      // update from v0.50 to v0.62 ---------------------------------------------------------------------------------
      break;
      }

      return true;
   }

   function get_error_mysql() {
      return mysql_error();
   }

// MSSQL -----------------------------------------------------------------------
   function check_connection_mssql() {
      return false;
   }

} // class


// *****************************************************************************
// Ttmos_LogParser
// *****************************************************************************
class Ttmos_LogParser {
   var $status;
   var $db;
   var $servers;

   var $cfg;
   var $cfg_cp;

   var $am_score;
   var $gm_score;
   var $sm_score;
   var $bm_score;
   var $fh_score;
   var $max_score;
   var $max_recs;
   var $days_delta;
   var $min_clan;

   var $log_players;
   var $log_tracks;
   var $log_results;

   function Ttmos_LogParser() {
      $this->cfg = config_load();
      $this->cfg_cp = config_mp_load();
      $this->status = null;
      $this->db = null;
      $this->servers = null;
      $this->am_score = $this->cfg['amscore'];
      $this->gm_score = $this->cfg['gmscore'];
      $this->sm_score = $this->cfg['smscore'];
      $this->bm_score = $this->cfg['bmscore'];
      $this->fh_score = $this->cfg['finishscore'];
      $this->max_recs = PS_DB_INSERT_RECS_COUNT;
      $this->days_delta = $this->cfg['timeperiod'];
      $this->min_clan = $this->cfg['minclansize'];
   }

   function GoGoGo($aservers) {

      $this->status = array();
      $this->db = new Ttmos_DB($this->cfg);
      $this->db->open();

      $this->servers = $this->db->query("select * from tmos_servers");
      if ($this->servers['count'] == 0) 
         return $this->status;

      for ($i = 0; $i < $this->servers['count']; $i++) {
         if (($aservers == "all" || isset($aservers[$this->servers[$i]['serverid']])) && (time() - $this->servers[$i]['last_update'] > PS_MIN_TIME_BETWEEN_PARSING)) {
            $this->status[$this->servers[$i]['serverc']]['skipped'] = false;

            $this->db->query_exec("update tmos_servers set last_update = 1 where serverid = {$this->servers[$i]['serverid']}");

            $this->servers[$i]['logfiles'] = split_logs($this->servers[$i]['logfiles'], false);
            $this->servers[$i]['tracks'] = split_tracks($this->servers[$i]['tracks']);

            $this->status[$this->servers[$i]['serverc']]['logscount'] = $this->servers[$i]['logfiles']['count'];

            $this->log_tracks = $this->db->query_assoc("select trackid as a, uid as b, track as c, trackc as d, author as e, envir as f, mood as g, type as h, nblaps as i, price as j, bronze as k, silver as l, gold as m, authortime as n, authorscore as o, relpath as p from tmos_tracks where serverid = {$this->servers[$i]['serverid']}", "a");
            $this->log_players = $this->db->query_assoc("select playerid as a, account as b, player as c, aliases as d, lastonline as e, 0 as f, 0 as g, 0 as h, 0 as i, 0 as j, 0 as k, 0 as l, 0 as m, 0 as n, 0 as o, 0 as p, 0 as q from tmos_players where serverid = {$this->servers[$i]['serverid']}", "a");

            for ($j = 0; $j < $this->servers[$i]['logfiles']['count']; $j++) {
               $this->servers[$i]['logfiles'][$j]['global'] = 0;
               $this->log_results = array();
               $this->parse_logfile($this->servers[$i]['serverid'], $this->servers[$i]['tracks'], $this->servers[$i]['logfiles'][$j]);
               unset($this->log_results);
               $this->status[$this->servers[$i]['serverc']][$j]['logfile'] = $this->servers[$i]['logfiles'][$j]['logfile'];
               $this->status[$this->servers[$i]['serverc']][$j]['status'] = $this->servers[$i]['logfiles'][$j]['global'];
            }

            if ($this->check_tracks()) {
               $this->find_tracks($this->servers[$i]['tracks']);
               $this->refresh_track_list($this->servers[$i]['serverid']);
            }
            if (count($this->log_players) > 0) {
               $this->check_players($this->servers[$i]['serverid']);
               $this->refresh_score_list($this->servers[$i]['serverid']);
               $this->refresh_player_list($this->servers[$i]['serverid']);
               $this->refresh_clans_list($this->servers[$i]['serverid']);
            }

            unset($this->log_tracks);
            unset($this->log_players);

            $this->servers[$i]['logfiles'] = merge_logs($this->servers[$i]['logfiles'], false);
            $this->db->query_exec("update tmos_servers set logfiles = '".addslashes($this->servers[$i]['logfiles'])."',
                                                           last_update = ".time()." where serverid = {$this->servers[$i]['serverid']}");
         }
         else {
            $this->status[$this->servers[$i]['serverc']]['skipped'] = true;
         }
      }

      $this->db->close();

      return $this->status;
   } 


   function parse_logfile($sid, $tracksdirs, &$log_curr) {
      $log_file = null;
      $curr_track = "x";
      $trackid = "x";
      $playerid = "x";
      $resultid = "x";
      $results_count = 0;
      $curr_offset = 0;
      $curr_buffer = "x";

      for ($i = 0; $i < $tracksdirs['count']; $i++)
         if (!file_exists($tracksdirs[$i])) $log_curr['global'] = -1;

      if ($log_curr['global'] != 0) {
      }
      else if (!file_exists($log_curr['logfile']))
         $log_curr['global'] = -2;
      else if (!is_readable($log_curr['logfile']))
         $log_curr['global'] = -3;
      else if (($log_file = @fopen($log_curr['logfile'], "rb")) == false)
         $log_curr['global'] = -4;
      else if (@fseek($log_file, $log_curr['parse_position']) == -1 ||
               md5(strtok(fgets($log_file, 2046),"\x0D\x0A")) !== $log_curr['parse_str']) {
         @fseek($log_file, 0);
         $log_curr['parse_position'] = 0;
         $log_curr['parse_track'] = 'x';
         $log_curr['parse_str'] = 'x';
      }
      else {
         $curr_track = $log_curr['parse_track'];
         $trackid = get_id($curr_track);
      }

      if ($log_curr['global'] != 0) return;

      while (!feof($log_file)) {
         $curr_line = array();
         $curr_offset = ftell($log_file);
         $curr_buffer = fgets($log_file, 2046);
         $curr_line['date'] = substr(strtok(str_replace("\xEF\xBB\xBF", "", $curr_buffer), ' '), 1);
         $curr_line['time'] = substr(strtok(' '), 0, -1);

         switch (strtok(' ')) {
         case '<time>':
            if ($curr_track == "x") continue;
            $curr_line['playerinf'] = strtok("\x0D\x0A");
            if (preg_match("/^\[(.+) \((.+)\)\] (.+)/u", $curr_line['playerinf'], $matches)) {
               $curr_line['account'] = $matches[1];
               $curr_line['player'] = $matches[2];
               $curr_line['result'] = time_full($matches[3]);
            }
            else if (preg_match("/(.+) by (.+)/u", $curr_line['playerinf'], $matches)) {
               $curr_line['account'] = $matches[2];
               $curr_line['player'] = "unnamed";
               $curr_line['result'] = time_full($matches[1]);
            }
            else {
               continue;
            }
            if (preg_match("/(.+)\/\d+\.\d+\.\d+\.\d+:\d+/u", $curr_line['account'], $matches)) {
               $curr_line['account'] = name_clear($matches[1]);
            }
            else {
               if ($curr_line['player'] == "unnamed") $curr_line['player'] = $curr_line['account'];
            }
            $curr_line['account'] = trim($curr_line['account']);
            $curr_line['player'] = trim($curr_line['player']);

            $playerid = get_id($curr_line['account']);

            if (!isset($this->log_players[$playerid])) {
               $this->log_players[$playerid]['b'] = $curr_line['account'];
               $this->log_players[$playerid]['c'] = $curr_line['player'];
               $this->log_players[$playerid]['d'] = $curr_line['player'] = str_replace(",", "_", $curr_line['player']);
               $this->log_players[$playerid]['e'] = time_stamp($curr_line['date'], $curr_line['time']);
               $this->log_players[$playerid]['f'] = 0;
               $this->log_players[$playerid]['g'] = 0;
               $this->log_players[$playerid]['h'] = 0;
               $this->log_players[$playerid]['i'] = 0;
               $this->log_players[$playerid]['j'] = 0;
               $this->log_players[$playerid]['k'] = 0;
               $this->log_players[$playerid]['l'] = 0;
               $this->log_players[$playerid]['m'] = 0;
               $this->log_players[$playerid]['n'] = 0;
               $this->log_players[$playerid]['o'] = 0;
               $this->log_players[$playerid]['p'] = 0;
               $this->log_players[$playerid]['q'] = 0;
            }
            else {
               $this->log_players[$playerid]['c'] = $curr_line['player'];
               $this->log_players[$playerid]['d'] = aliases_sum($this->log_players[$playerid]['d'], str_replace(",", "_", $curr_line['player']));
               $this->log_players[$playerid]['e'] = time_stamp($curr_line['date'], $curr_line['time']);
            }
            if ($curr_line['result'] != "00:00:00.00") {
               $results_count += 1;

               $resultid = get_id($curr_line['account'].$curr_track.$curr_line['date'].$curr_line['time']);
               $this->log_results[$resultid]['b'] = $trackid;
               $this->log_results[$resultid]['c'] = $playerid;
               $this->log_results[$resultid]['d'] = $curr_line['result'];
               $this->log_results[$resultid]['e'] = time_stamp($curr_line['date'], $curr_line['time']);
               if ($results_count > $this->max_recs) {
                  $this->refresh_result_list($sid);
                  $results_count = 0;
                  $this->log_results = array();
               }
            }
            break;

         case 'Loading':
            $curr_line['trackinf'] = strtok(' ');
            $curr_line['trackinf'] = strtok("\x0D\x0A");
            if (preg_match("/(.+) \((.{25,30})\)...$/",  $curr_line['trackinf'], $matches)) {
               $curr_track = $matches[2];
               $curr_track_name = $matches[1];
            }
            else {
               $curr_track = $curr_line['trackinf'];
               $curr_track_name = $curr_line['trackinf'];
            }
            $trackid = get_id($curr_track);
            if (!isset($this->log_tracks[$trackid])) {
               $this->log_tracks[$trackid]['b'] = $curr_track;
               $this->log_tracks[$trackid]['c'] = $curr_track_name;
               $this->log_tracks[$trackid]['d'] = name_clear($curr_track_name);
               $this->log_tracks[$trackid]['e'] = "-";
               $this->log_tracks[$trackid]['f'] = "-";
               $this->log_tracks[$trackid]['g'] = "-";
               $this->log_tracks[$trackid]['h'] = "-";
               $this->log_tracks[$trackid]['i'] = "1";
               $this->log_tracks[$trackid]['j'] = "0";
               $this->log_tracks[$trackid]['k'] = "00:00:00.00";
               $this->log_tracks[$trackid]['l'] = "00:00:00.00";
               $this->log_tracks[$trackid]['m'] = "00:00:00.00";
               $this->log_tracks[$trackid]['n'] = "00:00:00.00";
               $this->log_tracks[$trackid]['o'] = "0";
               $this->log_tracks[$trackid]['p'] = "-";
            }
            break;

         //case '==========':
         //   break;

         } // switch

         if ($curr_buffer != '') {
            $log_curr['parse_position'] = $curr_offset;
            $log_curr['parse_track'] = $curr_track;
            $log_curr['parse_str'] = md5(strtok($curr_buffer, "\x0D\x0A"));
         }

      } // while

      if (count($this->log_results) > 0)
         $this->refresh_result_list($sid);

      fclose($log_file);
   }

   function check_tracks() {
      $result = false;

      foreach ($this->log_tracks as $tid=>$tinf) {
         if ($tinf['f'] == '-') {
            $result = true;
            break;
         }
      }
      return $result;
   }

   function check_players($sid) {
      // del players from $cfg_players_ignorelist
      foreach ($this->cfg_cp['pil'] as $pid=>$pinf) {
         if (isset($this->log_players[$pid])) {
            unset($this->log_players[$pid]);
            $this->db->query_exec("delete from tmos_results where serverid=$sid and playerid='$pid'");
         }
      }
      // unite results for players in $cfg_players
      foreach ($this->cfg_cp['pal'] as $pid=>$destid) {
         if (isset($this->log_players[$pid]) && isset($this->log_players[$destid])) {
            $this->log_players[$destid]['d'] = aliases_sum($this->log_players[$destid]['d'], $this->log_players[$pid]['d']);
            if ($this->log_players[$pid]['e'] > $this->log_players[$destid]['e']) {
               $this->log_players[$destid]['c'] = $this->log_players[$pid]['c'];
               $this->log_players[$destid]['e'] = $this->log_players[$pid]['e'];
            }
            unset($this->log_players[$pid]);
            $this->db->query_exec("update tmos_results set playerid='$destid' where serverid=$sid and playerid='$pid'");
         }
      }
      // delete results for tracks in $cfg_tracks_ignorelist
      foreach ($this->cfg_cp['til'] as $tid=>$tinf) {
         $this->db->query_exec("delete from tmos_results where serverid=$sid and trackid='$tid'");
      }
   }

   function find_tracks($tracksdirs) {
      $ti = new Ttmos_TracksInfo($tracksdirs);
      $st = $ti->get_tracks_info();
      $ti->clear();
      foreach ($st as $tid=>$tinf)
         $this->log_tracks[$tid] = $tinf;
      unset($st);
   }

   function refresh_track_list($sid) {
      $this->db->query_exec("delete from tmos_tracks where serverid = $sid");
      $sql = "insert into tmos_tracks (serverid, trackid, uid, track, trackc, author, envir, mood, type, nblaps, price, bronze, silver, gold, authortime, authorscore, relpath) values ";
      foreach ($this->log_tracks as $tid=>$tinf)
         $sql .= "($sid,'$tid','{$tinf['b']}','".addslashes($tinf['c'])."','".addslashes($tinf['d'])."','".addslashes($tinf['e'])."','{$tinf['f']}','{$tinf['g']}','{$tinf['h']}',{$tinf['i']},{$tinf['j']},'{$tinf['k']}','{$tinf['l']}','{$tinf['m']}','{$tinf['n']}',{$tinf['o']},'".addslashes($tinf['p'])."'),";
      $sql = substr($sql, 0, -1);
      $this->db->query_exec($sql);
      unset($sql);
   }

   function refresh_result_list($sid) {
      $sql = "insert ignore into tmos_results (serverid, resultid, trackid, playerid, result, ts) values ";
      foreach ($this->log_results as $rid=>$rinf)
         $sql .= "($sid,'$rid','{$rinf['b']}','{$rinf['c']}','{$rinf['d']}','{$rinf['e']}'),";
      $sql = substr($sql, 0, -1);
      $this->db->query_exec($sql);
      unset($sql);
   }


   /*
   f1 - author
   f2 - gold
   f3 - silver
   f4 - bronze
   f5 - score
   f6 - num tracks
   f7 - stats
   */
   function kkk($sid, $tid, &$ra, &$rba, $rba_count, $f1, $f2, $f3, $f4, $f5, $f7) {
      $sql = "insert into tmos_view (serverid, trackid, playerid, bestresult, ts, award, rank, totalresults, stats) values ";
      $curr_recs = 0;
      $curr_award = "";
      $curr_best = "";
      $curr_place = 0;
      $curr_place_sign = '+';
      $total_players = sizeof($this->log_players);
      $total_places = 0;
      foreach ($rba as $pid=>$index) {
         if ($curr_best != $ra[$index]['c']) {
            $total_places++;
            $curr_best = $ra[$index]['c'];
         }
      }
      $curr_best = "";
      foreach ($rba as $pid=>$index) {

         if ($curr_recs >= $this->max_recs) { 
            $sql = substr($sql, 0, -1);
            $this->db->query_exec($sql);
            $sql = "insert into tmos_view (serverid, trackid, playerid, bestresult, ts, award, rank, totalresults, stats) values ";
            $curr_recs = 0;
         }
         if ($ra[$index]['c'] <= time_lapfull($this->log_tracks[$tid]['n'], $this->log_tracks[$tid]['i'])) {
            $this->log_players[$pid][$f1]++;
            $this->log_players[$pid][$f5] += $this->am_score;
            $curr_award = "a";
         }
         else if ($ra[$index]['c'] <= time_lapfull($this->log_tracks[$tid]['m'], $this->log_tracks[$tid]['i'])) {
            $this->log_players[$pid][$f2]++;
            $this->log_players[$pid][$f5] += $this->gm_score;
            $curr_award = "b";
         }
         else if ($ra[$index]['c'] <= time_lapfull($this->log_tracks[$tid]['l'], $this->log_tracks[$tid]['i'])) {
            $this->log_players[$pid][$f3]++;
            $this->log_players[$pid][$f5] += $this->sm_score;
            $curr_award = "c";
         }
         else if ($ra[$index]['c'] <= time_lapfull($this->log_tracks[$tid]['k'], $this->log_tracks[$tid]['i'])) {
            $this->log_players[$pid][$f4]++;
            $this->log_players[$pid][$f5] += $this->bm_score;
            $curr_award = "d";
         }
         else {
            $this->log_players[$pid][$f5] += $this->fh_score;
            $curr_award = "e";
         }
         if ($curr_best != $ra[$index]['c']) {
            $curr_place++;
            $curr_place_sign = '+';
            $curr_best = $ra[$index]['c'];
         }
         else if ($curr_place == 1) {
            $curr_place_sign = '-';
         }
         $this->log_players[$pid][$f5] += ($total_places-$curr_place)*(($total_players-$curr_place+1)/$total_players);
         $sql .= "($sid,'$tid','$pid','$curr_best','{$ra[$index]['b']}','$curr_award',$curr_place_sign$curr_place,'$total_places ($rba_count)','$f7'),";

         $curr_recs++;
      }
      $sql = substr($sql, 0, -1);
      $this->db->query_exec($sql);
   }

   function refresh_score_list($sid) {
      $this->db->query_exec("delete from tmos_view where serverid = $sid");
      foreach ($this->log_tracks as $tid=>$tinf) {
         // 12 sec
         $ra = $this->db->query("select playerid as a, ts as b, result as c from tmos_results where serverid = $sid and trackid = '$tid' order by c");

         // ~ 1-2 sec
         $rba = array();
         for ($i = 0; $i < $ra['count']; $i++) { // ~ 0.5 sec
            if (!isset($rba[$ra[$i]['a']]))
               $rba[$ra[$i]['a']] = $i;
         }
         $rba_count = count($rba);
         if ($rba_count > 0) {
            $this->kkk($sid, $tid, $ra, $rba, $rba_count, 'f', 'g', 'h', 'i', 'k', 'a');
         }

         //~ 5sec (mem)
         $rba = array();
         for ($i = 0; $i < $ra['count']; $i++) {
            if ($ra[$i]['b'] > time_stamp_delta($this->days_delta)) {
               if (!isset($rba[$ra[$i]['a']]) || $ra[$i]['c'] < $rba[$ra[$i]['a']]['c'])
                  $rba[$ra[$i]['a']] = $i;
            }
         }
         $rba_count = count($rba);
         if ($rba_count > 0) {
            $this->kkk($sid, $tid, $ra, $rba, $rba_count, 'l', 'm', 'n', 'o', 'q', 'c');
         }
      }
      $qryres = $this->db->query("select count(distinct tv.trackid) as tt, count(distinct tt.author) as ta from tmos_view tv, tmos_tracks tt where tv.serverid = $sid and tv.stats = 'a' and tv.serverid = tt.serverid and tv.trackid = tt.trackid");
      $this->db->query_exec("insert into tmos_view (serverid, stats, trackid, playerid, bestresult, ts, award, rank) values ($sid,'x','{$qryres[0]['tt']}','{$qryres[0]['ta']}','-','-','-',0)");
      $qryres = $this->db->query("select count(distinct tv.trackid) as tt, count(distinct tt.author) as ta from tmos_view tv, tmos_tracks tt where tv.serverid = $sid and tv.stats = 'c' and tv.serverid = tt.serverid and tv.trackid = tt.trackid");
      $this->db->query_exec("insert into tmos_view (serverid, stats, trackid, playerid, bestresult, ts, award, rank) values ($sid,'y','{$qryres[0]['tt']}','{$qryres[0]['ta']}','-','-','-',0)");
   }

   function refresh_player_list($sid) {
      $this->db->query_exec("delete from tmos_players where serverid = $sid");
      $players_count = 0;
      $sql = "insert into tmos_players (serverid, playerid, account, player, playerc, aliases, lastonline, am, gm, sm, bm, score, am_c, gm_c, sm_c, bm_c, score_c) values ";
      foreach ($this->log_players as $pid=>$pinf) {
         if ($players_count >= $this->max_recs) {
            $sql = substr($sql, 0, -1);
            $this->db->query_exec($sql);
            $players_count = 0;
            $sql = "insert into tmos_players (serverid, playerid, account, player, playerc, aliases, lastonline, am, gm, sm, bm, score, am_c, gm_c, sm_c, bm_c, score_c) values ";
         }
         $this->log_players[$pid]['r'] = name_clear($pinf['c']);
         $this->log_players[$pid]['k'] = $pinf['k'];
         $this->log_players[$pid]['q'] = $pinf['q'];
         $sql .= "($sid,'$pid','".addslashes($pinf['b'])."','".addslashes($pinf['c'])."','".addslashes($this->log_players[$pid]['r'])."','".addslashes($pinf['d'])."','".addslashes($pinf['e'])."','{$pinf['f']}','{$pinf['g']}','{$pinf['h']}','{$pinf['i']}','{$pinf['k']}','{$pinf['l']}','{$pinf['m']}','{$pinf['n']}','{$pinf['o']}','{$pinf['q']}'),";
         $players_count++;
      }
      $sql = substr($sql, 0, -1);
      $this->db->query_exec($sql);
      unset($sql);
   }

   function clan_add(&$clans, $cid, $ctag, $cdescr, $pid, $ppc, $ppa) {
      if (!isset($clans[$cid])) {
         $clans[$cid]['b'] = $ctag;
         $clans[$cid]['c'] = 1;
         $clans[$cid]['d'] = "'$pid'";
         $clans[$cid]['e'] = $ppc;
         $clans[$cid]['f'] = $ppa;
         $clans[$cid]['j'] = $cdescr;
      }
      else {
         $clans[$cid]['c']++;
         $clans[$cid]['d'] .= ",'$pid'";
         $clans[$cid]['e'] += $ppc;
         $clans[$cid]['f'] += $ppa;
      }
   }

   function refresh_clans_list($sid) {
      $clans = array();

      foreach ($this->log_players as $pid=>$pinf) {

         $curr_clan_m = "";
         $curr_clan_l = "";
         $curr_clan_r = "";
         $curr_clan_id = "";
         $curr_clan_descr = "";

         foreach ($this->cfg_cp['ctl'] as $cid=>$cinf) {
            if (isset($cinf['members'][$pinf['b']]) ||
               ($cinf['afm'] && name_clan_manual($pinf['r'], $cinf['tag']))) {
               $curr_clan_m = $cinf['tag'];
               $curr_clan_descr = $cinf['descr'];
               break;
            }
         }
         // manual
         if ($curr_clan_m == "" && $this->cfg_cp['afc']) {
            $curr_clan_l = name_clan_auto_left($pinf['r']);
            $curr_clan_r = name_clan_auto_right($pinf['r']);
         }
         if ($curr_clan_r == $curr_clan_l) $curr_clan_r = "";

         if ($curr_clan_m != "") {
            $curr_clan_id = get_id(strtolower($curr_clan_m));
            if (!isset($this->cfg_cp['cil'][$curr_clan_id]))
               $this->clan_add($clans, $curr_clan_id, $curr_clan_m, $curr_clan_descr, $pid, $pinf['k'], $pinf['q']);
         }
         // left
         if ($curr_clan_l != "") {
            $curr_clan_id = get_id(strtolower($curr_clan_l));
            if (!isset($this->cfg_cp['cil'][$curr_clan_id]))
               $this->clan_add($clans, $curr_clan_id, $curr_clan_l, $curr_clan_descr, $pid, $pinf['k'], $pinf['q']);
         }
         // right
         if ($curr_clan_r != "") {
            $curr_clan_id = get_id(strtolower($curr_clan_r));
            if (!isset($this->cfg_cp['cil'][$curr_clan_id]))
               $this->clan_add($clans, $curr_clan_id, $curr_clan_r, $curr_clan_descr, $pid, $pinf['k'], $pinf['q']);
         }
      }

      $this->db->query_exec("delete from tmos_clans where serverid = $sid");
      $sql = "insert into tmos_clans (serverid, clanc, description, members, score, score_c, tm) values ";
      foreach ($clans as $cid=>$cinf) {
         if ($cinf['c'] >= $this->min_clan) {
            $cinf['e'] = $cinf['e']/$cinf['c'];
            $cinf['f'] = $cinf['f']/$cinf['c'];
            $sql .= "($sid,'".addslashes($cinf['b'])."','".addslashes($cinf['j'])."','".addslashes($cinf['d'])."',{$cinf['e']},{$cinf['f']},{$cinf['c']}),";
         }
      }
      if (strlen($sql) > 90) {
         $sql = substr($sql, 0, -1);
         $this->db->query_exec($sql);
      }
   }

} // class



// *****************************************************************************
// Ttmos_ServersInfo
// *****************************************************************************
require_once "./include/GbxRemote.inc.php";

class Ttmos_ServersInfo {

   function send_command($ip, $login, $password, $timeout, $command, $param_1 = -1, $param_2 = -1) {
      $result = 0;
      $ip_port = preg_split("/(.*):(\d+)/u", $ip, -1, PREG_SPLIT_DELIM_CAPTURE | PREG_SPLIT_NO_EMPTY);
      if (!isset($ip_port[0]) || !isset($ip_port[1])) {
         $result = -1;
      }
      else {
         $tm_client = new IXR_Client_Gbx;
         if(!$tm_client->InitWithIp($ip_port[0], $ip_port[1], $timeout)) {
            $result = -2;
         }
         else {
            if(!$tm_client->query('Authenticate', $login, $password))
               $result = -3;
            else {
               if ($param_1 != -1 && $param_2 != -1)
                  $result = $tm_client->query($command, $param_1, $param_2);
               else if ($param_1 != -1)
                  $result = $tm_client->query($command, $param_1);
               else
                  $result = $tm_client->query($command);
               if ($result) $result = $tm_client->getResponse();
               else $result = -4;
            }
            $tm_client->Terminate();
         }
      }
      return $result;
   }

   function track_next($ip, $login, $password, $timeout) {
      $result = $this->send_command($ip, $login, $password, $timeout, 'NextChallenge');
      if ($result == 1) $result = 0;
      return $result;
   }

   function track_restrat($ip, $login, $password, $timeout) {
      $result = $this->send_command($ip, $login, $password, $timeout, 'ChallengeRestart');
      if ($result == 1) $result = 0;
      return $result;
   }

   function track_set($ip, $login, $password, $timeout, $trackname) {
      $result = $this->send_command($ip, $login, $password, $timeout, 'ChooseNextChallenge', $trackname);
      if ($result == 1) $result = 0;
      return $result;
   }

   function track_getlist($ip, $login, $password, $timeout) {
      $tmp = $this->send_command($ip, $login, $password, $timeout, 'GetChallengeList', 300, 0);
      if (is_array($tmp)) {
         $result['count'] = count($tmp);
         for ($i = 0; $i < $result['count']; $i++) {
            $result[$i]['trackc'] = name_clear($tmp[$i]['Name']);
            $result[$i]['track'] = $tmp[$i]['Name'];
            $result[$i]['envir'] = $tmp[$i]['Environnement'];
            $result[$i]['length'] = $tmp[$i]['GoldTime'];
            $result[$i]['filename'] = $tmp[$i]['FileName'];
         }
         array_multisort($result);
      }
      else
         $result = $tmp;
      return $result;
   }

   function matchsettings_load($ip, $login, $password, $timeout, $msfile) {
      $result = $this->send_command($ip, $login, $password, $timeout, 'LoadMatchSettings', $msfile);
      if ($result > 0) $result = 0;
      return $result;
   }

   function get_srv_info($ip, $login, $password, $timeout) {
      $si['status'] = 0;
      $ip_port = preg_split("/(.*):(\d+)/u", $ip, -1, PREG_SPLIT_DELIM_CAPTURE | PREG_SPLIT_NO_EMPTY);
      if (!isset($ip_port[0]) || !isset($ip_port[1])) {
         $si['status'] = -1;
      }
      else {
         $tm_client = new IXR_Client_Gbx;
         if(!$tm_client->InitWithIp($ip_port[0], $ip_port[1], $timeout)) {
            $si['status'] = -2;
         }
         else {
            $result = "";
            if(!$tm_client->query('Authenticate', $login, $password)) {
               $si['status'] = -3;
            }
            else {
               // srv status
               if ($tm_client->query('GetStatus')) {
                  $result = $tm_client->getResponse();
                  $si['srvstatus'] = $result['Name'];
               }
               else $si['srvstatus'] = '?';
               // srv version
               if ($tm_client->query('GetVersion')) {
                  $result = $tm_client->getResponse();
                  $si['version'] = $result['Version'];
               }
               else $si['version'] = '?';
               // srv name
               if ($tm_client->query('GetServerName')) $si['server'] = $tm_client->getResponse();
               else $si['server'] = '?';
               // srv comment
               if ($tm_client->query('GetServerComment')) $si['comment'] = $tm_client->getResponse();
               else $si['comment'] = '?';
               // game mode
               if ($tm_client->query('GetGameMode')) {
                  $si['gamemode'] = $tm_client->getResponse();
                  switch ($si['gamemode']) {
                  case 0: $si['gamemode'] = 'Rounds'; break;
                  case 1: $si['gamemode'] = 'TimeAttack'; break;
                  case 2: $si['gamemode'] = 'Team'; break;
                  case 3: $si['gamemode'] = 'Laps'; break;
                  case 4: $si['gamemode'] = 'Stunts'; break;
                  }
               }
               else $si['gamemode'] = '?';
               // players max
               if ($tm_client->query('GetMaxPlayers')) {
                  $result = $tm_client->getResponse();
                  $si['playersmax'] = $result['CurrentValue'];
               }
               else $si['playersmax'] = '?';
               // spectators max
               if ($tm_client->query('GetMaxSpectators')) {
                   $result = $tm_client->getResponse();
                   $si['spectatorsmax'] = $result['CurrentValue'];
               }
               else $si['spectatorsmax'] = '?';
               // players
               if ($tm_client->query('GetCurrentRanking', 50, 0)) {
                  $result = $tm_client->getResponse();
                  $si['playerscurr'] = count($result);
                  $si['spectatorscurr'] = 0;
                  $si['players']['count'] = count($result);
                  for ($i = 0; $i < $si['players']['count']; $i++) {
                     $si['players'][$i]['besttime'] = $result[$i]['BestTime'];
                     if ($si['players'][$i]['besttime'] == -1) $si['players'][$i]['besttime'] = 999999999;
                     $si['players'][$i]['lapsfinished'] = $result[$i]['NbrLapsFinished'];
                     $si['players'][$i]['account'] = $result[$i]['Login'];
                     $si['players'][$i]['player'] = $result[$i]['NickName'];
                     if ($tm_client->query('GetPlayerInfo', $result[$i]['Login'])) {
                        $player_inf = $tm_client->getResponse();
                        $si['players'][$i]['spectator'] = $player_inf['IsSpectator'];
                        if ($player_inf['IsSpectator']) $si['spectatorscurr']++;
                     }
                     else
                        $si['players'][$i]['spectator'] = false;
                  }
               }
               else {
                  $si['players']['count'] = 0;
                  $si['playerscurr'] = 0;
                  $si['spectatorscurr'] = 0;

               }

               array_multisort ($si['players']);

               // track curr
               if ($tm_client->query('GetCurrentChallengeInfo')) {
                  $result = $tm_client->getResponse();
                  $si['track']['uid'] = $result['UId'];
                  $si['track']['track'] = $result['Name'];
                  $si['track']['envir'] = $result['Environnement'];
                  $si['track']['author'] = $result['Author'];
                  $si['track']['authortime'] = $result['AuthorTime'];
                  $si['track']['laps'] = $result['LapRace'];
                  $si['track']['nblaps_t'] = 0;
               }
               else {
                  $si['track']['uid'] = 'x';
                  $si['track']['track'] = '?';
                  $si['track']['envir'] = '?';
                  $si['track']['author'] = '?';
                  $si['track']['authortime'] = 0;
                  $si['track']['laps'] = false;
                  $si['track']['nblaps_t'] = 0;
               }
               // trackscount
               if ($tm_client->query('GetChallengeList', 300, 0)) $si['challengetotal'] = count($tm_client->getResponse());
               else $si['challengetotal'] = '?';
               if ($si['challengetotal'] >= 300) $si['challengetotal'] = "300+";
               if ($tm_client->query('GetNbLaps')) {
                  $result = $tm_client->getResponse();
                  $si['nblaps_s'] = $result['CurrentValue'];
               }
               else $si['nblaps_s'] = 0;
               //GetServerPassword
            }
            $tm_client->Terminate();
         }
      }
      return $si;
   }

} // class
?>
