<?php
/*
   TM Offline Stats v0.62a
   Copyright (c) 2006 Alexander Domnin

   This program is licenced under the Creative Commons Attribution-NonCommercial-NoDerivs 2.5
   To view a copy of this licence, visit http://creativecommons.org/licenses/by-nc-nd/2.5/

   This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
   without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

error_reporting(E_ALL);
require_once("./include/tmos_lib.inc.php");
require_once("./include/tmos_content_admin.inc.php");

class Ttmos_Admin {
   var $it;
   var $cfg;
   var $srv;
   var $db;
   var $status;

   function Ttmos_Admin() {
      unset($this->status);
      unset($this->it);
      unset($this->cfg);
      unset($this->srv);
      unset($this->db);
   }

   function add_magic_quotes($arr) {
      foreach($arr as $key=>$value) {
         $arr[$key] = addslashes($value);
      }
      return $arr;
   }

   function process() {

      // del magic quotes
      set_magic_quotes_runtime(0);
      if (get_magic_quotes_gpc() == 1)
         foreach($_POST as $key=>$value) {
            if (is_string($value))
               $_POST[$key] = stripslashes($value);
         }

      session_start();
      // config
      $this->cfg = config_load();
      require_once("./include/tmos_lang_".$this->cfg['interfacelanguage'].".inc.php");
      $this->it = $tmos_admin_it;
      // status
      $this->status['dbconnect'] = false;
      $this->status['status_1'] = "";
      $this->status['status_2'] = "";
      $this->status['status_3'] = "";
      $this->status['status_4'] = "";
      if(isset($_SESSION['status_m'])) $this->status['status_m'] = $_SESSION['status_m'];
      else $this->status['status_m'] = "unknown";
      unset($_SESSION['status_m']);
      // step
      if (isset($_POST['step'])) $this->status['step'] = $_POST['step'];
      else $this->status['step'] = 1;
      // actionbtn
      if (isset($_POST['actionbtn'])) $this->status['actionbtn'] = $_POST['actionbtn'];
      else $this->status['actionbtn'] = "unknown";
      // sid
      if (isset($_GET['sid'])) $this->status['sid'] = $_GET['sid'];
      else if (isset($_POST['sid'])) $this->status['sid'] = $_POST['sid'];
      else $this->status['sid'] = -1;
      // action
      if (isset($_GET['action'])) $this->status['action'] = $_GET['action'];
      else if (isset($_POST['action'])) $this->status['action'] = $_POST['action'];
      else {
         $this->status['action'] = "config";
         $this->status['actionbtn'] = "unknown";
         $this->status['step'] = 1;
         $this->status['status_m'] = "unknown";
         $this->status['status_1'] = "";
         $this->status['status_2'] = "";
      }
      // servers
      $tmos_DB = new Ttmos_DB($this->cfg);
      if ($tmos_DB->check_lib()) {
         $this->status['dbconnect'] = $tmos_DB->check_connection();
         if ($this->status['dbconnect'] == "ok") {
            $tmos_DB->open();
            $this->srv = $tmos_DB->get_schema_curr();
            if ($this->srv['tmos_servers']['status'] == 1) 
               $this->srv = $tmos_DB->query("select * from tmos_servers");
            else {
               unset($this->srv);
               $this->srv['count'] = 0;
            }
            $tmos_DB->close();
         }
         else {
            $this->srv['count'] = 0;
         }
      }
      else {
         $this->status['dbconnect'] = $this->it['db_dberr'];
         $this->srv['count'] = 0;
      }

      // check authorize
      $this->process_authorize();

      // process
      switch ($this->status['action']) {
      case "config": 
         $this->process_config();
         break;
      case "db":
      case "db_update":
         $this->process_db();
         break;
      case "servers":
      case "servers_add":
      case "servers_edit":
         $this->process_servers();
         break;
      case "check":
         $this->process_check();
         break;
      case "server":
         $this->process_server();
      }
   }

   function process_authorize() {
      if (!isset($_SESSION['adminpass']) || $_SESSION['adminpass'] != $this->cfg['adminpass']) {
         if (isset($_POST['adminpass'])) {
            if ($_POST['adminpass'] == $this->cfg['adminpass']) {
               $_SESSION['adminpass'] = $_POST['adminpass'];
               header("Location: {$_SERVER['PHP_SELF']}?action=config"); exit;
            }
            else {
               $this->status['status_m'] = $this->it['az_status_1'];
               $this->status['action'] = "authorize";
            }
         }
         else {
            $this->status['status_m'] = "";
            $this->status['action'] = "authorize";
         }
      }
   }

   function process_config() {
      
      $this->cfg['langs'] = languages_load();
      $this->cfg['cssfiles'] = css_load();

      if ($this->status['step'] != 2) return;

      // del cache
      cache_dir_clear();

      // get params
      isset($_POST['dbhost']) ? $this->cfg['dbhost'] = $_POST['dbhost'] : $this->cfg['dbhost'] = "localhost";
      isset($_POST['dbtype']) ? $this->cfg['dbtype'] = $_POST['dbtype'] : $this->cfg['dbtype'] = "mysql";
      isset($_POST['dbname']) ? $this->cfg['dbname'] = $_POST['dbname'] : $this->cfg['dbname'] = "tmostats";
      isset($_POST['dblogin']) ? $this->cfg['dblogin'] = $_POST['dblogin'] : $this->cfg['dblogin'] = "root";
      isset($_POST['dbpassword']) ? $this->cfg['dbpassword'] = $_POST['dbpassword'] : $this->cfg['dbpassword'] = "x";
      isset($_POST['interfacelanguage']) ? $this->cfg['interfacelanguage'] = $_POST['interfacelanguage'] : $this->cfg['interfacelanguage'] = "rus";
      isset($_POST['cssfile']) ? $this->cfg['cssfile'] = $_POST['cssfile'] : $this->cfg['cssfile'] = "tmos_default.css";
      isset($_POST['recperpage']) ? $this->cfg['recperpage'] = $_POST['recperpage'] : $this->cfg['recperpage'] = 100;
      isset($_POST['javascript']) ? $this->cfg['javascript'] = true : $this->cfg['javascript'] = false;
      isset($_POST['servertimeout']) ? $this->cfg['servertimeout'] = $_POST['servertimeout'] : $this->cfg['servertimeout'] = 2;
      isset($_POST['defaultstats']) ? $this->cfg['defaultstats'] = $_POST['defaultstats'] : $this->cfg['defaultstats'] = "a";
      isset($_POST['showoneserver']) ? $this->cfg['showoneserver'] = true : $this->cfg['showoneserver'] = false;
      isset($_POST['showclans']) ? $this->cfg['showclans'] = true : $this->cfg['showclans'] = false;
      isset($_POST['showuserbars']) ? $this->cfg['showuserbars'] = true : $this->cfg['showuserbars'] = false;
      isset($_POST['minscore']) ? $this->cfg['minscore'] = $_POST['minscore'] : $this->cfg['minscore'] = 1;
      isset($_POST['htmlcache']) ? $this->cfg['htmlcache'] = $_POST['htmlcache'] : $this->cfg['htmlcache'] = "main";
      isset($_POST['gzipcompress']) ? $this->cfg['gzipcompress'] = true : $this->cfg['gzipcompress'] = false;
      isset($_POST['timeperiod']) ? $this->cfg['timeperiod'] = $_POST['timeperiod'] : $this->cfg['timeperiod'] = 7;
      isset($_POST['minclansize']) ? $this->cfg['minclansize'] = $_POST['minclansize'] : $this->cfg['minclansize'] = 3;
      isset($_POST['amscore']) ? $this->cfg['amscore'] = $_POST['amscore'] : $this->cfg['amscore'] = 1;
      isset($_POST['gmscore']) ? $this->cfg['gmscore'] = $_POST['gmscore']: $this->cfg['gmscore'] = 0;
      isset($_POST['smscore']) ? $this->cfg['smscore'] = $_POST['smscore']: $this->cfg['smscore'] = 0;
      isset($_POST['bmscore']) ? $this->cfg['bmscore'] = $_POST['bmscore']: $this->cfg['bmscore'] = 0;
      isset($_POST['finishscore']) ? $this->cfg['finishscore'] = $_POST['finishscore']: $this->cfg['finishscore'] = 0;
      isset($_POST['ubfont']) ? $this->cfg['ubfont'] = $_POST['ubfont']: $this->cfg['ubfont'] = "arialuni.ttf";
      isset($_POST['ubfontsizen']) ? $this->cfg['ubfontsizen'] = $_POST['ubfontsizen']: $this->cfg['ubfontsizen'] = 7;
      isset($_POST['ubfontsizeb']) ? $this->cfg['ubfontsizeb'] = $_POST['ubfontsizeb']: $this->cfg['ubfontsizeb'] = 9;
      isset($_POST['adminpass']) ? $this->cfg['adminpass'] = str_replace('"', '', $_POST['adminpass']) : $this->cfg['adminpass'] = "1";

      $this->status['status_1'] = "";
      $tmos_DB = new Ttmos_DB($this->cfg);
      if (strpos($this->cfg['dbhost'], '"') ||  strpos($this->cfg['dbname'], '"') ||
          strpos($this->cfg['dblogin'], '"') || strpos($this->cfg['dbpassword'], '"'))
         $this->status['status_1'] = $this->it['gs_errorprefix'].$this->it['gs_doublequotes_err'];
      else {
         $this->status['status_1'] = $tmos_DB->check_connection();
         if ($this->status['status_1'] != "ok") $this->status['status_1'] = $this->it['gs_errorprefix'].$this->status['status_1'];
         else $this->status['status_1'] = "";
      }
      $this->status['status_2'] = "";
      if (!preg_match("/^[1-9]\d*$/", $this->cfg['recperpage']) || $this->cfg['recperpage'] < 10) 
         $this->status['status_2'] = $this->it['gs_errorprefix'].$this->it['gs_recperpage_err']."<br>";
      if (!preg_match("/^[1-9]\d*$/", $this->cfg['servertimeout']))
         $this->status['status_2'] .= $this->it['gs_errorprefix'].$this->it['gs_servertimeout_err']."<br>";
      if (!preg_match("/^[0-9]\d*$/", $this->cfg['minscore']))
         $this->status['status_2'] .= $this->it['gs_errorprefix'].$this->it['gs_minscore_err']."<br>";
      $this->status['status_3'] = "";
      if (!preg_match("/^[1-9]\d*$/", $this->cfg['timeperiod']))
         $this->status['status_3'] .= $this->it['gs_errorprefix'].$this->it['gs_timeperiod_err']."<br>";
      if (!preg_match("/^[2-9]\d*$/", $this->cfg['minclansize']))
         $this->status['status_3'] .= $this->it['gs_errorprefix'].$this->it['gs_minclansize_err']."<br>";
      if (!preg_match("/^[0-9]\d*$/", $this->cfg['amscore']) || 
          !preg_match("/^[0-9]\d*$/", $this->cfg['gmscore']) || 
          !preg_match("/^[0-9]\d*$/", $this->cfg['smscore']) || 
          !preg_match("/^[0-9]\d*$/", $this->cfg['bmscore']) || 
          !preg_match("/^[0-9]\d*$/", $this->cfg['finishscore']))
         $this->status['status_3'] .= $this->it['gs_errorprefix'].$this->it['gs_medalsscore_err']."<br>";
      $this->status['status_4'] = "";
      if (!preg_match("/^[1-9]\d*$/", $this->cfg['ubfontsizen']) || 
          !preg_match("/^[1-9]\d*$/", $this->cfg['ubfontsizeb']))
         $this->status['status_4'] .= $this->it['gs_errorprefix'].$this->it['gs_fontsize_err'];

      $_SESSION['status_m'] = "";
      if ($this->status['status_1'] == "" && $this->status['status_2'] == "" &&
          $this->status['status_3'] == "" && $this->status['status_4'] == "") {
         if (config_save($this->cfg)) {
            $_SESSION['status_m'] = $this->it['gs_status_1'];
            header("Location: {$_SERVER['PHP_SELF']}?action=config"); exit;
         }
         else {
            $this->status['status_m'] = $this->it['gs_status_2'];
         }
      }
      else 
         $this->status['status_m'] = "unknown";
   }

   function process_db() {
      switch ($this->status['step']) {
      case 1:
         if ($this->status['dbconnect'] == "ok") {
            $this->status['status_1'] = $this->it['db_dbok'];
            $tmos_DB = new Ttmos_DB($this->cfg);
            $tmos_DB->open();
            $this->db = $tmos_DB->get_schema_ver();
            $this->db['tables'] = $tmos_DB->get_schema_curr();
            $tmos_DB->close();
         }
         else {
            $this->status['status_1'] = $this->it['db_errorprefix'].$this->status['dbconnect'];
            $this->db = false;
         }
         break;

      case 2:
         // del cache
         cache_dir_clear();

         $_SESSION['status_m'] = $this->it['db_status_1'];
         $tmos_DB = new Ttmos_DB($this->cfg);
         $tmos_DB->open();
         switch ($this->status['actionbtn']) {
         case $this->it['db_updatedb_btn']:
            $this->db = $tmos_DB->get_schema_ver();            
            $this->status['action'] = "db_update";
            break;
         case $this->it['db_createtables_btn']:
            if (!$tmos_DB->create_tables()) $_SESSION['status_m'] = $this->it['db_errorprefix'].$tmos_DB->get_error();
            break;
         case $this->it['db_droptables_btn']:
            if (!$tmos_DB->drop_tables()) $_SESSION['status_m'] = $this->it['db_errorprefix'].$tmos_DB->get_error();
            break;
         case $this->it['db_resetdb_btn']:
            if (!$tmos_DB->query_exec("delete from tmos_players", true) ||
                !$tmos_DB->query_exec("delete from tmos_tracks", true) ||
                !$tmos_DB->query_exec("delete from tmos_results", true) ||
                !$tmos_DB->query_exec("delete from tmos_view", true) ||
                !$tmos_DB->query_exec("delete from tmos_clans", true))
               $_SESSION['status_m'] = $this->it['db_errorprefix'].$tmos_DB->get_error();
               for ($i = 0; $i < $this->srv['count']; $i++) {
                  $tmp = split_logs($this->srv[$i]['logfiles'], true);
                  $tmp = merge_logs($tmp, false);
                  if (!$tmos_DB->query_exec("update tmos_servers set logfiles='".addslashes($tmp)."', last_update = 0 where serverid = {$this->srv[$i]['serverid']}", true)) 
                     $_SESSION['status_m'] = $this->it['db_errorprefix'].$tmos_DB->get_error();
               }
            break;
         case $this->it['db_cleardb_btn']:
            if (!$tmos_DB->query_exec("delete from tmos_servers", true) ||
                !$tmos_DB->query_exec("delete from tmos_players", true) ||
                !$tmos_DB->query_exec("delete from tmos_tracks", true) ||
                !$tmos_DB->query_exec("delete from tmos_results", true) ||
                !$tmos_DB->query_exec("delete from tmos_view", true) ||
                !$tmos_DB->query_exec("delete from tmos_clans", true))
               $_SESSION['status_m'] = $this->it['db_errorprefix'].$tmos_DB->get_error();
            break;
         }
         $tmos_DB->close();
         if ($this->status['actionbtn'] != $this->it['db_updatedb_btn']) {
            header("Location: {$_SERVER['PHP_SELF']}?action=db"); exit;
         }
         break;

      case 3:
         // cancel
         if ($this->status['actionbtn'] == $this->it['db_cancel_btn']) {
            $_SESSION['status_m'] = $this->it['db_status_2'];
            header("Location: {$_SERVER['PHP_SELF']}?action=db"); exit;
         }
         // update
         else {
            $tmos_DB = new Ttmos_DB($this->cfg);
            $tmos_DB->open();
            // ver
            $this->db = $tmos_DB->get_schema_ver();
            if ($this->db['ver_curr'] == "v0.60" || $this->db['ver_curr'] == "v0.61") {
               $tmos_DB->update_tables();
               $tmos_DB->close();
               header("Location: {$_SERVER['PHP_SELF']}?action=db"); exit;
            }
            else {
               // in db
               $this->db['tr_id'] = $tmos_DB->query("select distinct trackid from tmos_results");
               $this->db['tr_idstr'] = "(-1";
               for ($i = 0; $i < $this->db['tr_id']['count']; $i++) {
                  $this->db['tr_idstr'] .= ",{$this->db['tr_id'][$i]['trackid']}";
               }
               $this->db['tr_idstr'] .= ")";
               $this->db['tr_db'] = $tmos_DB->query_assoc("select * from tmos_tracks where uid='-' and trackid in {$this->db['tr_idstr']} order by filename", "filename");
               // dirs
               $this->db['tr_dirs'] = split_tracks($_POST['tracks']);
               // on hdd
               $tmos_TracksInfo = new Ttmos_TracksInfo($this->db['tr_dirs']);
               $this->db['tr_hdd'] = $tmos_TracksInfo->get_tracks_info(true);
               $tmos_TracksInfo->clear();
               foreach ($this->db['tr_hdd'] as $tid=>$tinf) {
                  if (isset($this->db['tr_db'][basename($tinf['p'])])) {
                     unset($this->db['tr_db'][basename($tinf['p'])]);
                  }
               }
               if (sizeof($this->db['tr_db']) == 0 || isset($_POST['ignoreerrors'])) {
                  @set_time_limit(0);
                  $this->db['tr_db'] = $tmos_DB->query_assoc("select * from tmos_tracks", "filename");
                  foreach ($this->db['tr_hdd'] as $tid=>$tinf) {
                     if (isset($this->db['tr_db'][basename($tinf['p'])]) && $this->db['tr_db'][basename($tinf['p'])]['uid'] == '-') {
                        $tmos_DB->query_exec("update tmos_tracks set uid='{$tinf['b']}', track='".addslashes($tinf['c'])."', trackc='".addslashes($tinf['d'])."', author='".addslashes($tinf['e'])."', envir='{$tinf['f']}', mood='{$tinf['g']}', type='{$tinf['h']}', nblaps={$tinf['i']}, price={$tinf['j']}, bronze='{$tinf['k']}', silver='{$tinf['l']}', gold='{$tinf['m']}', authortime='{$tinf['n']}', authorscore={$tinf['o']} where trackid={$this->db['tr_db'][basename($tinf['p'])]['trackid']}");
                     }
                  }
                  $tmos_DB->update_tables();
                  $tmos_DB->close();
                  header("Location: {$_SERVER['PHP_SELF']}?action=db"); exit;
               }
               else {
                  $tmos_DB->close();
                  $this->status['status_1'] = "error";
               }
            }
         }
         break;
      }
   }

   function process_servers() {
      switch ($this->status['step']) {
      case 1:
         if ($this->status['dbconnect'] == "ok") {
            $this->status['status_1'] = $this->it['db_dbok'];
            $this->db = $this->srv;
            for ($i = 0; $i < $this->db['count']; $i++) {
               $this->db[$i]['tracks'] = split_tracks($this->db[$i]['tracks']);
               $this->db[$i]['logfiles'] = split_logs($this->db[$i]['logfiles'], true);
            }
         }
         else {
            $this->status['status_1'] = $this->it['srv_errorprefix'].$this->status['dbconnect'];
            $this->db = false;
         }
         break;

      case 2:
         // del cache
         cache_dir_clear();

         if ($this->status['actionbtn'] == $this->it['srv_deleteservers_btn']) {
            $tmp = "";
            foreach($_POST as $key=>$value) {
               if (strpos($key, "serverid_") !== false) {
                  $tmp .= $value.",";
               }
            }
            if ($tmp != "") {
               @set_time_limit(0);
               $tmos_DB = new Ttmos_DB($this->cfg);
               $tmos_DB->open();
               $tmp = substr($tmp, 0, -1);
               if (!$tmos_DB->query_exec("delete from tmos_players where serverid in ($tmp)", true) ||
                   !$tmos_DB->query_exec("delete from tmos_tracks  where serverid in ($tmp)", true) ||
                   !$tmos_DB->query_exec("delete from tmos_results where serverid in ($tmp)", true) ||
                   !$tmos_DB->query_exec("delete from tmos_view    where serverid in ($tmp)", true) ||
                   !$tmos_DB->query_exec("delete from tmos_clans   where serverid in ($tmp)", true) ||
                   !$tmos_DB->query_exec("delete from tmos_servers where serverid in ($tmp)", true))
                  $_SESSION['status_m'] = $this->it['srv_errorprefix'].$tmos_DB->get_error();
               else
                  $_SESSION['status_m'] = $this->it['srv_status_2'];
               $tmos_DB->close();
            }
            else {
               $_SESSION['status_m'] = $this->it['srv_status_3'];
            }
            header("Location: {$_SERVER['PHP_SELF']}?action=servers"); exit;
         }
         else if ($this->status['actionbtn'] == $this->it['srv_modifyservers_btn']) {
            $this->db['count'] = 0;
            foreach($_POST as $key=>$value) {
               if (strpos($key, "serverid_") !== false) {
                  for ($i = 0; $i < $this->srv['count']; $i++)
                     if ($this->srv[$i]['serverid'] == $value) {
                        $this->db[$this->db['count']] = $this->srv[$i];
                        $this->db['count']++;
                     }
               }
            }
            if ($this->db['count'] == 0) {
               $_SESSION['status_m'] = $this->it['srv_status_3'];
               header("Location: {$_SERVER['PHP_SELF']}?action=servers"); exit;
            }
            $this->status['action'] = "servers_edit";
         }
         else {
            $this->db = false;
            $this->status['action'] = "servers_add";
         }
         break;

      case 3:
         // del cache
         cache_dir_clear();

         // cancel
         if ($this->status['actionbtn'] == $this->it['srv_cancel_btn']) {
            $_SESSION['status_m'] = $this->it['srv_status_1'];
            header("Location: {$_SERVER['PHP_SELF']}?action=servers"); exit;
         }
         // add server
         else if ($this->status['actionbtn'] == $this->it['srv_addserver_btn']) {
            // post
            isset($_POST['ip']) ? $this->db['ip'] = $_POST['ip'] : $this->db['ip'] = "localhost:ip";
            isset($_POST['server']) ? $this->db['server'] = $_POST['server'] : $this->db['server'] = "My Server";
            isset($_POST['game']) ? $this->db['game'] = $_POST['game'] : $this->db['game'] = "United";
            isset($_POST['login']) ? $this->db['login'] = $_POST['login'] : $this->db['login'] = "root";
            isset($_POST['password']) ? $this->db['password'] = $_POST['password'] : $this->db['password'] = "";
            isset($_POST['logfiles']) ? $this->db['logfiles'] = $_POST['logfiles'] : $this->db['logfiles'] = "";
            $tmp = preg_split('/;/u', $this->db['logfiles'], -1, PREG_SPLIT_NO_EMPTY);
            $this->db['logfiles'] = "";
            for ($i = 0; $i < sizeof($tmp); $i++) {
               $this->db['logfiles'] .= $tmp[$i]."*0*x*x;";
            }
            isset($_POST['tracks']) ? $this->db['tracks'] = $_POST['tracks'] : $this->db['tracks'] = "";
            // errors
            $this->status['status_1'] = "";
            if (strpos($this->db['server'], '"') !== false || strpos($this->db['ip'], '"') !== false ||
                strpos($this->db['login'], '"') !== false || strpos($this->db['password'], '"') !== false ||
                strpos($this->db['logfiles'], '"') !== false || strpos($this->db['tracks'], '"') !== false)
               $this->status['status_1'] = $this->it['srv_errorprefix'].$this->it['srv_doublequotes_err'];
            if ($this->status['status_1'] == "") {
               // add
               $tmos_DB = new Ttmos_DB($this->cfg);
               $tmos_DB->open();
               if (!$tmos_DB->query_exec("insert into tmos_servers (server, serverc, ip, game, login, password, tracks, logfiles, last_update) values ('".addslashes($this->db['server'])."', '".addslashes(name_clear($this->db['server']))."', '".addslashes($this->db['ip'])."', '".addslashes($this->db['game'])."', '".addslashes($this->db['login'])."', '".addslashes($this->db['password'])."', '".addslashes($this->db['tracks'])."', '".addslashes($this->db['logfiles'])."', 0)", true))
                  $_SESSION['status_m'] = $this->it['srv_errorprefix'].$tmos_DB->get_error();
               else 
                  $_SESSION['status_m'] = $this->it['srv_status_2'];
               $tmos_DB->close();
               header("Location: {$_SERVER['PHP_SELF']}?action=servers"); exit;
            }
            else {
               $this->status['status_m'] = "unknown";
            }
         }
         // edit
         else {
            // post
            $this->db['count'] = $_POST['count'];
            for ($i = 0; $i < $this->db['count']; $i++) {
               $this->db[$i]['serverid'] = $_POST["serverid_$i"];
               $this->db[$i]['ip'] = $_POST["ip_$i"];
               $this->db[$i]['server'] = $_POST["server_$i"];
               $this->db[$i]['game'] = $_POST["game_$i"];
               $this->db[$i]['login'] = $_POST["login_$i"];
               $this->db[$i]['password'] = $_POST["password_$i"];
               $this->db[$i]['logfiles'] = merge_logs(split_logs($_POST["logfiles_$i"], true), false);
               $this->db[$i]['tracks'] = $_POST["tracks_$i"];
            }
            $tmos_DB = new Ttmos_DB($this->cfg);
            $tmos_DB->open();
            for ($i = 0; $i < $this->db['count']; $i++) {
               if (!$tmos_DB->query_exec("update tmos_servers set server='".addslashes($this->db[$i]['server'])."', serverc='".addslashes(name_clear($this->db[$i]['server']))."', ip='".addslashes($this->db[$i]['ip'])."', game='".addslashes($this->db[$i]['game'])."', login='".addslashes($this->db[$i]['login'])."', password='".addslashes($this->db[$i]['password'])."', tracks='".addslashes($this->db[$i]['tracks'])."', logfiles='".addslashes($this->db[$i]['logfiles'])."' where serverid = {$this->db[$i]['serverid']}", true))
                  $_SESSION['status_m'] = $this->it['srv_errorprefix'].$tmos_DB->get_error();
               else
                  $_SESSION['status_m'] = $this->it['srv_status_2'];
            }
            $tmos_DB->close();
            header("Location: {$_SERVER['PHP_SELF']}?action=servers"); exit;
         }
         break;
      }

   }

   function process_check() {
      $this->db['php_minver'] = '4.4.0';
      $this->db['php_ver'] = PHP_VERSION;
      $this->db['php_xml'] = function_exists('xml_parser_create');
      $this->db['php_mysql'] = function_exists('mysql_connect');
      $this->db['php_gd'] = function_exists('imagecreate');
      $this->db['php_tt'] = function_exists('imagettftext');
      $this->db['php_ttfont'] = file_exists("./gfx/".$this->cfg['ubfont']);
      $this->db['php_ttfontname'] = $this->cfg['ubfont'];
      $fp = @fopen(PS_CACHE_DIR."cachetest", "wb+");
      if (!$fp) $this->db['php_cache'] = false;
      else {
         fclose($fp);
         if (!@unlink(PS_CACHE_DIR."cachetest"))
            $this->db['php_cache'] = false;
         else
            $this->db['php_cache'] = true;
      }
      $this->db['php_zlib'] = extension_loaded('zlib');
      $this->db['php_metime'] = get_cfg_var("max_execution_time");
      if (get_cfg_var("safe_mode") == 1) $this->db['php_metime'] .= " (SM = On)";
      else $this->db['php_metime'] .= " (SM = Off)";
      if (get_cfg_var("allow_url_fopen") == 1) $this->db['php_allowurl'] = "On";
      else $this->db['php_allowurl'] = "Off";
      $this->db['db_type']= $this->cfg['dbtype'];
      if ($this->status['dbconnect'] == "ok") {
         $this->db['db_connection'] = true;
         $tmos_DB = new Ttmos_DB($this->cfg);
         $tmos_DB->open();
         $this->db['db_version'] = $tmos_DB->get_db_version();
         $this->db['db_tables'] = $tmos_DB->get_schema_curr();
         $tmos_DB->close();
         $this->db['srv'] = $this->srv;
         @set_time_limit(120);
         $tmos_ServersInfo = new Ttmos_ServersInfo();
         for ($i = 0; $i < $this->db['srv']['count']; $i++) {
            $this->db['srv'][$i]['tracks'] = split_tracks($this->db['srv'][$i]['tracks']);
            $this->db['srv'][$i]['logfiles'] = split_logs($this->db['srv'][$i]['logfiles'], true);
            $si = $tmos_ServersInfo->get_srv_info($this->db['srv'][$i]['ip'], $this->db['srv'][$i]['login'], $this->db['srv'][$i]['password'], $this->cfg['servertimeout']);
            $this->db['srv'][$i]['connect'] = $si['status'];
         }
      }
      else {
         $this->db['db_connection'] = false;
         $this->db['srv']['count'] = 0;
      }
   }


   function process_server() {
      $this->db = false;
      for ($i = 0; $i < $this->srv['count']; $i++) {
         if ($this->status['sid'] == $this->srv[$i]['serverid'])
            $this->db = $this->srv[$i];
      }
      if (!$this->db) {
         $this->status['action'] = "error";
         return;
      }

      switch ($this->status['step']) {

      case 1:
         $this->db['logfiles'] = split_logs($this->db['logfiles'], false);
         for ($j = 0; $j < $this->db['logfiles']['count']; $j++) {
            $this->db['logfiles'][$j]['filesize'] = @filesize($this->db['logfiles'][$j]['logfile']);
            if (!$this->db['logfiles'][$j]['filesize']) $this->db['logfiles'][$j]['filesize'] = '?';
         }
         $this->db['tracks'] = split_tracks($this->db['tracks']);
         $tmos_ServersInfo = new Ttmos_ServersInfo();
         $this->db['inf'] = $tmos_ServersInfo->get_srv_info($this->db['ip'], $this->db['login'], $this->db['password'], $this->cfg['servertimeout']);
         if ($this->db['inf']['status'] == 0)
            $this->db['inf']['status'] = $this->db['inf']['srvstatus'];
         break;

      case 2:
         // refresh
         if ($this->status['actionbtn'] == $this->it['cs_refresh_btn']) {
            header("Location: {$_SERVER['PHP_SELF']}?action=server&sid={$this->status['sid']}"); exit;
         }
         // parse
         else if ($this->status['actionbtn'] == $this->it['cs_parse_btn']) {
            // del cache
            cache_dir_clear();
            @set_time_limit(0);
            $tmos_LP = new Ttmos_LogParser();
            $status = $tmos_LP->GoGoGo(array($this->db['serverid']=>true));
            if (count($status) == 0) {
               $_SESSION['status_m'] = $this->it['cs_errorprefix'].$this->it['cs_servers_err'];
            }
            else if ($status[$this->db['serverc']]['skipped']) {
               $_SESSION['status_m'] = $this->it['cs_errorprefix'].$this->it['cs_skipped_err'];
            }
            else {
               $_SESSION['status_m'] = "";
               for ($i = 0; $i < $status[$this->db['serverc']]['logscount']; $i++) {
                  switch ($status[$this->db['serverc']][$i]['status']) {
                  case  0:
                     $_SESSION['status_m'] .= $status[$this->db['serverc']][$i]['logfile']."=>".$this->it['cs_status_1']."<br>";
                     break;
                  case -1:
                     $_SESSION['status_m'] .= $status[$this->db['serverc']][$i]['logfile']."=>".$this->it['cs_errorprefix'].$this->it['cs_tracks_err']."<br>";
                     break;
                  case -2:
                     $_SESSION['status_m'] .= $status[$this->db['serverc']][$i]['logfile']."=>".$this->it['cs_errorprefix'].$this->it['cs_logfilenotfound_err']."<br>";
                     break;
                  case -3:
                     $_SESSION['status_m'] .= $status[$this->db['serverc']][$i]['logfile']."=>".$this->it['cs_errorprefix'].$this->it['cs_logfilenotreadable_err']."<br>";
                     break;
                  case -4:
                     $_SESSION['status_m'] .= $status[$this->db['serverc']][$i]['logfile']."=>".$this->it['cs_errorprefix'].$this->it['cs_logfilecantopen_err']."<br>";
                     break;
                  }
               }
            }
            header("Location: {$_SERVER['PHP_SELF']}?action=server&sid={$this->db['serverid']}"); exit;
         }
         // msf
         else if ($this->status['actionbtn'] == $this->it['cs_createmsf_btn']) {
            @set_time_limit(120);
            $this->db['tracks'] = split_tracks($this->db['tracks']);
            $tmos_TracksInfo = new Ttmos_TracksInfo($this->db['tracks']);
            $this->db['inf'] = $tmos_TracksInfo->get_tracks_info(true);
            $tmos_TracksInfo->clear();
            $this->status['action'] = "server_msf";
         }
         // restart
         else if ($this->status['actionbtn'] == $this->it['cs_restarttrack_btn']) {
            $tmos_ServersInfo = new Ttmos_ServersInfo();
            $_SESSION['status_m'] = $tmos_ServersInfo->track_restrat($this->db['ip'], $this->db['login'], $this->db['password'], $this->cfg['servertimeout']);
            switch ($_SESSION['status_m']) {
            case  0: $_SESSION['status_m'] = $this->it['cs_status_1']; break;
            case -1: $_SESSION['status_m'] = $this->it['cs_errorprefix'].$this->it['cs_badip_err']; break;
            case -2: $_SESSION['status_m'] = $this->it['cs_errorprefix'].$this->it['cs_serveroffline_err']; break;
            case -3: $_SESSION['status_m'] = $this->it['cs_errorprefix'].$this->it['cs_authenticate_err']; break;
            }
            header("Location: {$_SERVER['PHP_SELF']}?action=server&sid={$this->db['serverid']}"); exit;
         }
         // next
         else if ($this->status['actionbtn'] == $this->it['cs_nexttrack_btn']) {
            $tmos_ServersInfo = new Ttmos_ServersInfo();
            $_SESSION['status_m'] = $tmos_ServersInfo->track_next($this->db['ip'], $this->db['login'], $this->db['password'], $this->cfg['servertimeout']);
            switch ($_SESSION['status_m']) {
            case  0: $_SESSION['status_m'] = $this->it['cs_status_1']; break;
            case -1: $_SESSION['status_m'] = $this->it['cs_errorprefix'].$this->it['cs_badip_err']; break;
            case -2: $_SESSION['status_m'] = $this->it['cs_errorprefix'].$this->it['cs_serveroffline_err']; break;
            case -3: $_SESSION['status_m'] = $this->it['cs_errorprefix'].$this->it['cs_authenticate_err']; break;
            }
            header("Location: {$_SERVER['PHP_SELF']}?action=server&sid={$this->db['serverid']}"); exit;
         }
         // choose
         else if ($this->status['actionbtn'] == $this->it['cs_choosetrack_btn']) {
            $tmos_ServersInfo = new Ttmos_ServersInfo();
            $this->db['inf'] = $tmos_ServersInfo->track_getlist($this->db['ip'], $this->db['login'], $this->db['password'], $this->cfg['servertimeout']);
            $this->status['action'] = "server_choosetrack";
         }
         else {
            $this->status['action'] = "error";
         }
         break;

      case 3:
         // msf
         if ($this->status['actionbtn'] == $this->it['msf_savetofile_btn']) {
            $outfile = $_POST['msfilepath'];
            $fp = @fopen($outfile, 'w+');
            if($fp !== false){
$msfcontent = <<<EOD
<?xml version="1.0" encoding="utf-8" ?>
<playlist>
   <gameinfos>
      <game_mode>{$_POST['gi_gamemode']}</game_mode>
      <chat_time>{$_POST['gi_chattime']}</chat_time>
      <rounds_pointslimit>{$_POST['gi_roundspointslimit']}</rounds_pointslimit>
      <rounds_usenewrules>{$_POST['gi_roundsusenewrules']}</rounds_usenewrules>
      <timeattack_limit>{$_POST['gi_timeattacklimit']}</timeattack_limit>
      <timeattack_synchstartperiod>0</timeattack_synchstartperiod>
      <team_pointslimit>{$_POST['gi_teampointslimit']}</team_pointslimit>
      <team_maxpoints>{$_POST['gi_teammaxpoints']}</team_maxpoints>
      <team_usenewrules>{$_POST['gi_teamusenewrules']}</team_usenewrules>
      <laps_nblaps>{$_POST['gi_lapsnblaps']}</laps_nblaps>
      <laps_timelimit>{$_POST['gi_lapstimelimit']}</laps_timelimit>
   </gameinfos>
   <hotseat>
      <game_mode>0</game_mode>
      <timeattack_limit>3</timeattack_limit>
      <rounds_count>5</rounds_count>
   </hotseat>
   <filter>
      <is_solo>0</is_solo>
      <is_hotseat>0</is_hotseat>
      <is_lan>1</is_lan>
      <is_internet>0</is_internet>
      <sort_index>400</sort_index>
      <random_map_order>{$_POST['gi_randommaporder']}</random_map_order>
   </filter>\r\n
EOD;
               $is_tracks = false;
               foreach ($_POST as $id=>$value) {
                  if (preg_match("/t(al|ba|co|is|ra|sp|st)\d+/", $id)) {
                     $is_tracks = true;
                     $relpath = strtok($value, '*');
                     $uid = strtok('');
$msfcontent .= <<<EOD
   <challenge>
      <file>$relpath</file>
      <ident>$uid</ident>
   </challenge>\r\n
EOD;
                  }
               }
$msfcontent .= <<<EOD
</playlist>
EOD;
               if ($is_tracks) {
                  fputs($fp, $msfcontent);
                  $_SESSION['status_m'] = $this->it['cs_status_2'];
               }
               else {
                  $_SESSION['status_m'] = $this->it['cs_errorprefix'].$this->it['cs_msftracks_err'];
               }
               fclose($fp);

               if ($is_tracks && isset($_POST['restartserver'])) {
                  $tmos_ServersInfo = new Ttmos_ServersInfo();
                  if ($tmos_ServersInfo->matchsettings_load($this->db['ip'], $this->db['login'], $this->db['password'], $this->cfg['servertimeout'], $outfile) == 0) {
                     $tmos_ServersInfo->track_next($this->db['ip'], $this->db['login'], $this->db['password'], $this->cfg['servertimeout']);
                     $_SESSION['status_m'] .= "<br>".$this->it['cs_status_3'];
                  }
                  else
                     $_SESSION['status_m'] .= "<br>".$this->it['cs_errorprefix'].$this->it['cs_msfrestartserver_err'];
               }
            }
            else
               $_SESSION['status_m'] .= $this->it['cs_errorprefix'].$this->it['cs_msfwrite_err'];

            header("Location: {$_SERVER['PHP_SELF']}?action=server&sid={$this->db['serverid']}"); exit;
         }
         // choose
         else if ($this->status['actionbtn'] == $this->it['chtr_choosetrack_btn']) {
            if (isset($_POST['choosetrack'])) {
               $tmos_ServersInfo = new Ttmos_ServersInfo();
               if ($tmos_ServersInfo->track_set($this->db['ip'], $this->db['login'], $this->db['password'], $this->cfg['servertimeout'], $_POST['choosetrack']) == 0 &&
                   $tmos_ServersInfo->track_next($this->db['ip'], $this->db['login'], $this->db['password'], $this->cfg['servertimeout']) == 0)
                  $_SESSION['status_m'] = $this->it['cs_status_1'];
               else 
                  $_SESSION['status_m'] = $this->it['cs_status_4'];
            }
            else
               $_SESSION['status_m'] = $this->it['cs_errorprefix'].$this->it['cs_choosetrack_err'];
            header("Location: {$_SERVER['PHP_SELF']}?action=server&sid={$this->db['serverid']}"); exit;
         }
         // error
         else {
            $this->status['action'] = "error";
         }
         break;
      }
   }

   function show_content() {
      header('Content-Type: text/html; charset=UTF-8');

      echo get_header($this->cfg);
      if ($this->status['action'] != "authorize") 
         echo get_menu_header($this->it, $this->srv);
      switch($this->status['action']) {
      case "authorize":
         echo get_form_authorize($this->it, $this->status);
         break;
      case "config": 
         echo get_form_config($this->it, $this->cfg, $this->status);
         break;
      case "db": 
         echo get_form_db($this->it, $this->db, $this->status);
         break;
      case "db_update":
         echo get_form_db_update($this->it, $this->db, $this->status);
         break;
      case "servers":
         echo get_form_servers($this->it, $this->db, $this->status);
         break;
      case "servers_add":
         echo get_form_servers_add($this->it, $this->db, $this->status);
         break;
      case "servers_edit":
         echo get_form_servers_edit($this->it, $this->db, $this->status);
         break;
      case "check":
         echo get_form_check($this->it, $this->db);
         break;
      case "server":
         echo get_form_server($this->it, $this->db, $this->status);
         break;
      case "server_msf":
         echo get_form_msfg($this->it, $this->db);
         break;
      case "server_choosetrack":
         echo get_form_choosetrack($this->it, $this->db);
         break;
      default: 
         echo get_form_error();
         break;
      }
      if ($this->status['action'] != "authorize") 
         echo get_menu_footer();
      echo get_footer($this->it);
   }
}

$tmos_Admin = new Ttmos_Admin();
$tmos_Admin->process();
$tmos_Admin->show_content();
?>
