<?php

// TM Offline Stats v0.62a

/* - commentary ------------------------------------------------------
   This file allows you to manage the process of parsing logs.

   Usage:
   - do changes
   - save file
   - reparse stats

   Tips:
   - if you don't understand what you do, make DB backup first =)
   - if you want use non latin (UTF-8) characters, open this file in
     UTF-8 editor (like http://www.unipad.org)
   - if you want use " in string do it with backslash - \" 

   -!commentary --------------------------------------------------- */

/* - commentary ------------------------------------------------------
   Results of this players will by united. Format:
   $cfg_players = array(
      "SrcPlayerAccount"=>"DestPlayerAccount",
   );
   All results of player with account "SrcPlayerAccount" will
   be grabed by player with account "DestPlayerAccount". Player
   with account "SrcPlayerAccount" will be deleted from stats.
   You may view "account" in server's log-file.

   Example for /lan server:

   [2007/01/19 17:30:37] <time> [$000jago/213.85.135.45:2350 ($000Jago)] 1:18.47
   account - "$000jago"
   [2007/01/19 18:07:52] <time> [habicht/192.168.61.175:2350 (HabichT)] 1:29.61
   account - "habicht"

   $cfg_players = array(
      "$000jago"=>"habicht",
   );

   Example for /internet server:

   [2006/06/14 14:01:59] <time> [wjp84 ($i$f4fWJP)] 0:33.80
   account - "wjp84"
   [2006/06/14 14:02:07] <time> [saimi (zymiC)] 0:41.77
   account - "saimi"
   [2006/06/14 14:03:32] <time> [-a-p- (-A-P-)] 0:45.53
   account - "-a-p-"

   $cfg_players = array(
      "wjp84"=>"saimi",
      "-a-p-"=>"saimi",
   );
   -!commentary --------------------------------------------------- */

$cfg_players = array(
);

/* - commentary ------------------------------------------------------
   Results of this players will by deleted. Format:
   $cfg_players_ignorelist = array(
      "DeletePlayerAccount",
   );
   Player with account "DeletePlayerAccount" and all his results
   will by deleted from stats. You may view "account" in
   server's log-file.

   Example for /lan server:

   [2007/01/19 17:30:37] <time> [$000jago/213.85.135.45:2350 ($000Jago)] 1:18.47
   account - "$000jago"
   [2007/01/19 18:07:52] <time> [habicht/192.168.61.175:2350 (HabichT)] 1:29.61
   account - "habicht"

   $cfg_players_ignorelist = array(
      "$000jago",
      "habicht",
   );

   Example for /internet server:

   [2006/06/14 14:01:59] <time> [wjp84 ($i$f4fWJP)] 0:33.80
   account - "wjp84"
   [2006/06/14 14:02:07] <time> [saimi (zymiC)] 0:41.77
   account - "saimi"
   [2006/06/14 14:03:32] <time> [-a-p- (-A-P-)] 0:45.53
   account - "-a-p-"

   $cfg_players_ignorelist = array(
      "wjp84",
      "saimi",
      "-a-p-",
   );
   -!commentary --------------------------------------------------- */

$cfg_players_ignorelist = array(
"guest",
);

/* - commentary ------------------------------------------------------
   Switch on/off autoparse team-tags. If false, will be used only
   $cfg_clans array.
   true - on
   false - off
   -!commentary --------------------------------------------------- */

$cfg_autofindclans = true;

/* - commentary ------------------------------------------------------
   With this array you can manual register teams. Format:
   $cfg_clans = array(
      "TeamTag"=>array("description"=>"Description: full name, site, mirc channel, e.t.c.",
                       "autofindmembers"=>true,
                       "members"=>"account_member_1;account_member_2;account_member_e_t_c"),
   );
   "TeamTag" is case-insensitive.

   Example:

   $cfg_clans = array(
      "BANANAS"=>array("description"=>" - BANANAS clan",
                       "autofindmembers"=>true),
       "UnItEd"=>array("description"=>" - Some players united to clan",
                       "autofindmembers"=>false,
                       "members"=>"crockett;fleckman;hsl;vasia."),
       "[TMos]"=>array("description"=>" - \"TM Offline Stats\" funs (http://tmos.pp.ru)",
                       "autofindmembers"=>true,
                       "members"=>"$000jago;habicht;rock"),
   );

   -!commentary --------------------------------------------------- */

$cfg_clans = array(

   // information from http://tm-ladder.com (few random teams)
   "{+}"=>array("description"=>" - <img src=\"./gfx/flags/fra.png\" class=\"f\">&nbsp;<a href=\"http://savoysrv.viallet.biz\">Team savoy</a>",
                 "autofindmembers"=>true),
   "2fast4u"=>array("description"=>" - <img src=\"./gfx/flags/fra.png\" class=\"f\">&nbsp;<a href=\"http://2fast4u.roxorgamers.com\">2fast4u</a>",
                 "autofindmembers"=>true),
   "[BBD]"=>array("description"=>" - <img src=\"./gfx/flags/fra.png\" class=\"f\">&nbsp;<a href=\"http://www.bbd.ze.cx\">Belgium Best Drivers</a>",
                 "autofindmembers"=>true),
   "[BLR]"=>array("description"=>" - <img src=\"./gfx/flags/rus.png\" class=\"f\">&nbsp;<a href=\"http://www.tm-belarus.com\">Belarus team</a>",
                 "autofindmembers"=>true),
   "~CAT>"=>array("description"=>" - <img src=\"./gfx/flags/fra.png\" class=\"f\">&nbsp;<a href=\"http://cat.tmu.free.fr\">Catl li</a>",
                 "autofindmembers"=>true),
   "[CDD]"=>array("description"=>" - <img src=\"./gfx/flags/pol.png\" class=\"f\"><img src=\"./gfx/flags/gbr.png\" class=\"f\">&nbsp;<a href=\"http://cddclan.republika.pl\">Crazy Demo Drivers</a>",
                 "autofindmembers"=>true),
   "[cHoe]"=>array("description"=>" - <img src=\"./gfx/flags/ger.png\" class=\"f\">&nbsp;<a href=\"http://www.chaos-hoernchen.de\">Choas-Hoernchen</a>",
                 "autofindmembers"=>true),
   "*CRT*"=>array("description"=>" - <img src=\"./gfx/flags/ger.png\" class=\"f\">&nbsp;<a href=\"http://www.cologne-racing-team.de\">Cologne Racing Team</a>",
                 "autofindmembers"=>true),
   "*CZ*"=>array("description"=>" - <img src=\"./gfx/flags/fra.png\" class=\"f\">&nbsp;<a href=\"http://www.sweb.cz/prizdisracz\">PrizdiSraCZ</a>",
                 "autofindmembers"=>true),
   "]DoW["=>array("description"=>" - <img src=\"./gfx/flags/ger.png\" class=\"f\">&nbsp;<a href=\"http://martin.tibit.de/andre\">DriveOrWalk Team</a>",
                 "autofindmembers"=>true),
   "-=E.T.M=-"=>array("description"=>" - <img src=\"./gfx/flags/fra.png\" class=\"f\">&nbsp;<a href=\"http://team.etm.free.fr\">Enter The Matrix</a>",
                 "autofindmembers"=>true),
   "(FG)"=>array("description"=>" - <img src=\"./gfx/flags/gbr.png\" class=\"f\">&nbsp;<a href=\"http://www.forsaken-gaming.com/home\">Forsaken Gaming</a>",
                 "autofindmembers"=>true),
   "Furia"=>array("description"=>" - <img src=\"./gfx/flags/fra.png\" class=\"f\">&nbsp;<a href=\"http://teamfuria.cmonfofo.com\">teamfuria</a>",
                 "autofindmembers"=>true),
   "|GT|"=>array("description"=>" - <img src=\"./gfx/flags/pol.png\" class=\"f\">&nbsp;<a href=\"http://www.gtteam.ovh.org\">Gothic Trackers</a>",
                 "autofindmembers"=>true),
   "JBRT"=>array("description"=>" - <img src=\"./gfx/flags/fra.png\" class=\"f\">&nbsp;<a href=\"http://www.jbrteam.info\">Joe Bar Racing Team</a>",
                 "autofindmembers"=>true),
   "KK`"=>array("description"=>" - <img src=\"./gfx/flags/esp.png\" class=\"f\">&nbsp;<a href=\"http://www.kkteam.es.kz\">KK team</a>",
                 "autofindmembers"=>true),
   "NWT"=>array("description"=>" - <img src=\"./gfx/flags/por.png\" class=\"f\">&nbsp;<a href=\"http://nwt.up.md/modules/news\">North Wind Traders</a>",
                 "autofindmembers"=>true),
   "OLD/"=>array("description"=>" - <img src=\"./gfx/flags/nor.png\" class=\"f\">&nbsp;<a href=\"http://teamold.activebb.net\">Overaged Lucky Drivers</a>",
                 "autofindmembers"=>true),
   "plan-B"=>array("description"=>" - <img src=\"./gfx/flags/aut.png\" class=\"f\">&nbsp;<a href=\"http://www.plan-b.at\">plan-B Team</a>",
                 "autofindmembers"=>true),
   "USSR"=>array("description"=>" - <img src=\"./gfx/flags/rus.png\" class=\"f\">&nbsp;<a href=\"http://www.ussr-team.com\">USSR Team.tmn</a>",
                 "autofindmembers"=>true),
);

/* - commentary ------------------------------------------------------
   With this array you can delete "bad" team-tags, that will not show
   in statistics. Format:
   $cfg_clans_ignorelist = array(
      "TeamTag 1",
      "TeamTag 2",
      "TeamTag e.t.c",
   );
   "TeamTag" is case-insensitive.
   -!commentary --------------------------------------------------- */

$cfg_clans_ignorelist = array(
"the_", "le_", "the-", "le-", "'s", 
"black_", "_black", "_man", "-man", "_guest_", "_wolf", 
"-power", "_power", "-racer", "_racer",
"st.", "st_", "mr.", "mr_", "dr.", "dr_", "mc.", "mc_", "_an", "sir_",
"__", "___", "____",
"alex_", "_johnson", "]max", "michael_", "-lapin",
"a.", "b.", "c.", "d.", "e.", "f.", "g.", "h.", "i.", "j.", "k.", "l.", "m.",
"n.", "o.", "p.", "q.", "r.", "s.", "t.", "u.", "v.", "w.", "x.", "y.", "z.",
".a", ".b", ".c", ".d", ".e", ".f", ".g", ".h", ".i", ".j", ".k", ".l", ".m",
".n", ".o", ".p", ".q", ".r", ".s", ".t", ".u", ".v", ".w", ".x", ".y", ".z",
"-a", "-b", "-c", "-d", "-e", "-f", "-g", "-h", "-i", "-j", "-k", "-l", "-m",
"-n", "-o", "-p", "-q", "-r", "-s", "-t", "-u", "-v", "-w", "-x", "-y", "-z",
"a-", "b-", "c-", "d-", "e-", "f-", "g-", "h-", "i-", "j-", "k-", "l-", "m-",
"n-", "o-", "p-", "q-", "r-", "s-", "t-", "u-", "v-", "w-", "x-", "y-", "z-",
"_a", "_b", "_c", "_d", "_e", "_f", "_g", "_h", "_i", "_j", "_k", "_l", "_m",
"_n", "_o", "_p", "_q", "_r", "_s", "_t", "_u", "_v", "_w", "_x", "_y", "_z",
"a_", "b_", "c_", "d_", "e_", "f_", "g_", "h_", "i_", "j_", "k_", "l_", "m_",
"n_", "o_", "p_", "q_", "r_", "s_", "t_", "u_", "v_", "w_", "x_", "y_", "z_",
"a@", "b@", "c@", "d@", "e@", "f@", "g@", "h@", "i@", "j@", "k@", "l@", "m@",
"n@", "o@", "p@", "q@", "r@", "s@", "t@", "u@", "v@", "w@", "x@", "y@", "z@",
"-1", "-57", "_1", "_2", "_22", "_61", "_91", "_94", ".2006",
"_tr", "_rc", "_zi", "_pl", "_w_", "he-", "m!", "@n",
);

/* - commentary ------------------------------------------------------
   All results of all players on this tracks will be deleted. Format:
   $cfg_tracks_ignorelist = array(
      "track_uid",
   );

   You may view "track_uid" in matchsettings file or in server's log-file.

   Example:

   [2006/06/14 14:00:41] Loading challenge E-3.Challenge.Gbx (yxUTF2YQd351q4iWVtrrqYV59tk)...
   track_uid - "yxUTF2YQd351q4iWVtrrqYV59tk"

   $cfg_tracks_ignorelist = array(
      "yxUTF2YQd351q4iWVtrrqYV59tk",
   );
   -!commentary --------------------------------------------------- */

$cfg_tracks_ignorelist = array(
);

?>