<?php
/*
   TM Offline Stats v0.62a
   Copyright (c) 2006 Alexander Domnin

   This program is licenced under the Creative Commons Attribution-NonCommercial-NoDerivs 2.5
   To view a copy of this licence, visit http://creativecommons.org/licenses/by-nc-nd/2.5/

   This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
   without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

class Ttm_UserBar {
   var $db;
   var $it;
   var $error;
   var $link;
   var $ubminscore;
   var $ubtext;
   var $ubfont;
   var $ubfontsize_n;
   var $ubfontsize_b;

   function Ttm_UserBar() {
      $this->db = null;
      $this->it = null;
      $this->error = true;
      $this->link = null;
      $this->ubminscore = 1;
      $this->ubfont = "arialuni.ttf";
      $this->ubfontsize_n = 7;
      $this->ubfontsize_b = 9;
      $this->ubtext = "";
   }

   function load_config() {
      require_once("./tmos_config.php");
      require_once("./include/tmos_lang_".$cfg['interfacelanguage'].".inc.php");
      $this->it = $tmos_userbar_it;
      $this->db['dbhost'] = $cfg['dbhost'];
      $this->db['dblogin'] = $cfg['dblogin'];
      $this->db['dbpassword'] = $cfg['dbpassword'];
      $this->db['dbname'] = $cfg['dbname'];
      $this->ubminscore = $cfg['minscore'];
      $this->ubfont = "./gfx/".$cfg['ubfont'];
      $this->ubfontsize_n = $cfg['ubfontsizen'];
      $this->ubfontsize_b = $cfg['ubfontsizeb'];
   }

   function get_playerinf() {
     if (isset($_SERVER['QUERY_STRING']) && $_SERVER['QUERY_STRING'] != "")
        preg_match("/^tmos_(.)_(.)_([0-9a-f]{6})_(.{1,3})_(\d+)_(.)_(.+)\.png$/", $_SERVER['QUERY_STRING'], $this->link);
     else 
        preg_match("/^\/tmos_(.)_(.)_([0-9a-f]{6})_(.{1,3})_(\d+)_(.)_(.+)\.png$/", $_SERVER['PATH_INFO'], $this->link);
      if (sizeof($this->link) == 0) {
         $this->ubtext = $this->it['ub_gdt_badlink_err'];
      }
      else {
         $result = @mysql_connect($this->db['dbhost'], $this->db['dblogin'], $this->db['dbpassword']);
         if (!$result)
            $this->ubtext = $this->it['ub_gdt_offline_err'];
         else {
            $result = @mysql_select_db($this->db['dbname']);
            if (!$result)
               $this->ubtext = $this->it['ub_gdt_dbnotfound_err'];
            else {
               $result = @mysql_query("/*!40101 set names 'utf8' */");
               if (!$result)
                  $this->ubtext = $this->it['ub_gdt_sql1_err'];
               else {
                  $result = @mysql_query("select serverc from tmos_servers where serverid = {$this->link[5]}");
                  if (!$result)
                     $this->ubtext = $this->it['ub_gdt_sql2_err'];
                  else {
                     $srv = mysql_fetch_array($result, MYSQL_NUM);
                     if (!$srv)
                        $this->ubtext = $this->it['ub_gdt_servernotfound_err'];
                     else {
                        $result = @mysql_query("select playerc, score".(($this->link[6] == "c") ? "_c" : "")." from tmos_players where serverid = {$this->link[5]} and playerid = '{$this->link[7]}'");
                        if (!$result)
                           $this->ubtext = $this->it['ub_gdt_sql3_err'];
                        else {
                           $plr = mysql_fetch_array($result, MYSQL_NUM);
                           if (!$plr)
                              $this->ubtext = $this->it['ub_gdt_playernotfounderr'];
                           else {
                              $result = @mysql_query("select count(playerid) from tmos_players where serverid = {$this->link[5]} and score".(($this->link[6] == "c") ? "_c" : "")." > {$plr[1]}");
                              if (!$result)
                                 $this->ubtext = $this->it['ub_gdt_sql4_err'];
                              else {
                                 $rnk = mysql_fetch_array($result, MYSQL_NUM);
                                 mysql_free_result($result);
                                 $this->error = false;
                              }
                           }
                        }
                     }
                  }
               }
            }
            @mysql_close();
         }
      }

      if (!$this->error) {
         $this->ubtext['serverc'] = $srv[0];
         $this->ubtext['playerc'] = $plr[0];
         $this->ubtext['rank'] = $rnk[0] + 1;
         $this->ubtext['score'] = round($plr[1], 2);
         if ($this->ubtext['score'] < $this->ubminscore) {
            $this->ubtext['rank'] = "?";
            $this->ubtext['score'] = " < {$this->ubminscore}";

         }
         if ($this->link[6] == "c") {
            $this->ubtext['rank'] .= " *";
            $this->ubtext['score'] .= " *";
         }
      }
   }

   function draw_userbar() {
      if (!$this->error) {
         $ubfile = "./gfx/tmosub_{$this->link[1]}_{$this->link[2]}_{$this->link[3]}_{$this->link[4]}.png";
         $ubfileinf = @getimagesize($ubfile);
         if (!$ubfileinf || $ubfileinf[2] != 3) { // !png
            $this->ubtext = $this->it['ub_gdt_ubfile_err'];
            $this->error = true;
         }
      }
      if ($this->error) {
         $ubimg = imagecreate(350, 20);
         $ubfillcolor = imagecolorallocate($ubimg, 0, 0, 0);
         imagefill($ubimg, 0, 0, $ubfillcolor);
         $ubtextcolor = imagecolorallocate($ubimg, 255, 255, 255);
         imagestring($ubimg, 1, 1, 0, $this->ubtext, $ubtextcolor);
      }
      else {
         $ubimg = imagecreatefrompng($ubfile);
         $ubtextcolor = imagecolorallocate($ubimg, hexdec($this->link[3][0].$this->link[3][1]),
                                                   hexdec($this->link[3][2].$this->link[3][3]),
                                                   hexdec($this->link[3][4].$this->link[3][5]));
         if (function_exists('imagettfbbox') && function_exists('imagettftext') && file_exists($this->ubfont)) {
            if ($this->link[2] == "n") {
               $ubtext = $this->ubtext['serverc']. " / ".$this->ubtext['playerc']." / ".$this->ubtext['rank']." / ".$this->ubtext['score'];
               $ubtextsize = imagettfbbox($this->ubfontsize_n, 0, $this->ubfont, $ubtext);
               $ubtextsize = $ubtextsize[2] - $ubtextsize[0];
               imagettftext($ubimg, $this->ubfontsize_n, 0, 347-$ubtextsize, $this->ubfontsize_n+2, $ubtextcolor, $this->ubfont, $ubtext);
            }
            else {
               $ubtextsizearr = imagettfbbox($this->ubfontsize_b, 0, $this->ubfont, $this->it['ub_ttt_server']);
               $ubtextsize = $ubtextsizearr[2] - $ubtextsizearr[0];
               $ubtextsizearr = imagettfbbox($this->ubfontsize_b, 0, $this->ubfont, $this->it['ub_ttt_player']);
               if ($ubtextsizearr[2] - $ubtextsizearr[0] > $ubtextsize)
                  $ubtextsize = $ubtextsizearr[2] - $ubtextsizearr[0];
               $ubtextsizearr = imagettfbbox($this->ubfontsize_b, 0, $this->ubfont, $this->it['ub_ttt_rank']);
               if ($ubtextsizearr[2] - $ubtextsizearr[0] > $ubtextsize)
                  $ubtextsize = $ubtextsizearr[2] - $ubtextsizearr[0];
               $ubtextsizearr = imagettfbbox($this->ubfontsize_b, 0, $this->ubfont, $this->it['ub_ttt_score']);
               if ($ubtextsizearr[2] - $ubtextsizearr[0] > $ubtextsize)
                  $ubtextsize = $ubtextsizearr[2] - $ubtextsizearr[0];
               imagettftext($ubimg, $this->ubfontsize_b, 0, 110, 2+$this->ubfontsize_b, $ubtextcolor, $this->ubfont, $this->it['ub_ttt_server']);
               imagettftext($ubimg, $this->ubfontsize_b, 0, 110+$ubtextsize,  2+$this->ubfontsize_b, $ubtextcolor, $this->ubfont, $this->it['ub_ttt_separator'].$this->ubtext['serverc']);
               imagettftext($ubimg, $this->ubfontsize_b, 0, 110, 14+$this->ubfontsize_b, $ubtextcolor, $this->ubfont, $this->it['ub_ttt_player']);
               imagettftext($ubimg, $this->ubfontsize_b, 0, 110+$ubtextsize, 14+$this->ubfontsize_b, $ubtextcolor, $this->ubfont, $this->it['ub_ttt_separator'].$this->ubtext['playerc']);
               imagettftext($ubimg, $this->ubfontsize_b, 0, 110, 26+$this->ubfontsize_b, $ubtextcolor, $this->ubfont, $this->it['ub_ttt_rank']);
               imagettftext($ubimg, $this->ubfontsize_b, 0, 110+$ubtextsize, 26+$this->ubfontsize_b, $ubtextcolor, $this->ubfont, $this->it['ub_ttt_separator'].$this->ubtext['rank']);
               imagettftext($ubimg, $this->ubfontsize_b, 0, 110, 38+$this->ubfontsize_b, $ubtextcolor, $this->ubfont, $this->it['ub_ttt_score']);
               imagettftext($ubimg, $this->ubfontsize_b, 0, 110+$ubtextsize, 38+$this->ubfontsize_b, $ubtextcolor, $this->ubfont, $this->it['ub_ttt_separator'].$this->ubtext['score']);
            }
         }
         else if ($this->link[2] == "n") {
            $ubtext = $this->ubtext['serverc']. " / ".$this->ubtext['playerc']." / ".$this->ubtext['rank']." / ".$this->ubtext['score'];
            $ubtextsize = 347-5*strlen($ubtext);
            imagestring($ubimg, 1, $ubtextsize, 1, $ubtext, $ubtextcolor);
         }
         else {
            imagestring($ubimg, 2, 110,  0, $this->it['ub_gdt_server'].$this->ubtext['serverc'], $ubtextcolor);
            imagestring($ubimg, 2, 110, 12, $this->it['ub_gdt_player'].$this->ubtext['playerc'], $ubtextcolor);
            imagestring($ubimg, 2, 110, 24, $this->it['ub_gdt_rank'].$this->ubtext['rank'], $ubtextcolor);
            imagestring($ubimg, 2, 110, 36, $this->it['ub_gdt_score'].$this->ubtext['score'], $ubtextcolor);
         }
      }
      header("Content-Type: image/png");
      imagepng($ubimg);
      imagedestroy($ubimg);
   }
}

$obg = new Ttm_UserBar();
$obg->load_config();
$obg->get_playerinf();
$obg->draw_userbar();
?>