<?php
/*
   TM Offline Stats v0.62a
   Copyright (c) 2006 Alexander Domnin

   This program is licenced under the Creative Commons Attribution-NonCommercial-NoDerivs 2.5
   To view a copy of this licence, visit http://creativecommons.org/licenses/by-nc-nd/2.5/

   This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
   without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

error_reporting(E_ALL);
require_once("./include/tmos_lib.inc.php");
require_once("./include/tmos_content_viewer.inc.php");

class Ttm_StatsContent {
   var $it;
   var $sp;
   var $content;

   function Ttm_StatsContent() {
      $this->it = null;
      $this->sp = null;
      $this->content = null;
   }

   function clear() {
      unset($this->sp);
      unset($this->it);
      unset($this->content);
   }


   function get_params() {
      // del magic quotes
      set_magic_quotes_runtime(0);
      if (get_magic_quotes_gpc() == 1) {
         foreach($_POST as $key=>$value)
            $_POST[$key] = stripslashes($value);
         foreach($_GET as $key=>$value)
            $_GET[$key] = stripslashes($value);
      }
      // cfg
      $this->sp['cfg'] = config_load();

      // action
      if(isset($_GET['action'])) $this->sp['view']['action'] = $_GET['action'];
      else if(isset($_POST['action'])) $this->sp['view']['action'] = $_POST['action'];
      else $this->sp['view']['action'] = "servers";
      // stats
      if(isset($_GET['stats'])) $this->sp['view']['stats'] = $_GET['stats'];
      else if(isset($_POST['stats'])) $this->sp['view']['stats'] = $_POST['stats'];
      else $this->sp['view']['stats'] = $this->sp['cfg']['defaultstats'];
      // sid
      if(isset($_GET['sid'])) $this->sp['view']['sid'] = $_GET['sid'];
      else if(isset($_POST['sid'])) $this->sp['view']['sid'] = $_POST['sid'];
      else $this->sp['view']['sid'] = -1;
      // pid
      if(isset($_GET['pid'])) $this->sp['view']['pid'] = $_GET['pid'];
      else if(isset($_POST['pid'])) $this->sp['view']['pid'] = $_POST['pid'];
      else $this->sp['view']['pid'] = -1;
      // tid
      if(isset($_GET['tid'])) $this->sp['view']['tid'] = $_GET['tid'];
      else if(isset($_POST['tid'])) $this->sp['view']['tid'] = $_POST['tid'];
      else $this->sp['view']['tid'] = -1;
      // page
      if(isset($_GET['page'])) $this->sp['view']['page'] = $_GET['page'];
      else if(isset($_POST['page'])) $this->sp['view']['page'] = $_POST['page'];
      else $this->sp['view']['page'] = 1;
      // sort
      if(isset($_GET['sort'])) $this->sp['view']['sort'] = $_GET['sort'];
      else if(isset($_POST['sort'])) $this->sp['view']['sort'] = $_POST['sort'];
      else $this->sp['view']['sort'] = "default";
      // dir
      if(isset($_GET['dir'])) $this->sp['view']['dir'] = $_GET['dir'];
      else if(isset($_POST['dir'])) $this->sp['view']['dir'] = $_POST['dir'];
      else $this->sp['view']['dir'] = "default";
      // find
      if(isset($_GET['query'])) $this->sp['view']['query'] = $_GET['query'];
      else if(isset($_POST['query'])) $this->sp['view']['query'] = $_POST['query'];
      else $this->sp['view']['query'] = "*";
      if ($this->sp['view']['query'] == "") $this->sp['view']['query'] = "*";
      if ($this->sp['view']['query'] != "*") {
         if (preg_match("/^[^\*]*[^\*]$/u", $this->sp['view']['query']))
            $this->sp['view']['queryw'] = "*".$this->sp['view']['query']."*";
         else 
            $this->sp['view']['queryw'] = $this->sp['view']['query'];
         $this->sp['view']['queryw'] = str_replace("*", "%", $this->sp['view']['queryw']);
         $this->sp['view']['queryw'] = str_replace("?", "_", $this->sp['view']['queryw']);
         $this->sp['view']['queryw'] = addslashes($this->sp['view']['queryw']);
      }
      $this->sp['view']['query'] = htmlspecialchars($this->sp['view']['query']);

      // interface
      require_once("./include/tmos_lang_".$this->sp['cfg']['interfacelanguage'].".inc.php");
      $this->it = $tmos_viewer_it;
      // servers
      $this->sp['srv'] = array();
      $tmos_DB = new Ttmos_DB($this->sp['cfg']);
      if ($tmos_DB->check_lib()) {
         $this->status['dbconnect'] = $tmos_DB->check_connection();
         if ($this->status['dbconnect'] == "ok") {
            $tmos_DB->open();
            $this->sp['srv'] = $tmos_DB->query_assoc("select serverid, server, ip, game, login, password, last_update from tmos_servers ts order by serverc", "serverid");
            $tmos_DB->close();
            if (!$this->sp['srv'] || ($this->sp['view']['action'] != "servers" && !isset($this->sp['srv'][$this->sp['view']['sid']]))) {
               $this->sp['view']['action'] = "error_servers";
            }
         }
         else {
            $this->sp['view']['action'] = "error_dbconnection";
         }
      }
      else {
         $this->sp['view']['action'] = "error_dblib";
      }
      // check params
      if (!is_numeric($this->sp['view']['page'])) $this->sp['view']['page'] = 1;
      if ($this->sp['view']['stats'] != "a" && $this->sp['view']['stats'] != "c") $this->sp['view']['stats'] = "a";
      // show one server
      if (sizeof($this->sp['srv']) == 1 && !$this->sp['cfg']['showoneserver'] && $this->sp['view']['action'] == "servers") {
         $this->sp['view']['action'] = "monitoring";
         foreach($this->sp['srv'] as $sid=>$info)
            $this->sp['view']['sid'] = $sid;
      }
      if (sizeof($this->sp['srv']) == 1 && !$this->sp['cfg']['showoneserver']) $this->sp['view']['showmenuservers'] = false;
      else $this->sp['view']['showmenuservers'] = true;
      // show clans
      $this->sp['view']['showmenuclans'] = $this->sp['cfg']['showclans'];
      // show userbars
      $this->sp['view']['showuserbars'] = $this->sp['cfg']['showuserbars'];

     // params
     $this->get_params_tabs();
      switch ($this->sp['view']['action']) {
      case "servers":
         $this->get_params_servers();
         break;
      case "monitoring":
         $this->get_params_monitoring();
         break;
      case "players":
         $this->get_params_players();
         break;
      case "player":
         $this->get_params_player();
         break;
      case "tracks":
         $this->get_params_tracks();
         break;
      case "track":
         $this->get_params_track();
         break;
      case "clans":
         $this->get_params_clans();
         break;
      case "userbar":
         $this->get_params_userbars();
         break;
      }

      // menu
      if ($this->sp['view']['action'] == "servers")
         $this->sp['view']['showmenu'] = false;
      else
         $this->sp['view']['showmenu'] = true;
      // tabs
      if ($this->sp['view']['action'] == "servers" || strpos($this->sp['view']['action'], "error") !== false)
         $this->sp['view']['showtabs'] = false;
      else
         $this->sp['view']['showtabs'] = true;


   }

   function get_params_servers() {
      @set_time_limit(120);
      $tmos_ServersInfo = new Ttmos_ServersInfo();
      foreach($this->sp['srv'] as $sid=>$info) {
         $si = $tmos_ServersInfo->get_srv_info($info['ip'], $info['login'], $info['password'], $this->sp['cfg']['servertimeout']);
         if ($si['status'] == 0) {
            $si['game'] = $info['game'];
            $si['server'] = $info['server'];
            $this->sp['srv'][$sid] = $si;
         }
         else
            $this->sp['srv'][$sid]['status'] = $si['status'];
      }
   }

   function get_params_tabs() {
      $this->it['tab_lastxdays'] = str_replace("{0}", $this->sp['cfg']['timeperiod'], $this->it['tab_lastxdays']);
      if (!isset($this->sp['srv'][$this->sp['view']['sid']]['last_update']) || 
          $this->sp['srv'][$this->sp['view']['sid']]['last_update'] == 0) {
         $this->sp['tabs']['prev_date'] = "...";
         $this->sp['tabs']['curr_date'] = "...";
      }
      else if ($this->sp['srv'][$this->sp['view']['sid']]['last_update'] == 1) {
         $this->sp['tabs']['prev_date'] = "";
         $this->it['tab_dateseparator'] = "";
         $this->sp['tabs']['curr_date'] = $this->it['tab_statsupdate'];
      }
      else if ($this->sp['view']['stats'] == "a") {
         $this->sp['tabs']['prev_date'] = "...";
         $this->sp['tabs']['curr_date'] = date("j-m-Y", $this->sp['srv'][$this->sp['view']['sid']]['last_update']);
      }
      else {
         $this->sp['tabs']['prev_date'] = date("j-m-Y", strtotime("-{$this->sp['cfg']['timeperiod']} days", $this->sp['srv'][$this->sp['view']['sid']]['last_update']));
         $this->sp['tabs']['curr_date'] = date("j-m-Y", $this->sp['srv'][$this->sp['view']['sid']]['last_update']);
      }
   }

   function get_params_monitoring() {
      $sid = $this->sp['view']['sid'];
      $tmos_ServersInfo = new Ttmos_ServersInfo();
      $si = $tmos_ServersInfo->get_srv_info($this->sp['srv'][$sid]['ip'], $this->sp['srv'][$sid]['login'], $this->sp['srv'][$sid]['password'], $this->sp['cfg']['servertimeout']);
      if ($si['status'] != 0) {
         $this->sp['view']['action'] = "error_monitoring";
      }
      else {
         $si['game'] = $this->sp['srv'][$sid]['game'];
         $si['server'] = $this->sp['srv'][$sid]['server'];
         $tmos_DB = new Ttmos_DB($this->sp['cfg']);
         $tmos_DB->open();
         $trackid = $tmos_DB->query("select trackid, nblaps from tmos_tracks where serverid=$sid and uid='{$si['track']['uid']}'");
         if (!$trackid || $trackid['count'] == 0)
            $si['track']['trackid'] = -1;
         else {
            $si['track']['trackid'] = $trackid[0]['trackid'];
            $si['track']['nblaps_t'] = $trackid[0]['nblaps'];
            $besttime = $tmos_DB->query("select p.player, v.playerid, v.bestresult from tmos_view v, tmos_players p where v.serverid = $sid and v.stats = '{$this->sp['view']['stats']}' and v.trackid = '{$si['track']['trackid']}' and v.rank = 1 and p.playerid = v.playerid");
            if (!$besttime || $besttime['count'] == 0) {
               $si['track']['besttime'] = "-";
               $si['track']['bestplayer'] = "-";
               $si['track']['bestplayerid'] = -1;
            }
            else {
               $si['track']['besttime'] = $besttime[0]['bestresult'];
               $si['track']['bestplayer'] = $besttime[0]['player'];
               $si['track']['bestplayerid'] = $besttime[0]['playerid'];
            }
         }
         for ($i = 0; $i < $si['players']['count']; $i++) {
            if (preg_match("/(.+)\/\d+\.\d+\.\d+\.\d+:\d+/u", $si['players'][$i]['account'], $matches)) {
               $si['players'][$i]['account'] = name_clear($matches[1]);
            }
            $playerid = $tmos_DB->query("select playerid from tmos_players where serverid = $sid and account = '".addslashes($si['players'][$i]['account'])."'");
            if(!$playerid || $playerid['count'] == 0)
               $si['players'][$i]['playerid'] = -1;
            else 
               $si['players'][$i]['playerid'] = $playerid[0]['playerid'];
         }
         $tmos_DB->close();
         $this->sp['data'] = $si;
      }
   }

   function get_params_players() {
      // check params
      if ($this->sp['view']['sort'] == "default") $this->sp['view']['sort'] = "score";
      if ($this->sp['view']['dir'] == "default") $this->sp['view']['dir'] = "desc";
      $true_data = array("asc"=>true, "desc"=>true);
      if (!isset($true_data[$this->sp['view']['dir']])) $this->sp['view']['dir'] = "desc";
      $true_data = array("playerc"=>true, "score"=>true, "awards"=>true);
      if (!isset($true_data[$this->sp['view']['sort']])) {
         $this->sp['view']['sort'] = "score";
         $this->sp['view']['dir'] = "desc";
      }
      // db
      $tmos_DB = new Ttmos_DB($this->sp['cfg']);
      $tmos_DB->open();
      // data
      ($this->sp['view']['stats'] == "a") ? $q_stats = "" : $q_stats = "_c";
      ($this->sp['cfg']['minscore'] <= 0) ? $q_score = "" : $q_score = " and score$q_stats >= {$this->sp['cfg']['minscore']}";
      ($this->sp['view']['query'] == "*") ? $q_find = ""  : $q_find = " and playerc like '{$this->sp['view']['queryw']}'";
      ($this->sp['view']['sort'] != "score") ? $q_sort = "{$this->sp['view']['sort']} {$this->sp['view']['dir']}" : $q_sort = "score$q_stats {$this->sp['view']['dir']}";
      $this->sp['data'] = $tmos_DB->query_selectpage("select SQL_CALC_FOUND_ROWS playerid, player, (am$q_stats+gm$q_stats+sm$q_stats+bm$q_stats) as awards, round(score$q_stats, 2) as score from tmos_players where serverid = {$this->sp['view']['sid']}$q_score$q_find order by $q_sort", $this->sp['view']['page'], $this->sp['cfg']['recperpage']);
      // view
      $qryres = $tmos_DB->query("select FOUND_ROWS() as tp");
      $this->sp['view']['totalpages'] = ceil($qryres[0]['tp']/$this->sp['cfg']['recperpage']);
      // inf
      $this->sp['inf']['servername'] = $this->sp['srv'][$this->sp['view']['sid']]['server'];
      $this->sp['inf']['servergame'] = $this->sp['srv'][$this->sp['view']['sid']]['game'];
      if ($this->sp['srv'][$this->sp['view']['sid']]['last_update'] == 0 ||
          $this->sp['srv'][$this->sp['view']['sid']]['last_update'] == 1)
         $this->sp['inf']['lastupdate'] = "-";
      else
         $this->sp['inf']['lastupdate'] = date("j-m-Y H:i", $this->sp['srv'][$this->sp['view']['sid']]['last_update']);
      $qryres = $tmos_DB->query("select count(*) as tp, sum(am$q_stats+gm$q_stats+sm$q_stats+bm$q_stats) as ta from tmos_players where serverid = {$this->sp['view']['sid']}$q_score");
      if ($qryres['count'] == 0 || $qryres[0]['tp'] == 0) {
         $this->sp['inf']['totalplayers'] = '-';
         $this->sp['inf']['totalawards'] = '-';
      }
      else {
         $this->sp['inf']['totalplayers'] = $qryres[0]['tp'];
         $this->sp['inf']['totalawards'] = $qryres[0]['ta'];
      }
      // db
      $tmos_DB->close();
   }

   function get_params_player() {
      // check params
      if ($this->sp['view']['sort'] == "default") $this->sp['view']['sort'] = "trackc";
      if ($this->sp['view']['dir'] == "default") $this->sp['view']['dir'] = "asc";
      $true_data = array("asc"=>true, "desc"=>true);
      if (!isset($true_data[$this->sp['view']['dir']])) $this->sp['view']['dir'] = "asc";
      $true_data = array("trackc"=>true, "rank"=>true, "award"=>true, "ts"=>true);
      if (!isset($true_data[$this->sp['view']['sort']])) {
         $this->sp['view']['sort'] = "trackc";
         $this->sp['view']['dir'] = "asc";
      }
      // db
      $tmos_DB = new Ttmos_DB($this->sp['cfg']);
      $tmos_DB->open();
      // data
      $this->sp['data'] = $tmos_DB->query_selectpage("select SQL_CALC_FOUND_ROWS tv.trackid, tv.bestresult, tv.award, abs(tv.rank) as rank, tv.totalresults, tv.ts, tt.track from tmos_view tv, tmos_tracks tt where tv.serverid = {$this->sp['view']['sid']} and tv.stats = '{$this->sp['view']['stats']}' and tv.playerid = '{$this->sp['view']['pid']}' and tv.serverid = tt.serverid and tv.trackid = tt.trackid order by {$this->sp['view']['sort']} {$this->sp['view']['dir']}", $this->sp['view']['page'], $this->sp['cfg']['recperpage']);
      // view
      $qryres = $tmos_DB->query("select FOUND_ROWS() as tp");
      $this->sp['view']['totalpages'] = ceil($qryres[0]['tp']/$this->sp['cfg']['recperpage']);
      // inf
      ($this->sp['view']['stats'] == "a") ? $q_stats = "" : $q_stats = "_c";
      $qryres = $tmos_DB->query("select player, account, am$q_stats as am, gm$q_stats as gm, sm$q_stats as sm, bm$q_stats as bm, score$q_stats as score, lastonline, aliases from tmos_players where serverid = {$this->sp['view']['sid']} and playerid = '{$this->sp['view']['pid']}'");
      if ($qryres['count'] == 0) { // anti-hack
          $this->sp['inf']['player'] = "-";
          $this->sp['inf']['account'] = "-";
          $this->sp['inf']['rank'] = "-";
          $this->sp['inf']['am'] = "-";
          $this->sp['inf']['gm'] = "-";
          $this->sp['inf']['sm'] = "-";
          $this->sp['inf']['bm'] = "-";
          $this->sp['inf']['score'] = "-";
          $this->sp['inf']['lastonline'] = '-';
          $this->sp['inf']['aliases'] = "-";
      }
      else {
         $this->sp['inf'] = $qryres[0];
         $this->sp['inf']['account'] = str_replace(array("/","\\",":","*","?","<",">",'"',"|"), "_", $this->sp['inf']['account']);
         $qryres = $tmos_DB->query("select count(playerid) as rank from tmos_players where serverid = {$this->sp['view']['sid']} and score$q_stats > {$this->sp['inf']['score']}");
         $this->sp['inf']['rank'] = $qryres[0]['rank'] + 1;
         $this->sp['inf']['score'] = round($this->sp['inf']['score'], 2);
      }
      $this->sp['inf']['servername'] = $this->sp['srv'][$this->sp['view']['sid']]['server'];
      $this->sp['inf']['servergame'] = $this->sp['srv'][$this->sp['view']['sid']]['game'];
      // db
      $tmos_DB->close();
   }

   function get_params_tracks() {
      // check params
      if ($this->sp['view']['sort'] == "default") $this->sp['view']['sort'] = "trackc";
      if ($this->sp['view']['dir'] == "default") $this->sp['view']['dir'] = "asc";
      $true_data = array("asc"=>true, "desc"=>true);
      if (!isset($true_data[$this->sp['view']['dir']])) $this->sp['view']['dir'] = "asc";
      $true_data = array("trackc"=>true, "author"=>true, "bestresult"=>true, "playerc"=>true);
      if (!isset($true_data[$this->sp['view']['sort']])) {
         $this->sp['view']['sort'] = "trackc";
         $this->sp['view']['dir'] = "asc";
      }
      // db
      $tmos_DB = new Ttmos_DB($this->sp['cfg']);
      $tmos_DB->open();
      // data
      if ($this->sp['view']['query'] == "*")
         $q_find = "";
      else
         $q_find = " and tt.trackc like '{$this->sp['view']['queryw']}'";
      $this->sp['data'] = $tmos_DB->query_selectpage("select SQL_CALC_FOUND_ROWS tv.trackid, tv.bestresult, tt.track, tt.author, tp.player, tp.playerid from tmos_view tv, tmos_tracks tt, tmos_players tp where tv.serverid = {$this->sp['view']['sid']} and tv.stats = '{$this->sp['view']['stats']}' and tv.rank = 1 and tv.serverid = tt.serverid and tv.trackid = tt.trackid and tv.serverid = tp.serverid and tv.playerid = tp.playerid$q_find order by {$this->sp['view']['sort']} {$this->sp['view']['dir']}, trackc asc", $this->sp['view']['page'], $this->sp['cfg']['recperpage']);
      // view
      $qryres = $tmos_DB->query("select FOUND_ROWS() as tp");
      $this->sp['view']['totalpages'] = ceil($qryres[0]['tp']/$this->sp['cfg']['recperpage']);
      // inf
      if ($this->sp['view']['stats'] == "a")
         $q_stats = "x";
      else
         $q_stats = "y";
      $qryres = $tmos_DB->query("select trackid as tt, playerid as ta from tmos_view where serverid = {$this->sp['view']['sid']} and stats = '$q_stats'");
      if ($qryres['count'] != 0) {
         $this->sp['inf']['totaltracks'] = $qryres[0]['tt'];
         $this->sp['inf']['totalauthors'] = $qryres[0]['ta'];
      }
      else {
         $this->sp['inf']['totaltracks'] = '-';
         $this->sp['inf']['totalauthors'] = '-';
      }
      $this->sp['inf']['servername'] = $this->sp['srv'][$this->sp['view']['sid']]['server'];
      $this->sp['inf']['servergame'] = $this->sp['srv'][$this->sp['view']['sid']]['game'];
      // db
      $tmos_DB->close();
   }

   function get_params_track() {
      // check params
      if ($this->sp['view']['sort'] == "default") $this->sp['view']['sort'] = "bestresult";
      if ($this->sp['view']['dir'] == "default") $this->sp['view']['dir'] = "asc";
      $true_data = array("asc"=>true, "desc"=>true);
      if (!isset($true_data[$this->sp['view']['dir']])) $this->sp['view']['dir'] = "asc";
      $true_data = array("playerc"=>true, "bestresult"=>true, "ts"=>true);
      if (!isset($true_data[$this->sp['view']['sort']])) {
         $this->sp['view']['sort'] = "bestresult";
         $this->sp['view']['dir'] = "asc";
      }
      // db
      $tmos_DB = new Ttmos_DB($this->sp['cfg']);
      $tmos_DB->open();
      // data
      ($this->sp['view']['stats'] == "a") ? $q_stats = "" : $q_stats = "_c";
      $this->sp['data'] = $tmos_DB->query_selectpage("select SQL_CALC_FOUND_ROWS tv.playerid, tv.bestresult, tv.award, tv.ts, tp.player, tp.score$q_stats as score from tmos_view tv, tmos_players tp where tv.serverid = {$this->sp['view']['sid']} and tv.stats = '{$this->sp['view']['stats']}' and tv.trackid = '{$this->sp['view']['tid']}' and tv.serverid = tp.serverid and tv.playerid = tp.playerid order by {$this->sp['view']['sort']} {$this->sp['view']['dir']}", $this->sp['view']['page'], $this->sp['cfg']['recperpage']);
      // view
      $qryres = $tmos_DB->query("select FOUND_ROWS() as tp");
      $this->sp['view']['totalpages'] = ceil($qryres[0]['tp']/$this->sp['cfg']['recperpage']);
      // inf
      $qryres = $tmos_DB->query("select uid, track, author, envir, nblaps, bronze, silver, gold, authortime from tmos_tracks where serverid = {$this->sp['view']['sid']} and trackid = '{$this->sp['view']['tid']}'");
      if ($qryres['count'] == 0) { // anti-hack
          $this->sp['inf']['uid'] = "-";
          $this->sp['inf']['track'] = "-";
          $this->sp['inf']['author'] = "-";
          $this->sp['inf']['envir'] = "-";
          $this->sp['inf']['nblaps'] = 0;
          $this->sp['inf']['bronze'] = "-";
          $this->sp['inf']['silver'] = "-";
          $this->sp['inf']['gold'] = "-";
          $this->sp['inf']['authortime'] = "-";
      }
      else
         $this->sp['inf'] = $qryres[0];
      $this->sp['inf']['servername'] = $this->sp['srv'][$this->sp['view']['sid']]['server'];
      $this->sp['inf']['servergame'] = $this->sp['srv'][$this->sp['view']['sid']]['game'];
      $qryres = $tmos_DB->query("select bestresult as br from tmos_view where serverid = {$this->sp['view']['sid']} and stats = '{$this->sp['view']['stats']}' and trackid = '{$this->sp['view']['tid']}' and rank = 1");
      if ($qryres['count'] != 0)
         $this->sp['inf']['bestresult'] = $qryres[0]['br'];
      else
         $this->sp['inf']['bestresult'] = "00:00:00.00";
      // db
      $tmos_DB->close();
   }

   function get_params_clans() {
      // check params
      if ($this->sp['view']['sort'] == "default") $this->sp['view']['sort'] = "score";
      if ($this->sp['view']['dir'] == "default") $this->sp['view']['dir'] = "desc";
      $true_data = array("asc"=>true, "desc"=>true);
      if (!isset($true_data[$this->sp['view']['dir']])) $this->sp['view']['dir'] = "asc";
      $true_data = array("clan"=>true, "score"=>true);
      if (!isset($true_data[$this->sp['view']['sort']])) {
         $this->sp['view']['sort'] = "score";
         $this->sp['view']['dir'] = "desc";
      }
      // db
      $tmos_DB = new Ttmos_DB($this->sp['cfg']);
      $tmos_DB->open();
      // data
      ($this->sp['view']['stats'] == "a") ? $q_stats = "" : $q_stats = "_c";
      ($this->sp['view']['sort'] == "clan") ? $q_sort = "clanc {$this->sp['view']['dir']}" : $q_sort = "score$q_stats {$this->sp['view']['dir']}";
      ($this->sp['view']['sort'] == "clan") ? $q_sort_m = "playerc {$this->sp['view']['dir']}" : $q_sort_m = "score$q_stats {$this->sp['view']['dir']}";
      $this->sp['data'] = $tmos_DB->query_selectpage("select SQL_CALC_FOUND_ROWS clanid, clanc, description, members, round(score$q_stats, 2) as score from tmos_clans where serverid = {$this->sp['view']['sid']} order by $q_sort", $this->sp['view']['page'], $this->sp['cfg']['recperpage']);
      // view
      $qryres = $tmos_DB->query("select FOUND_ROWS() as tp");
      $this->sp['view']['totalpages'] = ceil($qryres[0]['tp']/$this->sp['cfg']['recperpage']);
      // data
      for ($i = 0; $i < $this->sp['data']['count']; $i++) {
         $this->sp['data'][$i]['members'] = $tmos_DB->query("select playerid, player, round(score$q_stats, 2) as score from tmos_players where serverid = {$this->sp['view']['sid']} and playerid in ({$this->sp['data'][$i]['members']}) order by $q_sort_m");
      }
      // inf
      $this->sp['inf']['servername'] = $this->sp['srv'][$this->sp['view']['sid']]['server'];
      // db
      $tmos_DB->close();
   }

   function get_params_userbars() {
      // data
      if (!function_exists('imagepng')) {
         $this->sp['view']['action'] = "error_gd";
      }
      else {
         $this->sp['data'] = userbars_load();
         if ($this->sp['data']['count'] == 0) {
            $this->sp['view']['action'] = "error_ub0";
         }
         else {
            asort($this->sp['data']);
            $this->sp['inf']['servergame'] = $this->sp['srv'][$this->sp['view']['sid']]['game'];
            $host = $_SERVER['HTTP_HOST'];
            $uri = rtrim($_SERVER['PHP_SELF'], "\\/");
            $uri = dirname($uri);
            if($uri == '\\' || $uri == '/') $uri = '';
            $this->sp['inf']['link'] = "http://$host$uri/tmos_userbar.php".PS_UB_QUERY_DELIM;
         }      
      }
   }

   function get_content() {
      $this->content = get_header($this->sp['cfg'], $this->it, $this->sp['view']);
      $this->content .= get_tabs_content($this->it, $this->sp['view'], $this->sp['tabs']);
      switch ($this->sp['view']['action']) {
      case "servers":
         $this->content .= get_servlist_content($this->sp['cfg'], $this->it, $this->sp['view'], $this->sp['srv']);
         break;
      case "monitoring":
         $this->content .= get_monitoring_content($this->sp['cfg'], $this->it, $this->sp['view'], $this->sp['data']);
         break;
      case "players":
         $this->content .= get_players_content($this->sp['cfg'], $this->it, $this->sp['view'], $this->sp['inf'], $this->sp['data']);
         break;
      case "player":
         $this->content .= get_player_content($this->sp['cfg'], $this->it, $this->sp['view'], $this->sp['inf'], $this->sp['data']);
         break;
      case "tracks":
         $this->content .= get_tracks_content($this->sp['cfg'], $this->it, $this->sp['view'], $this->sp['inf'], $this->sp['data']);
         break;
      case "track":
         $this->content .= get_track_content($this->sp['cfg'], $this->it, $this->sp['view'], $this->sp['inf'], $this->sp['data']);
         break;
      case "clans":
         $this->content .= get_clans_content($this->sp['cfg'], $this->it, $this->sp['view'], $this->sp['inf'], $this->sp['data']);
         break;
      case "userbar":
         $this->content .= get_userbar_content($this->it, $this->sp['view'], $this->sp['inf'], $this->sp['data']);
         break;
      default:
         $this->content .= get_error_content($this->it, $this->sp['view']['action']);
         break;
      }
      $this->content .= get_footer();
   }

   function get_content_cache() {
      $this->content = cache_file_read(md5($_SERVER['REQUEST_URI']));
      if ($this->content == "") 
         return false;
      else
         return true;
   }

   function write_content_cache() {
      switch ($this->sp['cfg']['htmlcache']) {
      case "all":
         if ($this->sp['view']['action'] == "servers" ||
             $this->sp['view']['action'] == "monitoring" ||
             $this->sp['view']['action'] == "userbar" ||
             strpos($this->sp['view']['action'], "error") !== false ||
             $this->sp['view']['query'] != "*")
            $save = false;
         else
            $save = true;
         break;
      case "main":
         if ($this->sp['view']['action'] == "servers" ||
             $this->sp['view']['action'] == "monitoring" ||
             $this->sp['view']['action'] == "player" ||
             $this->sp['view']['action'] == "track" ||
             $this->sp['view']['action'] == "userbar" ||
             strpos($this->sp['view']['action'], "error") !== false ||
             $this->sp['view']['query'] != "*")
            $save = false;
         else
            $save = true;
         break;
      default:
         $save = false;
         break;
      }
      if ($save) 
         cache_file_write(md5($_SERVER['REQUEST_URI']), $this->content);
   }

   function show_content() {
      header('Content-Type: text/html; charset=UTF-8');
      if ($this->sp['cfg']['gzipcompress'])
         gzip_out($this->content);
      else
         echo $this->content;
   }

}

$sc = new Ttm_StatsContent();
if (!$sc->get_content_cache()) {
   $sc->get_params();
   $sc->get_content();
   $sc->write_content_cache();
}
$sc->show_content();
$sc->clear();
?>